// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'app.core', 'app.comp', 'ngMaterial', 'ngCordova', 'ngFacebook',
        'mdRangeSlider', 'ngCordovaOauth', 'ionic.rating'
    ])
    .run(function($ionicPlatform, AppInit, AppUtil) {
        $ionicPlatform.ready(function() {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }

            (function(d, s, id) {
                var js, fjs = d.getElementsByTagName(s)[0];
                if (d.getElementById(id)) {
                    return;
                }
                js = d.createElement(s);
                js.id = id;
                js.src = "https://connect.facebook.net/en_US/sdk.js";
                fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));

            if (window.cordova) {
                // $cordovaNativeAudio.preloadComplex('notify_sound', 'assets/sound/nsound.mp3',1, 1, 0,
                //     function(msg) {
                //         console.log('error: ' + msg);
                //     },
                //     function(msg) {
                //         console.log('error: ' + msg);
                //     });
            }

            if (window.Connection && window.cordova) {

                if (navigator.connection.type == Connection.NONE) {

                    AppUtil.confirm('Sorry, no Internet connectivity detected. Please reconnect and try again.',
                        'No Internet Connection').then(function() {
                        ionic.Platform.exitApp();
                    }, function() {
                        ionic.Platform.exitApp();
                    });
                } else {

                    cordova.plugins.diagnostic.isLocationEnabled(function(enabled) {
                        if (enabled) {

                            cordova.plugins.diagnostic.requestRuntimePermissions(function(statuses) {
                                for (var permission in statuses) {
                                    switch (statuses[permission]) {
                                        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                                            console.log("Permission granted to use " + permission);
                                            break;
                                        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                                            console.log("Permission to use " + permission + " has not been requested yet");
                                            break;
                                        case cordova.plugins.diagnostic.permissionStatus.DENIED:
                                            console.log("Permission denied to use " + permission + " - ask again?");
                                            break;
                                        case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                                            console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                                            break;
                                    }
                                }
                            }, function(error) {
                                console.error("The following error occurred: " + error);
                            }, [
                                cordova.plugins.diagnostic.permission.ACCESS_FINE_LOCATION,
                                cordova.plugins.diagnostic.permission.ACCESS_COARSE_LOCATION,
                                cordova.plugins.diagnostic.permission.CAMERA,
                                cordova.plugins.diagnostic.permission.WRITE_EXTERNAL_STORAGE,
                                cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE
                            ]);

                            AppInit.init();

                        } else {
                            AppUtil.confirm("Your GPS is Disabled. You can not use Zeenka without Location." +
                                " Would you like to enable ? ", "Enable GPS").then(function() {
                                cordova.plugins.diagnostic.switchToLocationSettings();
                                ionic.Platform.exitApp();
                            }, function() {
                                ionic.Platform.exitApp();
                            });
                        }
                    }, function(error) {
                        ionic.Platform.exitApp();
                    });

                }

            } else {
                AppInit.init();
            }

            if (navigator && navigator.splashscreen)
                navigator.splashscreen.hide();
        });
    });

angular.module('app.comp', 
	['app.comp.chatusers',
	 'app.comp.imageviewer',
	 'app.comp.imagerate',
	 'app.comp.profile',
	 'app.comp.nearby',
	 'app.comp.like',
	 'app.comp.visitor',
	 'app.comp.favourite',
	 'app.comp.invite',
	 'app.comp.chat',
	 'app.comp.zeenking',
	 'app.comp.user',
	 'app.comp.editprofile',
	 'app.comp.filter',
	 'app.comp.about',
	 'app.comp.privacy',
	 'app.comp.termcondition',
	 'app.comp.feedback',
	 'app.comp.helpcenter',
	 'app.comp.match',
	 'app.comp.unmatch',
	 'app.comp.order',
	 'app.comp.delete',
	 'app.comp.tips',
	 'app.comp.ques',
	 'app.comp.payment']);


angular.module('app.core', ['app.core.login',
    'app.core.appconf',
    'app.core.datasync',
    'app.core.db',
    'app.core.appinit',
    'app.core.service',
    'app.core.setting',
    'app.core.util',
    'utf8-base64',
    'app.core.fs',
    'app.core.zlogin',
    'app.core.signup',
    'app.core.twitter',
    'app.core.fnotification',
    'app.core.geolocation',
    'app.core.refdata',
    'app.core.otpvarify',
    'app.core.offline',
    'app.core.paypal',
    'app.core.fortumo',
    'app.core.razorpay'
]);

angular.module('app.comp.about', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('about', {
            url: '/about',
            cache: false,
            templateUrl: 'app/comp/about/about.html',
            controller: 'AboutCtrl'
        });
    });

angular.module('app.comp.chat', ['btford.socket-io', 'ngSanitize'])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('chat', {
            url: '/chat',
            cache : false,
            templateUrl: 'app/comp/chat/chat.html',
            params: {
                user : '',
                hasinstance : false
            }
        });
    });

angular.module('app.comp.chatusers', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.chatusers', {
            url: '/chatusers',
            cache : false,
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/chatusers/chatusers.html',
                    controller: 'ChatUsersCtrl'
                }
            }
        });
    });

angular.module('app.comp.delete', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('delete', {
            url: '/delete',
            cache : false,
            templateUrl: 'app/comp/delete/delete.html',
            controller: 'DeleteCtrl'
        });
    });

angular.module('app.comp.editprofile', ['ngImgCrop'])
    .config(function($stateProvider, $urlRouterProvider) {

        $stateProvider
            .state('personalProfile', {
                templateUrl: 'app/comp/edit-profile/personal-info.html',
                controller: 'PersonalInfoCtrl',
                cache: false
            }).state('additionalProfile', {
                templateUrl: 'app/comp/edit-profile/additional-info.html',
                controller: 'AddtionalInfoCtrl',
                cache: false
            }).state('userimages', {
                templateUrl: 'app/comp/edit-profile/image-grid.html',
                controller: 'ImageGridCtrl',
                cache: false
            }).state('uploadimages', {
                templateUrl: 'app/comp/edit-profile/image-upload.html',
                cache: false,
                params: {
                    source: 1,
                    firstpic: false
                }
            });

    });

angular.module('app.comp.favourite', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.favourite', {
            url: '/favourite',
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/favourite/favourite.html',
                    controller: 'FavouriteCtrl'
                }
            }
        });
    });

angular.module('app.comp.feedback', [])
    .config(function($stateProvider) {

        $stateProvider.state('feedback', {
            url: '/feedback',
            cache: false,
            templateUrl: 'app/comp/feedback/feedback.html'
        });
    });

angular.module('app.comp.filter', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('filter', {
            url: '/filter',
            cache: false,
            templateUrl: 'app/comp/filter/filter.html',
            controller: 'FilterCtrl'
        });
    });

angular.module('app.comp.helpcenter', [])
    .config(function($stateProvider) {

        $stateProvider.state('helpcenter', {
            url: '/helpcenter',
            cache: false,
            templateUrl: 'app/comp/helpcenter/helpcenter.html'
        });
    });

angular
    .module('app.comp.imagerate', [])
    .config(function($stateProvider, $urlRouterProvider) {

        $stateProvider.state('rateimages', {
            url: "/rateimages",
            cache: false,
            templateUrl: "app/comp/imagerate/imagerate.html",
            controller: 'ImageRateCtrl'
        });
    });

angular
    .module('app.comp.imageviewer', [])
    .config(function($stateProvider, $urlRouterProvider) {

        $stateProvider.state('previewimages', {
            url: "/previewimages",
            cache: false,
            templateUrl: "app/comp/imageviewer/imageviewer.html",
            controller: 'ImageViewerCtrl',
            params: {
                images: "",
                isDeletable: false, 
                selected : 0
            }
        });
    });

angular.module('app.comp.invite', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.invite', {
            url: '/invite',
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/invite/invite.html',
                    controller: 'InviteCtrl'
                }
                // ,
                // 'fabContent': {
                //     template: '<button id="fab-gallery" class="button button-fab button-fab-top-right expanded button-energized-900 drop"><i class="icon ion-heart"></i></button>',
                //     controller: function($timeout) {
                //         $timeout(function() {
                //             document.getElementById('fab-gallery').classList.toggle('on');
                //         }, 600);
                //     }
                // }
            }
        });
    });

angular.module('app.comp.like', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.like', {
            url: '/like',
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/like/like.html',
                    controller: 'LikeCtrl'
                }
            }
        });
    });

angular.module('app.comp.match', [])
    .config(function() {

    });

angular.module('app.comp.nearby', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.nearby', {
            url: '/nearby',
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/nearby/nearby.html',
                    controller: 'NearByCtrl'
                }
            }
        });
    });

(function() {
    'use strict';

    angular
        .module('app.comp.order', [])
        .config(function($stateProvider) {
            $stateProvider.state('order', {
                url: '/order',
                templateUrl: 'app/comp/order/order.html',
                params: {
                    qty: 0
                }
            });
        });
})();

(function(){
    angular.module('app.comp.payment', []);
})();

angular.module('app.comp.privacy', [])
    .config(function($stateProvider) {

        $stateProvider.state('privacy', {
            url: '/privacy',
            cache: false,
            templateUrl: 'app/comp/privacy/privacy.html'
        });
    });

angular.module('app.comp.profile', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider
            .state('app.profile', {
                url: '/profile',
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'app/comp/profile/profile.html',
                        controller: 'ProfileCtrl'
                    }
                }
            });
    });

angular.module('app.comp.ques', [])
    .config(function($stateProvider) {

        $stateProvider.state('ques', {
            url: '/ques',
            cache: false,
            templateUrl: 'app/comp/ques/ques.html'
        });
    });

angular.module('app.comp.termcondition', [])
    .config(function($stateProvider) {

        $stateProvider.state('termcondition', {
            url: '/termcondition',
            cache: false,
            templateUrl: 'app/comp/termcondition/termcondition.html'
        });
    });

angular.module('app.comp.tips', [])
    .config(function() {

    });

angular.module('app.comp.unmatch', [])
    .config(function($stateProvider) {

        $stateProvider
            .state('unmatch', {
                url: '/unmatch',
                cache: false,
                templateUrl: 'app/comp/unmatch/unmatch.html',
                params: {
                    isBlocked: 'N',
                    user_id: 0
                }
            })
            .state('block', {
                url: '/block',
                cache: false,
                templateUrl: 'app/comp/unmatch/block.html',
                controller: 'BlockCtrl'
            });
    });

angular.module('app.comp.user', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider
            .state('app.user', {
                url: '/user:user',
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'app/comp/user/user.html',
                        controller: 'UserCtrl'
                    }
                }
            });
    });

angular.module('app.comp.visitor', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('app.visitor', {
            url: '/visitor',
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: 'app/comp/visitor/visitor.html',
                    controller: 'VisitorCtrl'
                }
            }
        });
    });

angular.module('app.comp.zeenking', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider
            .state('app.zeenking', {
                url: '/zeenking',
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'app/comp/zeenking/zeenking.html',
                        controller: 'ZeenkingCtrl'
                    }
                }
            });
    });

angular.module('app.core.razorpay', [])
    .config(function($stateProvider) {

        
    });

angular.module('app.core.refdata',[]);
(function() {
    'use strict';

    angular
        .module('app.core.appconf', 
            []);
})();
(function() {
    'use strict';

    angular
        .module('app.core.appinit', 
            []);
})();

(function() {
    'use strict';

    angular
        .module('app.core.datasync', 
            []);
})();
(function() {
    'use strict';

    angular
        .module('app.core.db', 
            []);
})();

(function() {
    'use strict';

    angular
        .module('app.core.fs', 
            []);
})();

(function() {
    'use strict';
    angular
        .module('app.core.fnotification', ['ionic.cloud']);
})();

angular.module('app.core.fortumo', [])
    .config(function($stateProvider) {

        $stateProvider.state('paybymobile', {
            url: '/paybymobile',
            params:{
            	cuid:0,
            	tc_id:0,
            	tc_amount:0
            },
            cache: false,
            templateUrl: 'app/core/fortumo/fortumo.html'
        });
    });

(function(){
	'use strct';

	angular
		.module('app.core.geolocation', []);
})();
angular.module('app.core.login', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider
            .state('login', {
                url: '/login',
                templateUrl: 'app/core/login/login.html',
                controller: 'LoginCtrl',
                params: {
                    forcereload: false
                }
            }).state('login-mobile', {
                url: '/login-mobile',
                templateUrl: 'app/core/login/login-mobile.html',
                controller: 'LoginCtrl',
                params: {
                    forcereload: false
                }
            });
    });

angular.module('app.core.menu',[]);
(function() {
    'use strict';
    angular
        .module('app.core.notification', []);
})();

angular.module('app.core.offline', [])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $stateProvider.state('offline', {
            url: '/offline',
            cache: true,
            templateUrl: 'app/core/offline/offline.html',
            controller: 'OfflineCtrl'
        });
    });

(function() {
    'use strict';

    angular
        .module('app.core.otpvarify', [])
        .config(function($stateProvider) {
            $stateProvider.state('smsvarify', {
                url: '/smsvarify',
                cache: false,
                templateUrl: 'app/core/otpvarification/otpverify.html'
            }).state('otpvarify', {
                url: '/otpvarify',
                cache: false,
                params: {
                    phone:"",
                    previus:undefined
                },
                templateUrl: 'app/core/otpvarification/otpverify2.html'
            });
        });
})();

(function() {
    'use strict';

    angular
        .module('app.core.service', 
            []);
})();
(function() {
    'use strict';

    angular
        .module('app.core.setting', [])
        .config(function($stateProvider, $urlRouterProvider) {

            $stateProvider.state('appSetting', {
                cache:false,
                url: '/appSetting',
                templateUrl: 'app/core/setting/setting.html',
                controller: 'SysSettingCtrl'
            });

        });
})();

angular.module('app.core.signup', ['ionic-datepicker'])
    .config(function($stateProvider, $urlRouterProvider) {

        $stateProvider
            .state('signup', {
                url: '/signup',
                templateUrl: 'app/core/signup/signup.html',
                controller: 'SignupCtrl'
            }).state('signup.1', {
                // loaded into ui-view of parent's template
                templateUrl: 'app/core/signup/signup_first.html'
            })
            .state('signup.2', {
                // loaded into ui-view of parent's template
                templateUrl: 'app/core/signup/signup_second.html'
            }).state('signup.3', {
                // loaded into ui-view of parent's template
                templateUrl: 'app/core/signup/signup_third.html'
            }).state('signup.4', {
                // loaded into ui-view of parent's template
                templateUrl: 'app/core/signup/signup_fourth.html'
            });

    })
    .directive('ionSelect', function() {
        'use strict';
        return {
            restrict: 'EAC',
            scope: {
                label: '@',
                labelField: '@',
                provider: '=',
                ngModel: '=?',
                ngValue: '=?',
                ngRequired: '=?',
                isMandatory: '=?'
            },
            require: '?ngModel',
            transclude: false,
            replace: false,
            template: '<div class="selectContainer">' + '<label class="item item-input item-stacked-label">' +
                '<span class="lable-color"><b> {{label}}</b></span>' + '<div class="item item-input-inset">' +
                '<label class="item-input-wrapper">'+
                '<input id="filtro" name="filtro" type="search" ng-required="isRequired()"  ng-model="ngModel" ng-value="ngValue" ng-keydown="onKeyDown()"/>' +
                '</label> </div>' + '</label>' +
                '<div class="optionList" ng-show="showHide">' + '<ion-scroll>' +
                '<ul class="list">' +
                '<li class="item" ng-click="selecionar(item)" ng-repeat="item in provider | filter:ngModel">{{item}}</li>' +
                '</ul>' + '</ion-scroll>' + '</div>' + '</div>',
            link: function(scope, element, attrs, ngModel) {
                scope.ngValue = scope.ngValue !== undefined ? scope.ngValue : 'item';

                scope.selecionar = function(item) {
                    ngModel.$setViewValue(item);
                    scope.showHide = false;
                };

                scope.isRequired = function() {
                    return scope.ngRequired !== undefined ? scope.ngRequired : false;
                }

                element.bind('click', function() {
                    element.find('input').focus();
                });

                scope.openf = function() {

                    scope.ngModel = "";
                    return scope.showHide = !scope.showHide;
                };

                scope.onKeyDown = function() {
                    scope.showHide = true;
                    if (!scope.ngModel) {
                        scope.showHide = false;
                    }
                }

                scope.$watch('ngModel', function(newValue) {
                    if (newValue)
                        element.find('input').val(newValue);

                });
            },
        };
    });

angular.module('app.core.twitter', ['ngCordovaOauth'])
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
        $stateProvider.state('twitterMsg', {
            url: '/twitterMsg',
            templateUrl: 'app/core/twitter/twitter.html',
            controller: 'TwitterMsgCtrl'
        });
    }).constant('twitConst', {
        'cKey': "oyWo6RXrP7x5a1U4vqyFO5LJ8",
        'cSecret': "ryc59WAWdtX73WQjJpUjN0yi2EmWeGhDPly6C7nfLY4E5ELiD4",
        'userInfoURL': "https://api.twitter.com/1.1/users/show.json",
        'frdsListURL': "https://api.twitter.com/1.1/friends/list.json",
        'directmsgURL': "https://api.twitter.com/1.1/direct_messages/new.json"
    });

(function() {
    'use strict';

    angular
        .module('app.core.util', 
            []);
})();
(function() {
    'use strict';

    angular
        .module('app.core.zlogin', ['app.core.facebook']);
})();

(function() {
    'use strict';
    angular
        .module('app.core.paypal', 
            []);
})();

(function() {
    'use strict';

    angular
        .module('app.core.facebook', 
            []);
})();

(function() {
    'use strict';

    angular
        .module('app.core.google', 
            []);
})();

angular.module('app.comp.chat').factory('ChatSvr', ChatSvr);

ChatSvr.$inject = ["$q", "ProfileSvr", "RemoteService", "DataSync", '$rootScope',
    "FileSvr", "$filter"
];

function ChatSvr($q, ProfileSvr, RemoteService, DataSync, $rootScope,
    FileSvr, $filter) {

    var self = this;
    self.list = [];
    self.table = "chatmsgs";
    self.idColumn = "id";
    self.typingList = [];

    self.init = function() {

        var def = $q.defer();

        FileSvr.getUserFileMsgs().then(function(data) {

            if (data !== undefined && data !== null && data.length > 0) {

                var chats = $filter('filter')(data, function(chat) {
                    return chat.user_id == ProfileSvr.me.user_id || chat.to_user_id == ProfileSvr.me.user_id;
                });

                if (chats !== undefined && chats.length > 0)
                    self.list = chats;
            }

            def.resolve();

        });

        return def.promise;

    }

    self.all = function() {
        return self.list;
    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }

    }

    self.removeTyping = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.typingList.splice(self.typingList.indexOf(obj), 1);
            });
        } else {
            self.typingList.splice(self.typingList.indexOf(obj), 1);
        }
    }

    self.removeChatByUser = function(user_id) {

        var chats = $filter('filter')(self.list, function(chat) {
            return chat.user_id != user_id && chat.to_user_id != user_id;
        });

        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list = chats;
            });
        } else {
            self.list = chats;
        }
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(row) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.push(row);
            });
        } else {
            self.list.push(row);
        }
    }

    self.addTyping = function(row) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.typingList.push(row);
            });
        } else {
            self.typingList.push(row);
        }
    }

    self.update = function(row) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == row[self.idColumn]) {
                self.list[i] = row;
                break;
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            if (self.get(value[self.idColumn]) == null) {
                self.add(value);
            } else {
                self.update(value);
            }
        });
    }

    self.setMsgRead = function(user_id, lastmsg_id) {

        var arr = {};
        arr.user_id = user_id;
        arr.lastmsg_id = lastmsg_id;
        var datasync = new DataSync.Init(self, arr, 'Read');
        return datasync.pushData();
    }

    self.sendMsg = function(obj) {

        var def = $q.defer();
        var data = {
            "reqData": obj,
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/SEND_Z_MESSAGE"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var sentmsg = angular.fromJson(res.data);
                // self.add(sentmsg);
                def.resolve(sentmsg);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });
        return def.promise;

    }

    self.retriveData = function(users) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "users": users
            },
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/usermsg"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var msgs = angular.fromJson(res.data);
                self.addArray(msgs);
                def.resolve(msgs);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.chat')
    .factory('zsocket', function($rootScope, socketFactory, ProfileSvr, ChatSvr, $q, ChatUserSvr,
        FavouriteSvr, VisitorSvr, LikeSvr, UserSvr, AppUtil, AppConf, UnmatchSvr, DataSync) {

        var self = this;

        self.init = function() {

            var def = $q.defer();

            if (!self.mySocket || (self.mySocket.readyState != self.mySocket.OPEN && self.mySocket.readyState != self.mySocket.CONNECTING)) {

                self.mySocket = new WebSocket(AppConf.getSocketFullUrl() + "/wsConn");

                self.mySocket.onopen = function() {
                    console.log('Connection open!');

                    self.mySocket.send(parseData('init', {
                        "deviceid": AppUtil.getDevice(),
                        "user": ProfileSvr.me.user_id,
                        "email": ProfileSvr.zUser(),
                        "key": ProfileSvr.zApiKey()
                    }));
                    def.resolve(self.mySocket.readyState);
                }

                self.mySocket.onerror = function(event) {
                    console.log('Error----------' + event.code);
                };

                self.mySocket.onclose = function(event) {
                    // TODO
                };

                self.mySocket.onmessage = function(event) {
                    var data = unParseData(event.data);
                    var comm = data.comm;
                    delete data.comm;

                    if (comm == 't_msg') {
                        self.onTextMessage(data);
                    } else if (comm == 'typ') {
                        self.onTyping(data.data);
                    } else if (comm == 'styp') {
                        self.onStopTyping(data.data);
                    } else if (comm == 'msg_read') {
                        self.onMsgRead(data);
                    } else if (comm == 'like_add') {
                        self.onLikeAdd(data);
                    } else if (comm == 'add_chatu') {
                        self.onChatUserAdd(data);
                    } else if (comm == 'add_fvt') {
                        self.onFvtAdd(data);
                    } else if (comm == 'add_visit') {
                        self.onVisitAdd(data);
                    } else if (comm == 'add_block') {
                        self.onBlockAdd(data);
                    } else if (comm == 'delete_like') {
                        self.onLikeDelete(data);
                    } else if (comm == 'delete_chatu') {
                        self.onChatUserDelete(data);
                    } else if (comm == 'delete_fvt') {
                        self.onFvtDelete(data);
                    } else if (comm == 'delete_visit') {
                        self.onVisitDelete(data);
                    } else if (comm == 'delete_block') {
                        self.onBlockDelete(data);
                    } else if (comm == 'seen_like') {
                        self.onLikeSeen(data);
                    } else if (comm == 'seen_fvt') {
                        self.onFvtSeen(data);
                    } else if (comm == 'seen_visit') {
                        self.onVisitSeen(data);
                    } else if (comm == 'user_credited') {
                        self.onUserCredited(data);
                    } else if (comm == 'add_premium') {
                        self.onPremiumAdd(data);
                    } else if (data.status) {
                        if (data.status == '413') {
                            ionic.Platform.exitApp();
                        } else if (data.status != '200') {
                            console.log('Error----------' + data.msg);
                        }
                    }

                }
            } else {
                setTimeout(function() {
                    def.resolve(self.mySocket.readyState);
                }, 5);
            }

            return def.promise;
        }

        self.stopTyping = function(data) {
            if (self.mySocket.readyState == self.mySocket.OPEN) {
                self.mySocket.send(parseData('styp', data));
            } else if (self.mySocket.readyState == self.mySocket.CLOSED) {
                self.init().then(function(res) {
                    if (res == self.mySocket.OPEN)
                        self.mySocket.send(parseData('styp', data));
                });
            }
        }

        self.startTyping = function(data) {
            if (self.mySocket.readyState == self.mySocket.OPEN) {
                self.mySocket.send(parseData('typ', data));
            } else if (self.mySocket.readyState == self.mySocket.CLOSED) {
                self.init().then(function(res) {
                    if (res == self.mySocket.OPEN)
                        self.mySocket.send(parseData('typ', data));
                });
            }
        }

        function parseData(command, data) {
            var pdata = {};
            pdata.comm = command;
            pdata.data = data;
            return JSON.stringify(pdata);
        }

        function unParseData(data) {
            return JSON.parse(data);
        }

        self.onMsgRead = function(obj) {

            var items = ChatSvr.list.filter(function(item) {
                return (item.read == 'N' && item.user_id == obj.from &&
                    item.to_user_id == obj.to && item.id <= obj.id);
            });
            angular.forEach(items, function(item) {
                item.read = 'Y';
            });

        }

        self.onLikeAdd = function(data) {

            if (data.from == ProfileSvr.me.user_id) {
                var user = UserSvr.get(data.user_id);
                if (user) {
                    user.islike = data.islike;
                }
            } else {

                AppUtil.notifyPlay();
                var toast_msg = data.displayname + " has liked you!";
                AppUtil.toast_notify(toast_msg);
                LikeSvr.add(data);
                var user = UserSvr.get(data.user_id);
                if (user) {
                    user.likedme = 'Y';
                }
            }
        };

        self.onUserCredited = function(data) {
            if (data.to && data.action_page == 'LIKE') {
                var obj = LikeSvr.byUser(data.to);
                if (obj)
                    obj.isdebited = 'Y';
            }
            if (data.credited_value)
                ProfileSvr.me.credit_point = ProfileSvr.me.credit_point - data.credited_value;
        };

        self.onLikeDelete = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = LikeSvr.get(value.id);
                if (obj)
                    LikeSvr.remove(obj);
            });
        };

        self.onChatUserDelete = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = ChatUserSvr.get(value.id);
                if (obj) {
                    ChatUserSvr.remove(obj);
                    ChatSvr.removeChatByUser(obj.user_id);
                }
            });
        };

        self.onFvtDelete = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = FavouriteSvr.get(value.id);
                if (obj)
                    FavouriteSvr.remove(obj);
            });
        };

        self.onBlockDelete = function(data) {

            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = UnmatchSvr.get(value.id);
                if (obj)
                    UnmatchSvr.remove(obj);
            });

            DataSync.removeSyncTime(ChatUserSvr);
            DataSync.removeSyncTime(FavouriteSvr);
            DataSync.removeSyncTime(VisitorSvr);
            DataSync.removeSyncTime(LikeSvr);

        };

        self.onVisitDelete = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = VisitorSvr.get(value.id);
                if (obj)
                    VisitorSvr.remove(obj);
            });
        };

        self.onLikeSeen = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = LikeSvr.get(value);
                if (obj)
                    obj.seen = 'Y';
            });
        };

        self.onFvtSeen = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = FavouriteSvr.get(value);
                if (obj)
                    obj.seen = 'Y';
            });
        };

        self.onVisitSeen = function(data) {
            angular.forEach(angular.fromJson(data.list), function(value, key) {
                var obj = VisitorSvr.get(value);
                if (obj)
                    obj.seen = 'Y';
            });
        };

        self.onTextMessage = function(data) {
            ChatSvr.add(data);
            if (data.user_id != ProfileSvr.me.user_id)
                AppUtil.notifyPlay();

            if (data.user_id != ProfileSvr.me.user_id)
                ChatUserSvr.checkUser(data.user_id);
            else
                ChatUserSvr.checkUser(data.to_user_id);
        };

        self.onBlockAdd = function(data) {
            delur = 0;
            if (data.from == ProfileSvr.me.user_id)
                delur = data.to;
            else {
                AppUtil.warning("You are reported by one of the user so" +
                    " Please behaviour respectful and well mannered ");
                delur = data.from;
            }

            DataSync.removeSyncTime(ChatUserSvr);
            DataSync.removeSyncTime(FavouriteSvr);
            DataSync.removeSyncTime(VisitorSvr);
            DataSync.removeSyncTime(LikeSvr);

        };

        self.onChatUserAdd = function(data) {
            ChatUserSvr.add(data);
        };

        self.onPremiumAdd = function(data) {
            ProfileSvr.setExpired(data.expired);
        };

        self.onFvtAdd = function(data) {
            if (data.from == ProfileSvr.me.user_id) {
                var user = UserSvr.get(data.user_id);
                if (user) {
                    user.isfvt = 'Y';
                }
            } else {
                AppUtil.notifyPlay();
                var toast_msg = data.displayname + " has marked you as favourite!";
                AppUtil.toast_notify(toast_msg);
            }
            FavouriteSvr.add(data);
        };

        self.onVisitAdd = function(data) {

            if (data.from == ProfileSvr.me.user_id) {
                var user = UserSvr.get(data.user_id);
                if (user) {
                    user.isvisited = 'Y';
                }
            } else {
                AppUtil.notifyPlay();
                var toast_msg = data.displayname + " has visited you!";
                AppUtil.toast_notify(toast_msg);
                VisitorSvr.add(data);
            }

        };

        self.onTyping = function(data) {
            data.type = 'notification';
            data.message = ' typing....';
            data.id = 0;
            ChatSvr.addTyping(data);
        };

        self.onStopTyping = function(obj) {

            var items = ChatSvr.typingList.filter(function(item) {
                return (item.type == 'notification' && item.message == ' typing....' &&
                    item.user_id == obj.user_id);
            });
            angular.forEach(items, function(item) {
                ChatSvr.removeTyping(item);
            });
        };
        return self;
    });

angular.module('app.comp.chatusers').factory('ChatUserSvr', ChatUserSvr);

ChatUserSvr.$inject = ["$q", "DataSync", "$filter", "$rootScope", "ChatSvr", "FileSvr"];

function ChatUserSvr($q, DataSync, $filter, $rootScope, ChatSvr, FileSvr) {

    var self = this;
    self.list = [];
    self.table = "chatUsers";
    self.idColumn = "id";
    self.syncTimeOut = 30;

    self.init = function(force, pullforce) {

        var def = $q.defer();
        if (force || self.list.length <= 0) {
            var datasync = new DataSync.Init(self, 0);
            datasync.pullData(pullforce).then(function() {
                def.resolve(self.list);
            }, function() {
                def.reject();
            });
        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }

        if (!self.curWatch) {
            self.curWatch = $rootScope.$watch(function() {
                return ChatSvr.list;
            }, function(newVal, oldVal) {

                setTimeout(function() {
                    FileSvr.writeUserFileMsgs(newVal);

                    if (newVal && oldVal && newVal.length != oldVal.length) {
                        angular.forEach(self.list, function(chatuser) {

                            var arCopy = [];
                            if (oldVal && oldVal.length > 0)
                                arCopy = angular.copy(newVal.slice(oldVal.length - 1));
                            else
                                arCopy = angular.copy(newVal);

                            unreadChat = arCopy.filter(function(chat) {
                                return chat.user_id == chatuser.user_id && chat.read == 'N';
                            });

                            //TODO:
                            obj = arCopy.FindObjMax(['user_id', 'to_user_id'], 'created', chatuser.user_id);
                            if (obj && obj.created != 0) {
                                chatuser.lastAccesedTime = obj.created;
                                chatuser.lastMessage = '';
                                if (obj.type === 't') {
                                    chatuser.lastMessage = obj.message;
                                } else if (obj.type === 'p') {
                                    chatuser.lastMessage = '📷 Photo';
                                }

                            }
                            if (unreadChat.length > 0) {
                                chatuser.unread = unreadChat.length;
                            } else {
                                chatuser.unread = 0;
                            }

                        });
                    }
                }, 10);

            }, true);
        }

        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {

        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {

                if (self.get(obj[self.idColumn]) == null) {
                    self.list.push(obj);

                    if (!self.rusers)
                        self.rusers = [];
                    obj = angular.copy(ChatSvr.list).FindObjMax(['user_id'], 'id', obj.user_id);
                    fobj = {};
                    fobj.user_id = obj.user_id;
                    fobj.id = obj.id;
                    self.rusers.push(fobj);


                    if (self.rusers && self.rusers.length == 10) {
                        if (self.rusers && self.rusers.length > 0) {
                            ChatSvr.retriveData(angular.copy(self.rusers));
                            self.rusers = [];
                        }
                    } else {
                        setTimeout(function() {
                            if (self.rusers && self.rusers.length > 0) {
                                ChatSvr.retriveData(angular.copy(self.rusers));
                                self.rusers = [];
                            }
                        }, 2000);
                    }

                } else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null) {
                self.list.push(obj);

                if (!self.rusers)
                    self.rusers = [];
                obj = angular.copy(ChatSvr.list).FindObjMax(['user_id'], 'id', obj.user_id);
                fobj = {};
                fobj.user_id = obj.user_id;
                fobj.id = obj.id;
                self.rusers.push(fobj);


                if (self.rusers && self.rusers.length == 10) {
                    if (self.rusers && self.rusers.length > 0) {
                        ChatSvr.retriveData(angular.copy(self.rusers));
                        self.rusers = [];
                    }
                } else {
                    setTimeout(function() {
                        if (self.rusers && self.rusers.length > 0) {
                            ChatSvr.retriveData(angular.copy(self.rusers));
                            self.rusers = [];
                        }
                    }, 2000);
                }

            } else
                self.update(obj);
        }

    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.removeByUser = function(userid) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].user_id == userid) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.removeChatUser = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;

        var datasync = new DataSync.Init(self, pobj, 'Delete');
        return datasync.pushData();
    }

    self.deleteByID = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'DeleteByID');
        return datasync.pushData();
    }

    self.addChatUser = function(obj) {
        var pobj = {};
        pobj.user_id = obj;
        var datasync = new DataSync.Init(self, pobj, 'Add');
        return datasync.pushData();
    }

    self.checkUser = function(user_id) {
        var user = $filter("filter")(self.list, {
            user_id: user_id
        });
        if (user.length <= 0) {
            self.addChatUser(user_id);
        }
    }

    return self;

};

angular.module('app.comp.favourite').factory('FavouriteSvr', FavouriteSvr);

FavouriteSvr.$inject = ["$q", "DataSync", "$rootScope"];

function FavouriteSvr($q, DataSync, $rootScope) {

    var self = this;
    self.list = [];
    self.table = "fvtUsers";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || self.list.length <= 0) {

            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.list);
            }, function() {
                def.reject();
            });
        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }
        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }
    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.removeByUser = function(userid) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].user_id == userid) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.removeByID = function(id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].id == id) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.setUnFavourite = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Delete');
        return datasync.pushData();
    }

    self.updateSeen = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Seen');
        return datasync.pushData();
    }

    self.setFavourite = function(obj) {
        var pobj = {};
        pobj.user_id = obj;
        var datasync = new DataSync.Init(self, pobj, 'Add');
        return datasync.pushData();
    }

    self.deleteByID = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'DeleteByID');
        return datasync.pushData();
    }

    return self;

};

angular.module('app.comp.feedback').factory('FeedbackSvr', FeedbackSvr);

FeedbackSvr.$inject = ["$q", 'RemoteService', "ProfileSvr", "AppUtil"];

function FeedbackSvr($q, RemoteService, ProfileSvr, AppUtil) {

    var self = this;

    self.init = function() {

        var def = $q.defer();

        if (angular.isDefined(self.types)) {
            setTimeout(function() {
                def.resolve(self.types);
            }, 0);
        } else {
            self.getTypeList().then(function(res) {
                if(res){
                    self.types = res;
                    def.resolve(self.types);
                }else if (res == null) {
                    self.types = {};
                     def.resolve(self.types);
                } else {
                    AppUtil.warning(res);
                }
            }, function(res) {
                def.reject();
            });
        }
        return def.promise;
    }

    self.addFeedback = function(data) {
        var def = $q.defer();
        var obj = {};
        obj.desc = data.desc;
        obj.type = data.type;
        var data = {
            "reqData": obj,
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/feedback/add"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve();
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });
        return def.promise;
    }

    

    self.getTypeList = function() {

        var def = $q.defer();
        var data = {
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/feedback/getlist"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var types = angular.fromJson(res.data);
                def.resolve(types);
            } else if (res.status == 404) {
                def.resolve(null);
            } else if (res.status == 201) {
                def.resolve(res.message);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.filter').factory('FilterSvr', FilterSvr);

FilterSvr.$inject = ["$q", "DataSync", "$rootScope"];

function FilterSvr($q, DataSync, $rootScope) {

    var self = this;
    self.data = null;
    self.table = "ufilter";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || !self.data) {

            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.data);
            });

        } else {
            setTimeout(function() {
                def.resolve(self.data);
            }, 50);
        }
        return def.promise;
    }

    self.get = function() {
        return self.data;
    }

    self.update = function(row) {
        if (row) {
            self.data = row;
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.update(value);
        });
    }

    self.setUpdate = function(obj) {
        var def = $q.defer();
        var datasync = new DataSync.Init(self, obj, 'Add');
        datasync.pushData().then(function() {
            self.update(obj);
            def.resolve();
        }, function() {
            def.reject("Please Try Later");
        });
        return def.promise;
    }

    return self;

};

angular.module('app.comp.imagerate').factory('ImageRateSvr', ImageRateSvr);

ImageRateSvr.$inject = ["$q", "DataSync", "$rootScope"];

function ImageRateSvr($q, DataSync, $rootScope) {

    var self = this;
    self.list = [];
    self.table = "uPhotor";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || self.list.length <= 5) {

            var datasync = new DataSync.Init(self, 0, null, 1);
            datasync.pullData(true).then(function() {
                def.resolve(self.list);
            }, function() {
                def.reject();
            });
        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }
        return def.promise;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.retriveData = function() {

        var def = $q.defer();
        var datasync = new DataSync.Init(self, 0, null, 1);
        datasync.pullData(true).then(function() {
            def.resolve(self.list);
        }, function() {
            def.reject();
        });

        return def.promise;
    }

    self.remove = function(obj) {
        var remObj = self.get(obj);
        if (remObj)
            self.list.splice(self.list.indexOf(remObj), 1);
        if (self.list.length <= 5) {
            self.retriveData().then(function(res) {
                if (res) {
                    self.addArray(res);
                }
            }, function(res) {
                // def.resolve();
            });
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            if (self.get(value[self.idColumn]) == null) {
                self.add(value);
            } else {
                self.update(value);
            }
        });
    }

    self.ratePhoto = function(photoID, rate) {

        var deferred = $q.defer();

        var pobj = {};
        pobj.photo_id = photoID;
        pobj.rate = rate;
        var datasync = new DataSync.Init(self, pobj, 'Add');
        datasync.pushData().then(function(res) {
            self.remove(photoID);
            deferred.resolve();
        }, function() {
            deferred.reject();
        });

        return deferred.promise;
    }

    return self;

};

angular.module('app.comp.invite').factory('InviteSvr', InviteSvr);

InviteSvr.$inject = ["$q", "DBSvc", "DataSync"];

function InviteSvr($q, DBSvc, DataSync) {

    var self = this;
    self.list = [];
    self.tableName = "invites";
    self.idColumn = "invites_id";

    self.init = function() {

        var def = $q.defer();

        if (angular.isDefined(self.list) && self.list.length > 0) {
            def.resolve(self.list);
        } else {
            DataSync.pullData([{
                "Table": self.tableName
            }], 0, 0).then(function(res) {
                DBSvc.query("Select * from " + self.tableName).then(function(result) {
                    self.list = DBSvc.fetchAll(result);
                    def.resolve(self.list);
                }, function(res) {
                    def.reject(res);
                });
            }, function(res) {
                def.reject(res);
            });
        }

        return def.promise;

    }

    self.all = function() {
        return self.list;
    }

    self.remove = function(obj) {
        var sql = "Delete from " + self.tableName + " WHERE " + self.idColumn + " = ? ";
        DBSvc.query(sql, [obj[self.idColumn]]).then(function(result) {
            self.list.splice(self.list.indexOf(obj), 1);
        });
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(row) {

        var deferred = $q.defer();
        DBSvc.addTableRow(self.tableName, row).then(function(result) {
            self.list.push(row);
            deferred.resolve(result);
        }, function(res) {
            deferred.reject(res);
        });

        return deferred.promise;
    }

    self.update = function(row) {
        var obj = row,
            deferred = $q.defer();
        if (obj) {
            DBSvc.updateTableRow(self.tableName, obj).then(function(result) {
                for (var i = 0; i < self.list.length; i++) {
                    if (self.list[i][self.idColumn] == obj[self.idColumn]) {
                        self.list[i] = obj;
                        break;
                    }
                }
                deferred.resolve(result);
            }, function(res) {
                deferred.reject(res);
            });
        }
        return deferred.promise;
    }

    self.addArray = function(objList) {

        var def = $q.defer();
        var loopPromises = [];
        angular.forEach(objList, function(value, key) {
            var deferred = $q.defer();
            loopPromises.push(deferred.promise);
            if (self.get(value[self.idColumn]) == null) {
                self.add(value).then(function(res) {
                    deferred.resolve();
                }, function(res) {
                    deferred.reject();
                });
            } else {
                self.update(value).then(function(res) {
                    deferred.resolve();
                }, function(res) {
                    deferred.reject();
                });
            }
        });

        $q.all(loopPromises).then(function(res) {
            def.resolve(res);
        }, function(res) {
            def.resolve(res);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.like').factory('LikeSvr', LikeSvr);

LikeSvr.$inject = ["$q", "DataSync", "ProfileSvr", "RemoteService", "$rootScope", "AppUtil"];

function LikeSvr($q, DataSync, ProfileSvr, RemoteService, $rootScope, AppUtil) {

    var self = this;
    self.list = [];
    self.table = "likeUsers";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || self.list.length <= 0) {

            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.list);
            }, function(){
                def.reject();
            });
        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }
        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.byUser = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i]['user_id'] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }
    }

    self.add = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.removeByUser = function(userid) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].user_id == userid) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.removeLike = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Delete');
        return datasync.pushData();
    }

    self.removeByID = function(id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].id == id) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.deleteByID = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'DeleteByID');
        return datasync.pushData();
    }

    self.updateSeen = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Seen');
        return datasync.pushData();
    }

    self.unLike = function(obj) {
        return self.servelike(obj, 'UnLike');
    }

    self.like = function(obj) {
        return self.servelike(obj, 'Like');
    }

    self.servelike = function(obj, value) {

        var def = $q.defer();

        var data = {
            "reqData": {
                "user": obj
            },
            "action": value,
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/servelike"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newObj = angular.fromJson(res.data);
                // TODO Varify is matched or not 
                def.resolve(newObj);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.nearby').factory('NearBySvr', NearBySvr);

NearBySvr.$inject = ["$q", "RemoteService", "ZGeolocation", "ProfileSvr" , "AppUtil"];

function NearBySvr($q, RemoteService, ZGeolocation, ProfileSvr, AppUtil) {

    var self = this;
    self.lastsync;
    self.list = [];

    self.init = function() {

        var def = $q.defer();
        if ((self.isSync() || self.list.length <= 0) && ZGeolocation.currentPosition.lat && ZGeolocation.currentPosition.lon ) {

            self.retriveData().then(function(res) {
                if (res) {
                    self.list = res;
                }
                def.resolve();
                self.lastsync = new Date();
            }, function(res) {
                def.resolve();
            });

        } else {
            setTimeout(function() {
                def.resolve();
            }, 0);
        }
        return def.promise;

    }

    self.all = function() {
        return self.list;
    }

    self.isSync = function() {

        if (self.lastsync) {
            var endTime = new Date();
            var timeDiff = endTime - self.lastsync;
            // strip the miliseconds
            timeDiff /= 1000;
            // remove seconds from the date
            timeDiff = Math.floor(timeDiff / 60);
            // get minutes
            var minutes = Math.round(timeDiff % 60);
            if (minutes > 5) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }

    self.retriveData = function() {

        var def = $q.defer();
        var data = {
            "reqData": ZGeolocation.currentPosition,
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/getNearestPersons"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var list = angular.fromJson(res.data);
                def.resolve(list);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.order').factory('OrderSvr', OrderSvr);

OrderSvr.$inject = ['$q', 'DataSync', 'ProfileSvr', 'RemoteService'];

function OrderSvr($q, DataSync, ProfileSvr, RemoteService) {

    var self = this;

    self.generateOrder = function(orderJSON) {
        var def = $q.defer();
        var data = {
            "reqData": orderJSON,
            "action": "Add",
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/order/create"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newObj = angular.fromJson(res.data);
                def.resolve(newObj);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.orderGPayCall = function(pres, orderid, pstatus) {
        var def = $q.defer();
        var data = {
            "reqData": {
                res: pres,
                order: orderid,
                status: pstatus
            },
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/order/googlePayCall"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve();
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.orderRazorCall = function(pres, orderid, pstatus) {
        var def = $q.defer();
        var data = {
            "reqData": {
                res: pres,
                order: orderid,
                status: pstatus
            },
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/order/razorPayCall"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve();
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.orderFortumoCall = function(pres, orderid, pstatus) {
        var def = $q.defer();
        var data = {
            "reqData": {
                res: pres,
                order: orderid,
                status: pstatus
            },
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/order/fortumoCallback"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve();
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;
}

angular.module('app.comp.order').factory('PackageSvr', PackageSvr);

PackageSvr.$inject = ['$q', 'DataSync'];

function PackageSvr($q, DataSync) {

    var self = this;
    self.list = [];
    self.table = "pack";
    self.idColumn = "id";
    self.qtyColumn = "qty";

    self.load = function() {

        var def = $q.defer();

        var datasync = new DataSync.Init(self, 0);
        datasync.pullData().then(function() {
            def.resolve(self.list);
        });

        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id, qty) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id &&
                self.list[i][self.qtyColumn] == qty) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {
        if (self.get(obj[self.idColumn], obj[self.qtyColumn]) == null)
            self.list.push(obj);
        else
            self.update(obj);
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.getPayMethods = function(qty) {
        var jsonPackage = {};
        angular.forEach(self.list, function(value, key) {
            if (value.qty == qty) {
                jsonPackage = value;
            }
        });
        return jsonPackage;
    }

    return self;
}

angular.module('app.comp.profile').factory('ProfileSvr', ProfileSvr);

ProfileSvr.$inject = ["$q", "DBSvc", 'RemoteService', '$state', '$filter', '$rootScope', "AppUtil"];

function ProfileSvr($q, DBSvc, RemoteService, $state, $filter, $rootScope, AppUtil) {

    var self = this;
    self.me = null;
    self.profileImage = "assets/img/no-user.png";
    self.initParam = null;

    self.init = function(loginRes) {

        var def = $q.defer();

        if (angular.isDefined(self.me) && self.list != null) {
            setTimeout(function() {
                def.resolve(self.me);
            }, 0);
        } else if (loginRes && !loginRes.fbuserid && !loginRes.mobile) {
            self.me = loginRes;
            setTimeout(function() {
                def.resolve('smsvarify');
            }, 0);
        } else {

            if (loginRes) {
                self.initParam = loginRes;
            }

            self.retriveMe(self.initParam).then(function(res) {
                if (res == null) {
                    self.setMeFromFBResponse(self.initParam);
                    $state.go('signup');
                    def.reject();
                } else if (res) {

                    if (res.isvarified && res.isvarified == 'Y') {
                        self.setMe(res);

                        if (!self.curWatch) {

                            self.curWatch = $rootScope.$watch(function() {
                                return self.me.photos;
                            }, function(newVal, oldVal) {
                                if (self.me.photos) {
                                    var profilePics = $filter("filter")(self.me.photos, {
                                        isprofile: 'Y'
                                    });
                                    if (profilePics.length > 0) {
                                        self.me.profilePic = profilePics[0].photopath;
                                    }
                                }
                            }, true);
                        }

                        def.resolve('app.zeenking');
                    } else if (res.isvarified && res.isvarified == 'N') {
                        self.setMe(res);
                        def.resolve('smsvarify');
                    } else {
                        AppUtil.warning(res);
                    }

                }
            }, function(res) {
                def.reject();
            });
        }
        return def.promise;
    }

    self.setMe = function(res) {
        self.me = res;
        if (self.me && self.me.photos) {
            var profilePics = $filter("filter")(self.me.photos, {
                isprofile: 'Y'
            });
            if (profilePics.length > 0) {
                self.me.profilePic = profilePics[0].photopath;
            }
        }
        self.afterUpdateExpired();

    }

    self.setExpired = function(date) {
        if (self.me) {
            self.me.expired = date;
            self.afterUpdateExpired();
        }
    }

    self.afterUpdateExpired = function() {
        if (self.me) {
            setTimeout(function() {
                var diff = AppUtil.dateDiff('h', new Date(), self.me.expired);
                if (diff < 0) {
                    self.me.ispremium = 'N';

                    if (self.me.isvarified && self.me.isvarified == 'Y') {
                        $state.go("order");
                    }
                } else {
                    if (diff <= 1) {
                        var diff = AppUtil.dateDiff('x', new Date(), self.me.expired);
                        setTimeout(function() {
                            var diff = AppUtil.dateDiff('x', new Date(), self.me.expired);
                            if (diff < 0) {
                                self.me.ispremium = 'N';

                                if (self.me.isvarified && self.me.isvarified == 'Y') {
                                    $state.go("order");
                                }
                            }
                        }, diff + 1000);
                    }
                    self.me.ispremium = 'Y';
                }
            }, 5000);
        }
    }

    self.updateMe = function(res) {

        var keys = Object.keys(res);
        angular.forEach(keys, function(value) {
            self.me[value] = res[value];
        });

    }

    self.addphoto = function(newObj) {
        if (newObj) {
            if (self.me.photos) {
                self.me.photos.push(newObj);
            } else {
                self.me.photos = [];
                self.me.photos.push(newObj);
            }
            if (newObj.isprofile && newObj.isprofile == 'Y') {

                self.me.profilePic = newObj.photopath;

            }
        }
    }


    self.setMeFromFBResponse = function(loginRes) {

        var obj = {};
        obj.email = loginRes.email;
        obj.displayname = loginRes.name;
        obj.fbuserid = loginRes.id;

        if (loginRes.birthday)
            obj.birthdate = loginRes.birthday;
        if (loginRes.gender) {
            if (loginRes.gender == 'male') {
                obj.gender = 'M';
            } else if (loginRes.gender == 'female') {
                obj.gender = 'F';
            }
        }
        if (loginRes.languages)
            obj.languages = loginRes.languages;
        if (loginRes.education) {
            obj.education = [];
            angular.forEach(loginRes.education, function(value, key) {
                var edu = {};
                if (value.school) {
                    edu.school = value.school.name;
                }
                if (value.type) {
                    edu.type = value.type;
                }
                if (value.year) {
                    edu.year = value.year.name;
                }
                this.push(edu);
            }, obj.education);
        }
        if (loginRes.location)
            obj.location = loginRes.location;
        if (loginRes.work) {
            obj.work = [];
            angular.forEach(loginRes.work, function(value, key) {
                var work = {};
                if (value.employer) {
                    work.employer = value.employer.name;
                }
                if (value.location) {
                    work.location = value.location.name;
                }
                if (value.position) {
                    work.position = value.position.name;
                }
                if (value.start_date) {
                    work.start_date = value.start_date;
                }
                this.push(work);
            }, obj.work);
        }
        self.setMe(obj);
    }

    self.remove = function(obj) {
        var sql = "Delete from " + self.tableName + " WHERE " + self.idColumn + " = ? ";
        DBSvc.query(sql, [obj[self.idColumn]]).then(function(result) {
            self.list.splice(self.list.indexOf(obj), 1);
        });
    }

    self.iscomplete = function() {
        if (self.me.ucast && self.me.location && self.me.languages && self.me.maritalstatus && self.me.education && self.me.employment &&
            self.me.horoscope && self.me.height && self.me.bodytype && self.me.smoking && self.me.drinking && self.me.diet) {
            if (self.me.ucast.trim().length > 0 && self.me.location.trim().length > 0 && self.me.languages.trim().length > 0 &&
                self.me.maritalstatus.trim().length > 0 && self.me.education.trim().length > 0 && self.me.employment.trim().length > 0 &&
                self.me.horoscope.trim().length > 0 && self.me.height.trim().length > 0 && self.me.bodytype.trim().length > 0 &&
                self.me.smoking.trim().length > 0 && self.me.drinking.trim().length > 0 && self.me.diet.trim().length > 0) {
                return true;
            }
        }
        return false;
    }

    self.add = function(row) {

        var deferred = $q.defer();
        DBSvc.addTableRow(self.tableName, row).then(function(result) {
            self.list.push(row);
            deferred.resolve(result);
        }, function(res) {
            deferred.reject(res);
        });

        return deferred.promise;
    }

    self.updateInfo = function(data, type) {
        var def = $q.defer();
        var obj = {};
        obj.data = data;
        obj.type = type;
        var data = {
            "reqData": obj,
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/updateInfo"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newUser = angular.fromJson(res.data);
                self.updateMe(newUser);
                def.resolve(newUser);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });
        return def.promise;
    }

    self.completeSignUp = function(data) {
        var def = $q.defer();
        var data = {
            "reqData": data
        };
        var request = {
            method: "POST",
            actionType: "/zuser/create"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newUser = angular.fromJson(res.data);
                def.resolve(newUser);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });
        return def.promise;
    }

    self.deleteUser = function(data) {
        var def = $q.defer();
        var data = {
            "reqData": data,
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/delete"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve(res.message);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });
        return def.promise;
    }

    self.retriveMe = function(loginRes) {

        var def = $q.defer();

        var data = {
            "reqData": {
                'device': AppUtil.getDevice()
            },
            'loginData': self.getAPIKey(loginRes)
        };
        var request = {
            method: "POST",
            actionType: "/zuser/me"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newUser = angular.fromJson(res.data);
                self.sessionKey = res.message;
                def.resolve(newUser);
            } else if (res.status == 404) {
                def.resolve(null);
            } else if (res.status == 201) {
                def.resolve(res.message);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.getAPIKey = function(loginRes) {

        var retObj = {};

        retObj.zUser = self.zUser(loginRes);
        retObj.zApiKey = self.zApiKey(loginRes);

        return retObj;
    }

    self.zApiKey = function(loginRes) {

        if (loginRes !== undefined)
            return AppUtil.getCredentialObj(loginRes);
        else if (self.sessionKey)
            return self.sessionKey;
        else
            return AppUtil.getCredentialObj(self.me);
    }


    self.zUser = function(loginRes) {

        if (loginRes !== undefined)
            return loginRes.fbuserid ? loginRes.fbuserid : loginRes.mobile;
        else
            return self.me.fbuserid ? self.me.fbuserid : self.me.mobile;
    }

    self.uploadImage = function(base64) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "image": base64,
                "action": "Add"
            },
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/image"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newObj = angular.fromJson(res.data);
                self.addphoto(newObj);
                def.resolve(newObj);

            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.addCredit = function(userid, action) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "user": userid,
                "action": action
            },
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/creditpoint"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve();
            } else if (res.status == 201) {
                def.reject(res.message);
            } else {
                def.reject("Something Going Wrong. Try Again later");
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.setProfileImage = function(imageid) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "image": imageid + "",
                "action": "SetProfile"
            },
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/image"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newObj = angular.fromJson(res.data);
                self.updateProfileImage(newObj);
                def.resolve(newObj);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.updateProfileImage = function(imageid) {

        // Reset Privious Profile Image
        var profilePics = $filter("filter")(self.me.photos, {
            isprofile: 'Y'
        });
        if (profilePics.length > 0) {
            profilePics[0].isprofile = 'N';
        }

        // Set New Profile Image
        var profilePics = $filter("filter")(self.me.photos, {
            id: imageid
        });
        if (profilePics.length > 0) {
            profilePics[0].isprofile = 'N';
        }

        self.me.profilePic = profilePics[0].photopath;
    }

    // imagename should be comma seperated ids
    self.removeImage = function(imagename) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "image": imagename + "",
                "action": "Remove"
            },
            'loginData': self.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/image"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {

                var newObj = angular.fromJson(res.data);
                angular.forEach(newObj, function(value, key) {
                    var newTemp = $filter("filter")(self.me.photos, {
                        id: value
                    });
                    if (newTemp.length > 0)
                        self.me.photos.splice(self.me.photos.indexOf(newTemp[0]), 1);
                });

                def.resolve(newObj);

            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.comp.ques').factory('QuesSvr', QuesSvr);

QuesSvr.$inject = ["$q", "DataSync", "AppUtil", "$rootScope"];

function QuesSvr($q, DataSync, AppUtil, $rootScope) {

    var self = this;
    self.data = null;
    self.table = "usr_que";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || !self.data) {

            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.data);
            });

        } else {
            setTimeout(function() {
                def.resolve(self.data);
            }, 50);
        }
        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }
    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.submitAns = function(obj) {
        if (obj) {
            var datasync = new DataSync.Init(self, obj, 'Add');
            return datasync.pushData();
        }
    }

    return self;

};

angular.module('app.comp.tips').factory('TipsSvr', TipsSvr);

TipsSvr.$inject = ["$q", '$mdDialog', '$filter', '$ionicHistory'];

function TipsSvr($q, $mdDialog, $filter, $ionicHistory) {

    var self = this;

    // Test Data will change later 
    self.list = [
    {
        'state': 'login',
        'data': [{
            'seq': '10',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fcDhrbE5PY3E3Mkk'
        },{
            'seq': '20',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fQzNncXVYU3QtX00'
        },{
            'seq': '30',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fclVXNER3RnFRSms'
        },{
            'seq': '40',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fVkJpZ3QyaXBtTDQ'
        },{
            'seq': '50',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fVkU2QVJ0Xy1JYVk'
        },{
            'seq': '60',
            'image': 'https://docs.google.com/uc?id=0B0BtUVXZxA9fMldST1hRc000Qzg'
        }]
    }
    // , {
    //     'state': 'app.profile',
    //     'data': [{
    //         'seq': '10',
    //         'image': 'https://www.google.co.in/images/branding/googlelogo/2x/googlelogo_color_272x92dp.png'
    //     }]
    // }
    ];

    self.open = function() {

        self.cstate = $ionicHistory.currentStateName();

        if (!localStorage.getItem('skipAllTips')) {

            if (!self.states) {
                self.states = localStorage.getItem('stateDone');
                if (self.states)
                    self.states = self.states.split(',');
                else
                    self.states = [];
            }

            if (self.states.indexOf(self.cstate) >= 0)
                return null;

            var images = $filter("filter")(self.list, {
                state: self.cstate
            });

            if (images && images.length >= 1) {

                $mdDialog.show({
                        controller: 'TipsCtrl',
                        templateUrl: 'app/comp/tips/tips.html',
                        parent: angular.element(document.body),
                        clickOutsideToClose: true,
                        locals: {
                            data: images[0].data
                        },
                        fullscreen: false // Only for -xs, -sm breakpoints.
                    })
                    .then(function(action) {
                        if (action == 'skipall') {
                            localStorage.setItem('skipAllTips', true);
                        } else if (action == 'complete') {
                            self.states.push(self.cstate);
                            localStorage.setItem('stateDone', self.states.join(','));
                        }
                    }, function() {
                        // TODO
                    });
            }
        }
    }

    return self;

};

angular.module('app.comp.unmatch').factory('UnmatchSvr', UnmatchSvr);

UnmatchSvr.$inject = ["$q", "DataSync", "$rootScope"];

function UnmatchSvr($q, DataSync, $rootScope) {

    var self = this;
    self.table = "ublock";
    self.list = [];
    self.idColumn = "id";

    self.addNew = function(obj) {

        var def = $q.defer();
        var datasync = new DataSync.Init(self, obj, 'Add');
        datasync.pushData().then(function() {
            def.resolve();
        }, function() {
            def.reject("Please Try Later");
        });
        return def.promise;
    };

    self.init = function(force) {

        var def = $q.defer();
        if (force || self.list.length <= 0) {
            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.list);
            }, function() {
                def.reject();
            });

        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }
        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {

        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {

                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }

    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.removeByID = function(id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].id == id) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.deleteByID = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'DeleteByID');
        return datasync.pushData();
    }

    return self;

};

angular.module('app.comp.user').factory('UserSvr', UserSvr);
UserSvr.$inject = ["$q", 'RemoteService', 'ProfileSvr', "AppUtil"];

function UserSvr($q, RemoteService, ProfileSvr, AppUtil) {

    var self = this;
    self.list = [];
    self.lastsync = [];
    self.idColumn = 'user_id';

    self.init = function() {

    }

    self.add = function(row) {
        self.list.push(row);
        self.lastsync[row.user_id] = new Date();
    }

    self.update = function(row) {
        var obj = row;
        if (obj) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == obj[self.idColumn]) {
                    self.list[i] = obj;
                    self.lastsync[obj.user_id] = new Date();
                    break;
                }
            }
        }
    }

    self.get = function(userid) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == userid) {
                return self.list[i];
            }
        }
        return null;
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            if (self.get(value[self.idColumn]) == null) {
                self.add(value);
            } else {
                self.update(value);
            }
        });
    }

    self.isSync = function(user_id) {

        if (self.lastsync[user_id]) {
            var endTime = new Date();
            var timeDiff = endTime - self.lastsync[user_id];
            // strip the miliseconds
            timeDiff /= 1000;
            // remove seconds from the date
            timeDiff = Math.floor(timeDiff / 60);
            // get minutes
            var minutes = Math.round(timeDiff % 60);
            if (minutes >= 5) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }

    self.userVisited = function(user_id) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "user_id": ProfileSvr.me.user_id,
                "to_user_id": user_id
            },
            "action": "Add",
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/visit/update"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var newObj = angular.fromJson(res.data);
                def.resolve(newObj);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    self.retriveUser = function(userids) {

        var def = $q.defer();

        var foundusers = [];
        var notFound = [];

        if (!angular.isArray(userids)) {
            var user = self.get(userids);
            if (!user || self.isSync(userids)) {
                notFound.push(userids);
            } else {
                foundusers.push(user);
            }
        } else {
            angular.forEach(userids, function(userid) {
                var user = self.get(userid);
                if (!user || self.isSync(userid)) {
                    notFound.push(userid);
                } else {
                    foundusers.push(user);
                }
            });
        }

        if (notFound.length > 0) {
            var data = {
                "reqData": {
                    "users": notFound
                },
                'loginData': ProfileSvr.getAPIKey()
            };
            var request = {
                method: "POST",
                actionType: "/me/userdetailes"
            };
            RemoteService.invokeRemoteAction(request, data).then(function(res) {
                if (res.status == 200) {
                    var users = angular.fromJson(res.data);
                    self.addArray(users);
                    angular.extend(foundusers, users);
                    def.resolve(foundusers);
                } else if (res.status == 404) {
                    def.resolve(null);
                } else {
                    def.reject(res.message);
                }
            }, function(res) {
                def.reject(res.message);
            });
        } else {
            setTimeout(function() {
                def.resolve(foundusers);
            }, 0);
        }

        return def.promise;
    }

    return self;

};

angular.module('app.comp.visitor').factory('VisitorSvr', VisitorSvr);

VisitorSvr.$inject = ["$q", "DataSync", "$rootScope"];

function VisitorSvr($q, DataSync, $rootScope) {

    var self = this;
    self.list = [];
    self.table = "visitedUsers";
    self.idColumn = "id";

    self.init = function(force) {

        var def = $q.defer();
        if (force || self.list.length <= 0) {
            var datasync = new DataSync.Init(self, 0);
            datasync.pullData().then(function() {
                def.resolve(self.list);
            }, function(){
                def.reject();
            });

        } else {
            setTimeout(function() {
                def.resolve(self.list);
            }, 50);
        }
        return def.promise;
    }

    self.all = function() {
        return self.list;
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.add = function(obj) {

        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {

                if (self.get(obj[self.idColumn]) == null)
                    self.list.push(obj);
                else
                    self.update(obj);
            });
        } else {
            if (self.get(obj[self.idColumn]) == null)
                self.list.push(obj);
            else
                self.update(obj);
        }

    }

    self.update = function(row) {
        if (row) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == row[self.idColumn]) {
                    self.list[i] = row;
                    break;
                }
            }
        }
    }

    self.remove = function(obj) {
        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
            $rootScope.$apply(function() {
                self.list.splice(self.list.indexOf(obj), 1);
            });
        } else {
            self.list.splice(self.list.indexOf(obj), 1);
        }
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            self.add(value);
        });
    }

    self.removeByUser = function(userid) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].user_id == userid) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.removeVisitor = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Delete');
        return datasync.pushData();
    }

    self.removeByID = function(id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i].id == id) {
                self.list.splice(i, 1);
                break;
            }
        }
    }

    self.deleteByID = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'DeleteByID');
        return datasync.pushData();
    }

    self.updateSeen = function(obj) {
        if (!angular.isArray(obj)) {
            var arr = [];
            arr.push(obj);
            obj = arr;
        }
        var pobj = {};
        pobj.list = obj;
        var datasync = new DataSync.Init(self, pobj, 'Seen');
        return datasync.pushData();
    }

    self.addVisitor = function(obj) {
        var pobj = {};
        pobj.user_id = obj;
        var datasync = new DataSync.Init(self, pobj, 'Add');
        return datasync.pushData();
    }

    return self;

};

angular.module('app.comp.zeenking').factory('ZeenkingSvr', ZeenkingSvr);
ZeenkingSvr.$inject = ["$q", 'RemoteService', 'ProfileSvr', "AppUtil"];

function ZeenkingSvr($q, RemoteService, ProfileSvr, AppUtil) {

    var self = this;
    self.list = [];
    self.idColumn = "user_id";

    self.init = function(now) {

        var def = $q.defer();

        if (now)
            self.list = [];

        if (angular.isDefined(self.list) && self.list.length > 0) {
            setTimeout(function() {
                def.resolve();
            }, 300);
        } else {
            self.retriveData().then(function(res) {
                if (res) {
                    self.addArray(res);
                }
                def.resolve();
            }, function(res) {
                def.resolve();
            });
        }
        return def.promise;
    }

    self.add = function(row) {
        self.list.push(row);
    }

    self.remove = function(obj) {
        var remObj = self.get(obj[self.idColumn]);
        if (remObj)
            self.list.splice(self.list.indexOf(remObj), 1);
        if (self.list.length <= 5) {
            self.retriveData().then(function(res) {
                if (res) {
                    self.addArray(res);
                }
            }, function(res) {
                // def.resolve();
            });
        }
    }

    self.update = function(row) {
        var obj = row;
        if (obj) {
            for (var i = 0; i < self.list.length; i++) {
                if (self.list[i][self.idColumn] == obj[self.idColumn]) {
                    self.list[i] = obj;
                    break;
                }
            }
        }
    }

    self.get = function(obj_id) {
        for (var i = 0; i < self.list.length; i++) {
            if (self.list[i][self.idColumn] == obj_id) {
                return self.list[i];
            }
        }
        return null;
    }

    self.addArray = function(objList) {
        angular.forEach(objList, function(value, key) {
            if (self.get(value[self.idColumn]) == null) {
                self.add(value);
            } else {
                self.update(value);
            }
        });
    }

    self.retriveData = function() {

        var def = $q.defer();
        var data = {
            'loginData': ProfileSvr.getAPIKey()
        };
        var request = {
            method: "POST",
            actionType: "/me/zeenkers"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                var users = angular.fromJson(res.data);
                def.resolve(users);
            } else if (res.status == 404) {
                def.resolve(null);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.core.razorpay').factory('RazorSvr', RazorSvr);
RazorSvr.$inject = ["$q", 'RemoteService', 'ProfileSvr', "AppUtil"];

function RazorSvr($q, RemoteService, ProfileSvr, AppUtil) {

    var self = this;
    self.options = {
        // description: 'Credits towards consultation',
        //image: 'https://i.imgur.com/3g7nmJC.png',
        currency: 'INR',
        name: "Zeenka Dating",
        key: 'rzp_live_ZYPtkQUisHAyBJ',
        // amount: '5000',
        // name: 'foo',
        prefill: {
            // email: 'pranav@razorpay.com',
            // contact: '8879524924',
            // name: 'Pranav Gupta'
        },
        theme: {
            color: '#5BA4D9'
        }
    };
    self.called = false;

    self.openPaymentPage = function(order) {

        var def = $q.defer();

        options = angular.copy(self.options);
        options.description = 'Premium User';
        options.amount = order.amount * 100;
        // options.amount = 2 * 100;
        options.name = 'Zeenka Dating';
        options.prefill.email = order.email;
        options.prefill.contact = order.phone;
        // options.prefill.name = 'Pranav Gupta';

        if (!self.called) {
            RazorpayCheckout.open(options, function(res) {
                self.called = false;
                    def.resolve(res);
                },
                function(res) {
                    self.called = false;
                    def.reject(res);
                });
            self.called = true;
        }

        return def.promise;
    }

    self.successCallback = function(payment_id) {
        alert('payment_id: ' + payment_id);
        self.called = false
    };

    self.cancelCallback = function(error) {
        alert(error.description + ' (Error ' + error.code + ')');
        self.called = false
    };

    return self;

};

angular.module('app.core.refdata').service('RefDataService', RefDataService);

RefDataService.$inject = ['$q', '$http', 'RefData', 'RemoteService'];

function RefDataService($q, $http, RefData, RemoteService) {

    var _self = this;
    _self.data = {};
    _self.statelist = [];
    _self.stateCity = {};

    _self.init = function() {

        var def = $q.defer();
        var data = {
            "reqData": {
                "RefType": 'All'
            }
        };

        var request = {
            method: "POST",
            actionType: "/references"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status != 200) {
                def.reject(res.message);
            } else {
                _self.getStateList();
                _self.data = angular.fromJson(res.data);
                def.resolve(_self.data);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    _self.getTC = function() {

        var def = $q.defer();

        if (_self.tc !== undefined) {
            setTimeout(function() {
                def.resolve(_self.tc);
            }, 300);
        } else {

            var data = {
                "reqData": {
                    "Get": 'TC'
                }
            };

            var request = {
                method: "POST",
                actionType: "/references"
            };

            RemoteService.invokeRemoteAction(request, data).then(function(res) {
                if (res.status != 200) {
                    def.reject(res.message);
                } else {
                    _self.tc = res.data;
                    def.resolve(_self.tc);
                }
            }, function(res) {
                def.reject(res.message);
            });
        }


        return def.promise;
    }

    _self.getStateList = function() {

        var def = $q.defer();

        if (_self.statelist.length > 0) {
            setTimeout(function() {
                def.resolve(_self.statelist);
            }, 500);
        } else {
            var data = {
                "reqData": {
                    "type": 'state'
                }
            };

            var request = {
                method: "POST",
                actionType: "/location"
            };

            RemoteService.invokeRemoteAction(request, data).then(function(res) {
                if (res.status != 200) {
                    def.reject(res.message);
                } else {
                    _self.statelist = angular.fromJson(res.data);
                    def.resolve(angular.fromJson(res.data));
                }
            }, function(res) {
                def.reject(res.message);
            });
        }

        return def.promise;
    }

    _self.getCityList = function(state) {

        var def = $q.defer();

        if (_self.stateCity[state]) {
            setTimeout(function() {
                def.resolve(_self.stateCity[state]);
            }, 500);
        } else {

            var data = {
                "reqData": {
                    "type": 'city',
                    "state": state
                }
            };

            var request = {
                method: "POST",
                actionType: "/location"
            };

            RemoteService.invokeRemoteAction(request, data).then(function(res) {
                if (res.status != 200) {
                    def.reject(res.message);
                } else {
                    _self.stateCity[state] = angular.fromJson(res.data);
                    def.resolve(angular.fromJson(res.data));
                }
            }, function(res) {
                def.reject(res.message);
            });
        }

        return def.promise;
    }

    _self.getEducation = function() {
        if (_self.data) {
            return _self.data.Education;
        } else {
            return RefData.Education;
        }
    }

    _self.getHereFor = function() {
        if (_self.data) {
            return _self.data.HereFor;
        } else {
            return RefData.HereFor;
        }
    }

    _self.getReligion = function() {
        if (_self.data) {
            return _self.data.Religion;
        } else {
            return null;
        }
    }

    _self.getCaste = function() {
        if (_self.data) {
            return _self.data.Caste;
        } else {
            return null;
        }
    }

    _self.getHeight = function() {
        if (_self.data) {
            return _self.data.Height;
        } else {
            return RefData.Height;
        }
    }

    _self.getSmoking = function() {
        if (_self.data) {
            return _self.data.Smoking;
        } else {
            return RefData.Smoking;
        }
    }

    _self.getIncome = function() {
        if (_self.data) {
            return _self.data.Income;
        } else {
            return RefData.Income;
        }
    }

    _self.getBodytype = function() {
        if (_self.data) {
            return _self.data.Bodytype;
        } else {
            return RefData.Bodytype;
        }
    }

    _self.getDiet = function() {
        if (_self.data) {
            return _self.data.Diet;
        } else {
            return RefData.Diet;
        }
    }

    _self.getDrinking = function() {
        if (_self.data) {
            return _self.data.Drinking;
        } else {
            return RefData.Drinking;
        }
    }

    _self.getEmployment = function() {
        if (_self.data) {
            return _self.data.Employment;
        } else {
            return RefData.Employment;
        }
    }

    _self.getStatus = function() {
        if (_self.data) {
            return _self.data.Status;
        } else {
            return RefData.Status;
        }
    }

    _self.getHoroscope = function() {
        if (_self.data) {
            return _self.data.Horoscope;
        } else {
            return RefData.Horoscope;
        }
    }

    _self.getLanguage = function() {
        if (_self.data) {
            return _self.data.Language;
        } else {
            return RefData.Language;
        }
    }
}

angular.module('app.core.appconf').factory('AppConf', AppConf);

AppConf.$inject = ["SysConfig", "$q", "AppUtil", "AppParam", "$http", "$ionicPopup"];

function AppConf(SysConfig, $q, AppUtil, AppParam, $http, $ionicPopup) {

    var _self = this;
    _self.appID = "com.org.zeenkamobile";
    _self.MyAppCache = null;
    _self.country = "India";

    _self.init = function() {
        // Read Configuaration and Local Storage Data
        var defer = $q.defer();

        var options = {
            enableHighAccuracy: false
        };

        navigator.geolocation.getCurrentPosition(function(position) {

            $http.get('http://maps.googleapis.com/maps/api/geocode/json?latlng=' +
                    parseFloat(position.coords.latitude) + ',' + parseFloat(position.coords.longitude) + '&sensor=true')
                .success(function(data, status, headers, config) {
                    _self.formatted = data.results[data.results.length - 1].formatted_address;
                    _self.formatted = _self.formatted.split(', ');
                    _self.country = _self.formatted[_self.formatted.length - 1].trim();
                })
                .then(function(result) {
                    console.log("Data:" + result);
                });

        }, function(err) {
            console.log("Error:" + err);
        }, options);

        if (_self.MyAppCache === null) {
            _self.MyAppCache = SysConfig;

            _self.getLatestAPK().then(function(res) {
                if (res !== undefined && res.app_version !== undefined &&
                    res.app_version.replace(/[.]/g, '') > _self.getVersion().replace(/[.]/g, '')) {
                    AppUtil.hideLoading();
                    $ionicPopup.alert({
                        title: 'Time to update',
                        template: "New update is available. We've added some great features just for you. ",
                        okText: "Update"
                    }).then(function() {
                        window.location.href = "market://details?id=" + _self.appID;
                        setTimeout(function() {
                            ionic.Platform.exitApp();
                        }, 3000);
                    })

                } else {
                    defer.resolve();
                }
            }, function() {
                defer.resolve();
            });

            // $http.get("https://play.google.com/store/apps/details?id=" + _self.appID + "&hl=en", {
            //         params: null
            //     })
            //     .success(function(data) {

            //         if (data !== undefined) {
            //             versions = new DOMParser().parseFromString(data, "text/html").querySelectorAll('div[itemprop="softwareVersion"]');
            //             if (versions.length > 0) {
            //                 var newVer = versions[0].innerHTML.trim();
            //                 if (newVer != _self.getVersion()) {
            //                     window.location.href = "market://details?id=" + _self.appID;
            //                 } else {
            //                     defer.resolve();
            //                 }
            //             }
            //         }
            //         defer.resolve();
            //     })
            //     .error(function(data) {
            //         defer.reject();
            //     });
        }
        if (window.device) {
            _self.setIMEI(window.device.uuid);
        }

        return defer.promise;
    };

    _self.getLatestAPK = function() {

        var def = $q.defer();
        var data = {
            "reqData": {
                "Get": 'LatestApp',
                "type": ionic.Platform.platform(),
                "api_level": ionic.Platform.version()
            }
        };

        var request = {
            method: "POST",
            url: _self.getFullUrl() + "/references",
            data: encodeURIComponent(JSON.stringify(data)),
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json; charset=UTF-8'
            }
        };

        $http(request).then(function(res) {
            if (res.data.status != 200) {
                def.reject(res.data.message);
            } else {
                def.resolve(angular.fromJson(res.data.data));
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    _self.isLogin = function() {
        if (AppUtil.isNotNull(_self.getUserName()) || AppUtil.isNotNull(_self.getUserToken())) {
            return true;
        } else {
            return false;
        }
    }

    _self.getFeedBack = function() {
        if (!_self.getLSItems("user_reviwed")) {
            AppUtil.confirm("<div layout='row' layout-align='center center'><rating max='5'></rating></div>", "Feedback").then(function(res) {
                window.location.href = "market://details?id=" + _self.appID;
                _self.setLSItems("user_reviwed", true);
            })
        }
    }

    _self.getLoginRequest = function() {
        var param = null;
        if (AppUtil.isNotNull(_self.getUserToken()) && AppUtil.isNotNull(_self.getUserName())) {
            param = {
                "zUser": _self.getUserName(),
                "zApiKey": _self.getUserToken()
            }
        }
        if (param) {
            return param;
        } else {
            // $state.go("app.login");
            return null;
        }
    }

    _self.removeLoginParam = function() {
        _self.setLSItems("app.Username", null);
        _self.setLSItems("app.Token", null);
    }

    _self.getFullUrl = function() {
        return ("http://" + _self.getByName("app.AppServerUrl") + ":" + _self.getByName("app.AppServerPort") +
            _self.getByName("app.AppServerWSURL"));
    }

    _self.getSocketFullUrl = function() {
        return ("ws://" + _self.getByName("app.AppServerUrl") + ":" + _self.getByName("app.AppServerPort"));
    }

    _self.getGCMSenderNumber = function() {
        return _self.getByName("app.GCMServerID");
    }

    _self.getLocationPushInterval = function() {
        return _self.getByName("app.locationpush.interval");
    }

    _self.setLSItems = function(name, value) {
        // TODO Set Local Storage Items
        if (name) {
            localStorage.setItem(name, value);
        }
    }

    _self.getGPLAuth = function() {
        _self.getLSItems('zeenka_gpl_auth');
    }

    _self.getLSItems = function(name) {
        // TODO Set Local Storage Items
        if (name) {
            return localStorage.getItem(name);
        }
        return null;
    }

    _self.getAppInstance = function() {
        return _self.getLSItems("app.APP_INSTANCE_ID");
    }

    _self.setAppInstance = function(value) {
        return _self.setLSItems("app.APP_INSTANCE_ID", value);
    }

    _self.setUserName = function(value) {
        return _self.setLSItems("app.Username", value);
    }

    _self.setUserToken = function(value) {
        return _self.setLSItems("app.Token", value);
    }

    _self.setUserID = function(value) {
        return _self.setLSItems("app.UserID", value);
    }

    _self.getUserID = function() {
        return _self.getLSItems("app.UserID");
    }

    _self.getUserName = function() {
        return _self.getLSItems("app.Username");
    }

    _self.getUserToken = function() {
        return _self.getLSItems("app.Token");
    }

    _self.isBeta = function() {
        return AppParam["app.isBeta"];
    }

    _self.getAppName = function() {
        return AppParam["app.APPID"];
    }

    _self.getDBName = function() {
        return AppParam["app.DBName"];
    }

    _self.getVersion = function() {
        var installedVersion = _self.getLSItems("app.Version");
        if (installedVersion) {
            return installedVersion;
        } else {
            return AppParam["app.Version"];
        }
    }

    _self.getAppVersion = function() {
        return AppParam["app.Version"];
    }

    _self.getRole = function() {
        return _self.getByName("app.Role");
    }

    _self.getLang = function() {
        return _self.getByName("app.Lang");

    }

    _self.getClient = function() {
        return _self.getByName("app.Client");
    }

    _self.getWarehouse = function() {
        return _self.getByName("app.Warehouse");
    }

    _self.getOrg = function() {
        return _self.getByName("app.Org");
    }

    _self.getStage = function() {
        return _self.getByName("app.Stage");
    }

    _self.getByName = function(Name) {
        var obj = [];
        if (Name != null) {
            angular.forEach(_self.MyAppCache, function(Obj) {
                if (Obj.name == Name) {
                    this.push(Obj.value);
                }
            }, obj);
            if (obj.length > 0)
                return obj[0];
            else

                return null;
        }
    }

    _self.getByID = function(ID) {
        var obj = [];

        if (Name != null) {
            angular.forEach(_self.MyAppCache, function(Obj) {
                if (obj.ad_sysconfig_id == ID) {
                    this.push(Obj.value);
                }

            }, obj);
            if (obj.length > 0)
                return obj[0];
            else
                return null;
        } else {
            return null;
        }
    }

    _self.getDefaultSysCong = function() {
        return _self.MyAppCache;
    }

    _self.setIMEI = function(imei) {
        _self.imei = imei;
    }

    _self.getIMEI = function() {
        if (angular.isDefined(_self.imei)) {
            return _self.imei;
        } else {
            return ("VijayNew");
        }
    }

    return _self;
}

angular.module('app.core.appinit').service('AppInit', AppInit);

AppInit.$inject = ["$q", "$state", "AppConf", "DBSvc", "AD_SysConfig",
    "AppUtil", 'ProfileSvr', "FileSvr", "ZLogin", "RefDataService"
];

function AppInit($q, $state, AppConf, DBSvc, AD_SysConfig, AppUtil, ProfileSvr, FileSvr,
    ZLogin, RefDataService) {

    console.log("App init");

    var _self = this;
    _self.init = function() {

        AppUtil.showLoading();
        AppConf.init().then(function(res) {
            FileSvr.init();
            DBSvc.init().then(function() {
                AD_SysConfig.init();
                RefDataService.init().then(function() {
                    ZLogin.init();
                }, function(res) {
                    AppUtil.confirm('Sorry, We are not able to connect to server. Please check your internet connection or try later.',
                        'Oops !! Something Went Wrong').then(function() {
                        ionic.Platform.exitApp();
                    }, function() {
                        ionic.Platform.exitApp();
                    });
                });

            });
        }, function() {
            ionic.Platform.exitApp();
        });
    };
}

angular.module('app.core.datasync').factory('DataSync', DataSync);

DataSync.$inject = ['RemoteService', 'ProfileSvr', '$q', "AppUtil"];


function DataSync(RemoteService, ProfileSvr, $q, AppUtil) {

    var self = this;
    self.lastsync = [];

    self.Init = function(listner, data, action, count) {
        this.listner = listner;
        this.data = data;
        this.action = action;

        if (count)
            this.count = count;
        else
            this.count = 0;
    }

    self.isSync = function(listner) {

        if (self.lastsync[listner.table]) {
            var endTime = new Date();
            var timeDiff = endTime - self.lastsync[listner.table];
            // strip the miliseconds
            timeDiff /= 1000;
            // remove seconds from the date
            timeDiff = Math.floor(timeDiff / 60);
            // get minutes
            var minutes = Math.round(timeDiff % 60);
            if (minutes > (listner.syncTimeOut != undefined ? listner.syncTimeOut : 10)) {
                return true;
            } else {
                return false;
            }

        }
        return true;
    }

    self.removeSyncTime = function(listner) {
        self.lastsync[listner.table] = undefined;
    }

    self.Init.prototype.pullData = function(iscontinue) {

        var _self = this;
        var def = $q.defer();
        if (self.isSync(_self.listner) || iscontinue) {

            var data = {
                "reqData": {
                    "table": _self.listner.table,
                    "offset": (_self.data ? _self.data : 0)
                },
                'loginData': ProfileSvr.getAPIKey()
            };

            var request = {
                method: "POST",
                actionType: "/me/pullData"
            };

            RemoteService.invokeRemoteAction(request, data).then(function(response) {
                var status = response.status;
                var res = {};
                if (status != 200) {
                    res.Error = response.message;
                } else {
                    // var jObject = AppUtil.decodeBase64ToJson(response.Error);
                    var jObject = angular.fromJson(response);
                    self.lastsync[_self.listner.table] = new Date();
                    if (jObject.offset == 0) {
                        _self.listner.list = [];
                    }
                    if (jObject.dataCount > 0 && jObject.params.table) {
                        _self.listner.addArray(angular.fromJson(jObject.data));

                        if (_self.count == 0 || _self.count >= jObject.offset) {
                            _self.data = jObject.offset + 1;
                            _self.pullData(true);
                        }
                    }

                    def.resolve(res);
                }
                if (res.Error) {
                    def.reject(res);
                }
            });
        } else {
            setTimeout(function() {
                def.resolve();
            }, 0);
        }

        return def.promise;;
    };

    self.Init.prototype.pushData = function() {

        var _self = this;
        var deferred = $q.defer();

        var data = {
            "reqData": {
                "table": _self.listner.table,
                "action": _self.action,
                "data": _self.data
            },
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/pushData"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(response) {
            var status = response.status;
            var res = {};
            if (status != 200) {
                res.Error = response.message;
            } else {
                var jObject = angular.fromJson(response);
                jObject = angular.fromJson(jObject.data);
                // _self.listner.afterPush(jObject);
                deferred.resolve(jObject);
            }
            if (res.Error) {
                deferred.reject(res);
            }
        });

        return deferred.promise;
    };

    return self;



    // _self.parseError = function(jsonObj) {
    //     var errorLis = [];
    //     var type = typeof jsonObj
    //     if (type == "object") {
    //         for (var key in jsonObj) {
    //             if (key == "Error") {
    //                 errorLis.push(jsonObj);
    //             } else {
    //                 angular.merge(errorLis, _self.parseError(jsonObj[key]));
    //             }
    //         }
    //     } else {
    //         // Do something with data
    //     }
    //     return errorLis;
    // }

    // _self.attachData = function(Data) {
    //     var deferred;
    //     if (!deferred) {
    //         deferred = $q.defer();
    //     }
    //     // Data Shuld be like below 
    //     // "Data": [ { "Table": "","Rows": [{"UU": "","AlwaysAdd": "Y","Attachments": [{"Content": "",
    //     // "FileName": "varTest.text" } ] } ] } ]

    //     var actualDat = {};
    //     actualDat.AppInstanceUU = AppConf.getAppInstance();
    //     actualDat.Data = [];
    //     angular.merge(actualDat.Data, Data);

    //     console.log(angular.toJson(actualDat));

    //     var data = {
    //         "ModelRunProcessRequest": {
    //             "ModelRunProcess": {
    //                 "serviceType": "SyncAttachment",
    //                 "ParamValues": {
    //                     "field": [{
    //                         "@column": "AttachmentJson",
    //                         "val": AppUtil.encodeJsonTOBase64(actualDat)
    //                     }]
    //                 }
    //             }
    //         }
    //     };

    //     var request = {
    //         method: "POST",
    //         actionType: "/run_process"
    //     };

    //     RemoteService.invokeRemoteAction(request, data).then(function(response) {
    //         var error = response["@IsError"];
    //         var res = {};
    //         if (error == "true") {
    //             console.log(response.Error);
    //             res.Error = response.Error;
    //         } else {
    //             var jObject = AppUtil.decodeBase64ToJson(response.Error);
    //             if (jObject.Error) {
    //                 console.log(jObject.Error);
    //             } else {
    //                 if (jObject.Data.length > 0) {
    //                     // TODO Do anything with response data
    //                 } else {
    //                     deferred.resolve(res);
    //                 }
    //             }
    //         }
    //         if (res.Error) {
    //             deferred.reject(res);
    //         }
    //     });
    //     return deferred.promise;
    // };


}

angular.module('app.core.db').service('DBSvc', DBSvc);

DBSvc.$inject = ["$q", "DB_CONFIG", "AppConf", "$cordovaSQLite"];

function DBSvc($q, DB_CONFIG, AppConf, $cordovaSQLite) {
    var self = this;
    self.dbInstance = null;

    self.SQLError = {
        'UNKNOWN_ERR': 0,
        'DATABASE_ERR': 1,
        'VERSION_ERR': 2,
        'TOO_LARGE_ERR': 3,
        'QUOTA_ERR': 4,
        'SYNTAX_ERR': 5,
        'CONSTRAINT_ERR': 6,
        'TIMEOUT_ERR': 7
    };

    self.errorHandler = function(res) {
        var msg = "";
        switch (res.code) {
            case self.SQLError.DATABASE_ERR:
                msg = "Database Error";
                break;
            case self.SQLError.VERSION_ERR:
                msg = "Version Error";
                break;
            case self.SQLError.TOO_LARGE_ERR:
                msg = "Too Large Error";
                break;
            case self.SQLError.QUOTA_ERR:
                msg = "Quota Error";
                break;
            case self.SQLError.SYNTAX_ERR:
                msg = "Syntax Error";
                break;
            case self.SQLError.CONSTRAINT_ERR:
                msg = "Constraint Error";
                break;
            default:
                msg = "Unknown Error";
                break;
        }
        return msg;
    }

    self.init = function() {
        console.log("Initialize Application");
        if (window.cordova) {
            self.dbInstance = $cordovaSQLite.openDB({
                name: AppConf.getDBName(),
                location: 1
            });
        } else {
            self.dbInstance = window.openDatabase(AppConf.getDBName(), "", "database", -1);
        }

        var promArray = [];
        angular.forEach(DB_CONFIG.tables, function(tablesql) {
            var def = $q.defer();
            promArray.push(def.promise);
            self.query(tablesql).then(function(res) {
                def.resolve(res);
            }, function(res) {
                def.reject(res);
            });
        });

        return $q.all(promArray);
    };

    self.fetchAll = function(result) {
        var output = [];

        if (result) {
            for (var i = 0; i < result.rows.length; i++) {
                output.push(result.rows.item(i));
            }
        }

        return output;
    };

    self.fetch = function(result) {
        return result.rows.item(0);
    };

    self.query = function(query, bindings) {

        bindings = typeof bindings !== 'undefined' ? bindings : [];
        var deferred = $q.defer();

        if (self.dbInstance) {
            self.dbInstance.transaction(function(transaction) {
                transaction.executeSql(query, bindings, function(transaction, result) {
                    deferred.resolve(result);
                    console.log(query + "--------" + result);
                }, function(transaction, error) {
                    console.log(query + "--------" + angular.toJson(error));
                    error.Error = self.errorHandler(error);
                    deferred.reject(error);
                    console.log(query + "--------" + angular.toJson(error));
                });
            });
        } else {
            setTimeout(function() {
                deferred.resolve(null);
            }, 50);
        }
        return deferred.promise;
    };

    self.isDataExist = function(tableName, value) {
        var deferred = $q.defer();
        if (value) {
            var selectsql = "SELECT " + tableName + "_uu FROM " + tableName + " WHERE " + tableName + "_uu = ?";
            self.query(selectsql, [value]).then(function(rs) {
                if (rs.rows.length > 0)
                    deferred.resolve(true);
                else
                    deferred.resolve(false);
            });
        } else {
            deferred.resolve(false);
        }
        return deferred.promise;
    };

    self.removeRecordByTableID = function(tableName, value) {
        if (value) {
            var selectsql = "Delete * from " + tableName + " WHERE " + tableName + "_uu = ?";
            return self.query(selectsql, [value]);
        }
    };

    self.addTableRow = function(tableName, row) {
        var params = [],
            paramStr = [],
            paramKeys = [];
        var keys = Object.keys(row);
        angular.forEach(keys, function(key, index) {
            if (key === "$$hashKey") {} else {
                params.push(row[key]);
                paramStr.push("?");
                paramKeys.push(key);
            }
        });
        var sql = "Insert into " + tableName + " (" + paramKeys.join(',') + ") Values (" + paramStr.join(',') + ")";
        return self.query(sql, params);
    };

    self.addTableRowByColumn = function(tableName, columns, row) {
        var params = [],
            paramStr = [],
            paramKeys = [];
        var keys = Object.keys(row);
        angular.forEach(keys, function(key, index) {

            if (key === "$$hashKey" || columns.indexOf(key) < 0) {
                // Skip to add 
            } else {
                params.push(row[key]);
                paramStr.push("?");
                paramKeys.push(key);
            }
        });
        var sql = "Insert into " + tableName + " (" + paramKeys.join(',') + ") Values (" + paramStr.join(',') + ")";
        return self.query(sql, params);
    };

    self.updateTableRow = function(tableName, row) {
        var paramStr = [];
        var idColumn = tableName + "_uu";
        var param = [];
        var keys = Object.keys(row);
        angular.forEach(keys, function(key, index) {
            if (key === "$$hashKey") {} else {
                paramStr.push(key + "= ? ");
                param.push(row[key]);
            }
        });

        param.push(row[idColumn]);

        var sql = "Update " + tableName + " set " + paramStr.join(',') + " WHERE " + idColumn + " = ? ";
        return self.query(sql, param);
    };
    /*return self;*/
}

angular.module('app.core.fs').service('FileSvr', FileSvr);

FileSvr.$inject = ["$q", "base64", "$cordovaFile"];

function FileSvr($q, base64, $cordovaFile) {

    var self = this;
    self.root = null;
    self.msgFileName = 'donotdelete_msg.json';

    self.init = function() {
        console.log("Initialize File Storage");
        // TODO
        // if ($cordovaFile && window.cordova) {
        //     if (!$cordovaFile.checkDir(cordova.file.applicationStorageDirectory, AppConf.getAppName())) {
        //         $cordovaFile.createDir(cordova.file.applicationStorageDirectory, AppConf.getAppName(), false)
        //             .then(function(success) {
        //                 console.log(angular.toJson(success));
        //             }, function(error) {
        //                 console.log(error);
        //             });
        //     }
        // }
    };

    // self.moveFile = function(oldname, newname) {

    //     var def = $q.defer();
    //     if ($cordovaFile && window.cordova) {
    //         $cordovaFile.moveFile(cordova.file.externalCacheDirectory,
    //                 oldname, cordova.file.applicationStorageDirectory + AppConf.getAppName() + "/", newname)
    //             .then(function(success) {
    //                 self.readAsDataURL(success.name).then(function(res) {
    //                     success.imageData = res;
    //                     def.resolve(success);
    //                 }, function(res) {
    //                     def.reject(res);
    //                 });
    //             }, function(error) {
    //                 def.reject(error);
    //             });
    //     } else {
    //         def.reject();
    //     }

    //     return def.promise;
    // }

    self.getCacheImage = function(file) {
        return self.readAsDataURL(cordova.file.cacheDirectory, file);
    }

    self.getImage = function(file) {
        return self.readAsDataURL(cordova.file.dataDirectory, file);
    }

    self.readAsDataURL = function(path, file) {

        var def = $q.defer();

        if ($cordovaFile && window.cordova) {
            $cordovaFile.readAsDataURL(path,
                    file)
                .then(function(success) {
                    def.resolve(success);
                }, function(error) {
                    def.reject();
                });
        }

        return def.promise;
    }

    self.createCacheImage = function(filename, data) {

        var def = $q.defer();
        data = data.replace(/data:image\/(png|jpg|jpeg);base64,/, '');
        data = base64.imageDecode(data);
        if ($cordovaFile && window.cordova) {
            $cordovaFile.writeFile(cordova.file.cacheDirectory,
                    filename, data, false)
                .then(function(success) {
                    def.resolve();
                }, function(error) {
                    def.reject();
                });
        } else {
            def.resolve();
        }

        return def.promise;
    }

    self.createCacheImage = function(filename, data) {

        var def = $q.defer();
        data = data.replace(/data:image\/(png|jpg|jpeg);base64,/, '');
        data = base64.imageDecode(data);
        if ($cordovaFile && window.cordova) {
            $cordovaFile.writeFile(cordova.file.cacheDirectory,
                    filename, data, false)
                .then(function(success) {
                    def.resolve();
                }, function(error) {
                    def.reject();
                });
        } else {
            def.resolve();
        }

        return def.promise;
    }

    self.createImage = function(filename, data) {

        var def = $q.defer();
        data = data.replace(/data:image\/(png|jpg|jpeg);base64,/, '');
        data = base64.imageDecode(data);
        if ($cordovaFile && window.cordova) {
            $cordovaFile.writeFile(cordova.file.dataDirectory,
                    filename, data, false)
                .then(function(success) {
                    def.resolve();
                }, function(error) {
                    def.reject();
                });
        } else {
            def.resolve();
        }

        return def.promise;
    }


    self.getUserFileMsgs = function() {

        var def = $q.defer();
        if ($cordovaFile && typeof cordova !== 'undefined') {
            $cordovaFile.checkFile(cordova.file.dataDirectory, self.msgFileName).then(
                function(success) {
                    $cordovaFile.readAsText(cordova.file.dataDirectory, self.msgFileName).then(
                        function(data) {
                            def.resolve(JSON.parse(data));
                        },
                        function(error) {
                            def.resolve([]);
                        });
                },
                function(error) {
                    def.resolve([]);
                }
            );
        } else {
            setTimeout(function() {
                def.resolve([]);
            }, 0);
        }
        return def.promise;
    };

    self.writeUserFileMsgs = function(msgs) {

        var def = $q.defer();
        if ($cordovaFile && typeof cordova !== 'undefined') {
            $cordovaFile.writeFile(cordova.file.dataDirectory, self.msgFileName, JSON.stringify(msgs), true).then(
                function(success) {
                    def.resolve(msgs);
                },
                function(error) {
                    def.resolve(msgs);
                });

        } else {
            setTimeout(function() {
                def.resolve(msgs);
            }, 0);
        }
        return def.promise;
    };

    // self.createAndWriteFile = function(filename, data) {

    //     var def = $q.defer();
    //     data = data.replace(/data:image\/(png|jpg|jpeg);base64,/, '');
    //     data = base64.imageDecode(data);
    //     if ($cordovaFile && window.cordova) {
    //         $cordovaFile.writeFile(cordova.file.externalRootDirectory + AppConf.getAppName(),
    //                 filename, data, false)
    //             .then(function(success) {
    //                 def.resolve();
    //             }, function(error) {
    //                 def.reject();
    //             });
    //     } else {
    //         def.resolve();
    //     }

    //     return def.promise;
    // }
}

angular.module('app.core.fnotification')
    .factory('ZFCMPushFactory', ZFCMPushFactory)
    .config(function($ionicCloudProvider) {
        $ionicCloudProvider.init({
            "core": {
                "app_id": "9f4c0097"
            },
            "push": {
                "sender_id": "180862704514",
                "pluginConfig": {
                    "ios": {
                        "badge": true,
                        "sound": true
                    },
                    "android": {
                        "iconColor": "#343434"
                    }
                }
            }
        });
    });

ZFCMPushFactory.$inject = ['$q', '$rootScope', '$ionicPush', '$cordovaDevice', 'RemoteService', 'ProfileSvr', 'AppConf', '$state'];

function ZFCMPushFactory($q, $rootScope, $ionicPush, $cordovaDevice, RemoteService, ProfileSvr, AppConf, $state) {

    var _self = this;

    _self.init = function() {

        if (typeof PushNotification == "undefined")
            return null;

        //Error handler
        if (!$rootScope.$$listeners.hasOwnProperty("cloud:push:error")) {
            $rootScope.$on('cloud:push:error', function(event, error) {
                console.log("notification error occured");
                console.log("event : ", event);
                console.log("error : ", error);
            });
        }

        //Notification handler
        if (!$rootScope.$$listeners.hasOwnProperty("cloud:push:notification")) {
            $rootScope.$on('cloud:push:notification', function(event, notification) {
                //alert('message = ' + notification.message.text + ' msgTitle = ' + notification.message.title);
                // var state = notification.message.payload.$state;
                // var stateparam = {};
                // if (notification.message.payload.stateparam) {
                //     stateparam = JSON.parse(notification.message.payload.stateparam);
                // }
                // console.log("State:" + state);
                // console.log("StateParam:" + JSON.stringify(stateparam));
                // if (typeof state != 'undefined') {
                //     //Redirect to specified state
                //     $state.go(state, stateparam);
                // }
            });
        }

        var isRegistered = window.localStorage.getItem("pushRegistered");
        isRegistered = false;
        if (!isRegistered) {
            $ionicPush.register({
                canShowAlert: false, //Can pushes show an alert on your screen?
                canSetBadge: true, //Can pushes update app icon badges?
                canPlaySound: true, //Can notifications play a sound?
                canRunActionsOnWake: true, //Can run actions outside the app,
                onNotification: function(notification) {
                    // Handle new push notifications here
                    console.log("onNotification::" + notification);
                    return true;
                }
            }).then(function(deviceToken) {
                return $ionicPush.saveToken(deviceToken);
            }).then(function(deviceToken) {
                console.log('Token saved:', deviceToken.token);
                var deviceInfo = {
                    device_token: deviceToken.token,
                    device_uu: $cordovaDevice.getUUID(),
                    device_type: $cordovaDevice.getPlatform()
                }
                _self.registerOnServer(deviceInfo).then(function(response) {
                    // alert('registered!');
                    window.localStorage.setItem("pushRegistered", "true");
                });
            });
        }
    };

    _self.registerOnServer = function(rdata) {

        var def = $q.defer();
        var data = {
            "reqData": rdata,
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/device"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status != 200) {
                def.reject(res.message);
            } else {
                def.resolve(res.data);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return _self;

};

angular.module('app.core.fortumo').factory('FortumoSvr', FortumoSvr);
FortumoSvr.$inject = ["$q", 'RemoteService', 'ProfileSvr', "AppUtil"];

function FortumoSvr($q, RemoteService, ProfileSvr, AppUtil) {

    var self = this;

    self.getSIG = function(text) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "txt": text
            },
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/order/fortumoSig"
        };
        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status == 200) {
                def.resolve(res.data);
            } else {
                def.reject(res.message);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return self;

};

angular.module('app.core.geolocation')
    .service('ZGeolocation', ZGeolocation);

ZGeolocation.$inject = ['$q', '$cordovaGeolocation', 'RemoteService', 'ProfileSvr', 'AppConf', "AppUtil"];

function ZGeolocation($q, $cordovaGeolocation, RemoteService, ProfileSvr, AppConf, AppUtil) {

    var _self = this;
    _self.defInterval = AppConf.getLocationPushInterval();
    if (!_self.defInterval) {
        _self.defInterval = 600000;
    }

    //Store current position
    _self.currentPosition = {
        lat: 0,
        lon: 0
    };

    var options = {
        enableHighAccuracy: true,
        timeout: 5 * 1000,
        maximumAge: 0
    };

    //Get current position, save to server as well as service properties
    _self.init = function(interval) {

        if (!_self.initialized) {
            if (!interval) {
                interval = _self.defInterval
            }
            var geoLocationInterval = window.localStorage.getItem("locationInterval");
            if (geoLocationInterval != null && geoLocationInterval != "") {
                clearInterval(geoLocationInterval);
            }
            geoLocationInterval = setInterval(function() {
                _self.getUpdatedLocation();
            }, interval);
            window.localStorage.setItem("locationInterval", "" + geoLocationInterval);
            _self.getUpdatedLocation();
            _self.initialized = true;
        }
    };

    _self.getUpdatedLocation = function() {

        navigator.geolocation.getCurrentPosition(function(position) {

            _self.currentPosition.lat = parseFloat(position.coords.latitude);
            _self.currentPosition.lon = parseFloat(position.coords.longitude);

            saveOnServer(_self.currentPosition).then(function(response) {}, function(err) {
                console.log("Error:" + err);
            });

        }, function(err) {
            console.log("Error:" + err);
        }, options);

        // navigator.geolocation.getCurrentPosition(options)
        //     .then(function(position) {
        //         _self.currentPosition.lat = position.coords.latitude;
        //         _self.currentPosition.lon = position.coords.longitude;
        //         saveOnServer(_self.currentPosition).then(function(response) {}, function(err) {
        //             console.log("Error:" + err);
        //         });
        //     }, function(err) {
        //         console.log("Error:" + err);
        //     });
    }

    var saveOnServer = function(position) {
        var def = $q.defer();
        var data = {
            "reqData": position,
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/update/location"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status != 200) {
                def.reject(res.message);
            } else {
                def.resolve(res.data);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    };

    return _self;
}

angular.module('app.core.service').service('AuthService', AuthService);

AuthService.$inject = ['$q', '$http', 'AppConf', 'RemoteService'];


function AuthService($q, $http, AppConf, RemoteService) {

    var _self = this;
    _self.retriveMeByEmail = function(emailid) {

        var def = $q.defer();
        var data = {
            "reqData": {
                "email": emailid
            }
        };

        var request = {
            method: "POST",
            actionType: "/zuser/exists"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status != 200) {
                def.reject(res.message);
            } else {
                def.resolve(res.data);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }
}

angular.module('app.core.login');
angular.module('app.core.notification')
    .factory('ZPushFactory', ZPushFactory);

ZPushFactory.$inject = ['$q', '$rootScope', '$cordovaPushV5', '$cordovaDevice', 'RemoteService', 'ProfileSvr', 'AppConf', "AppUtil"];

function ZPushFactory($q, $rootScope, $cordovaPushV5, $cordovaDevice, RemoteService, ProfileSvr, AppConf, AppUtil) {

    var _self = this;

    _self.init = function() {

        if(typeof PushNotification == "undefined")
            return null;

        //Error handler
        if (!$rootScope.$$listeners.hasOwnProperty("$cordovaPushV5:errorOccurred")) {
            $rootScope.$on('$cordovaPushV5:errorOccurred', function(event, error) {
                console.log("notification error occured");
                console.log("event : ", event);
                console.log("error : ", error);
            });
        }

        //Notification handler
        if (!$rootScope.$$listeners.hasOwnProperty("$cordovaPushV5:notificationReceived")) {
            $rootScope.$on('$cordovaPushV5:notificationReceived', function(event, notification) {
                alert('message = ' + notification.message + ' msgTitle = ' + notification.title);
            });
        }

        var isRegistered = window.localStorage.getItem("pushRegistered");
        if (!isRegistered) {

            $cordovaPushV5.initialize({
                "android": {
                    "clearNotifications": false,
                    "senderID": AppConf.getGCMSenderNumber()
                }
            });

            $cordovaPushV5.register().then(function(deviceToken) {
                var deviceInfo = {
                    device_token: deviceToken,
                    device_uu: $cordovaDevice.getUUID(),
                    device_type: $cordovaDevice.getPlatform()
                }
                _self.registerOnServer(deviceInfo).then(function(response) {
                    // alert('registered!');
                    window.localStorage.setItem("pushRegistered", "true");
                });
                // Below code required to configure $cordovaPushV5 notifications emitter. 
                // Don't pass function it's not handler.
                $cordovaPushV5.onNotification();
                $cordovaPushV5.onError();

                // $ionicLoading.hide();
            }, function(error) {
                console.log("Failed to registered" + error);
                // $ionicLoading.hide();
            });

        } else {
            $cordovaPushV5.onNotification();
            $cordovaPushV5.onError();
        }

    };

    _self.registerOnServer = function(rdata) {

        var def = $q.defer();
        var data = {
            "reqData": rdata,
            'loginData': ProfileSvr.getAPIKey()
        };

        var request = {
            method: "POST",
            actionType: "/me/device"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(res) {
            if (res.status != 200) {
                def.reject(res.message);
            } else {
                def.resolve(res.data);
            }
        }, function(res) {
            def.reject(res.message);
        });

        return def.promise;
    }

    return _self;

};

angular.module('app.core.otpvarify').factory('OTPSvr', OTPSvr);

OTPSvr.$inject = ['RemoteService', 'ProfileSvr', '$q', "AppUtil"];

function OTPSvr(RemoteService, ProfileSvr, $q, AppUtil) {

    var self = this;

    self.sendcode = function(phone, user) {

        var deferred = $q.defer();

        var data = {
            "reqData": {
                "phone": phone,
                "user_id" : user,
                "action": 'sendcode',
            }
        };

        var request = {
            method: "POST",
            actionType: "/me/otpv1"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(response) {
            var status = response.status;
            var res = {};
            if (status != 200) {
                res.Error = response.message;
            } else {

                jObject = angular.fromJson(response.data);
                deferred.resolve(jObject);
            }
            if (res.Error) {
                deferred.reject(res);
            }
        });

        return deferred.promise;
    }

    self.varifyMobile = function(phone) {

        var deferred = $q.defer();

        var data = {
            "reqData": {
                "phone": phone,
                "action": 'varifysend',
            }
        };

        var request = {
            method: "POST",
            actionType: "/me/otpv1"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(response) {
            var status = response.status;
            var res = {};
            if (status != 200) {
                res.Error = response.message;
            } else {
                jObject = angular.fromJson(response.data);
                deferred.resolve(jObject);
            }
            if (res.Error) {
                deferred.reject(res);
            }
        });

        return deferred.promise;
    }

    self.varify = function(code, phone, device) {
        var deferred = $q.defer();

        var data = {
            "reqData": {
                "code": code,
                "phone": phone,
                'device': angular.toJson(device),
                "action": 'validate',
            }
        };

        var request = {
            method: "POST",
            actionType: "/me/otpv1"
        };

        RemoteService.invokeRemoteAction(request, data).then(function(response) {
            var status = response.status;
            var res = {};
            if (status != 200) {
                res.Error = response.message;
            } else {
                jObject = angular.fromJson(response.data);
                deferred.resolve(jObject);
            }
            if (res.Error) {
                deferred.reject(res);
            }
        });

        return deferred.promise;
    }

    return self;
}

(function() {
    'use strict';
    angular.module('app.core.service')
        .service('RemoteService', RemoteService);

    RemoteService.$inject = ['$q', '$log', '$http', 'AppConf', 'AppUtil', "$state"];

    function RemoteService($q, $log, $http, AppConf, AppUtil, $state) {
        var _self = this;
        _self.invokeRemoteAction = function(actionConfig, actionParams) {
            // $log.debug('invokeRemoteAction-->'+actionConfig.actionName, actionParams);
            //Constuct deferred object for return
            var deferred, errorMessage, hasLoginParam = true;
            deferred = $q.defer();

            if (actionParams) {
                var allkeys = Object.keys(actionParams);
                if (allkeys.length > 0) {
                    hasLoginParam = actionParams.hasOwnProperty("loginData");
                    if (!hasLoginParam) {
                        var loginData = AppConf.getLoginRequest();
                        if (loginData != null) {
                            actionParams[allkeys[0]].loginData = loginData;
                        }
                    }
                }
            }

            if (!actionConfig.actionType || typeof actionConfig.actionType !== 'string') {
                errorMessage = "Error - Could not invoke remote action: action type invalid!";
                $log.error(errorMessage);
                deferred.reject(errorMessage);
                return deferred.promise;
            }

            var req = {
                method: actionConfig.method,
                url: getActionURL(actionConfig),
                data: encodeURIComponent(JSON.stringify(getReqData(actionParams)))
            }

            if (actionConfig.dataType) {
                req.dataType = actionConfig.dataType;
                req.headers = {
                    'Accept': 'application/' + actionConfig.dataType,
                    'Content-Type': 'application/' + actionConfig.dataType + '; charset=UTF-8',
                };
            } else if (actionConfig.headers) {
                req.headers = actionConfig.headers;
            } else {
                req.headers = {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json; charset=UTF-8'
                };
            }

            function rejector(response) {
                deferred.reject(response);
                return deferred.promise;
            }

            function resolver(response) {

                var res = response;

                if (res.data.message !== undefined && res.data.message == "Authentication failed" &&
                    !res.config.url.endsWith("/zuser/me")) {
                    
                    $state.go('offline');
                }
                deferred.resolve(res.data);


                return deferred.promise;
            }

            // get data paremeters
            function getReqData(actionParams) {
                // convert array of arguments into object to pass into $http data parameter
                var param = actionParams ? actionParams : {};
                return param;
            }

            //Gets URL from base in respect to method
            function getActionURL(actionConfig) {
                if (actionConfig.actionType) {
                    return AppConf.getFullUrl() + actionConfig.actionType;
                }
                return AppConf.getFullUrl();
            }

            return ($http(req).then(resolver, rejector));
        }

        _self.validateLoginResponse = function(response) {
            if (response.roles == 0) {
                return false;
            } else {
                return true;
            }
        }
    }
})();

angular
    .module('app.core.setting')
    .factory('AD_SysConfig', AD_SysConfig);

AD_SysConfig.$inject = ["DBSvc", "AppConf"];

function AD_SysConfig(DBSvc, AppConf) {

    var _self = this;
    _self.list = [];
    _self.tableName = "user_setting";
    _self.idColumn = "user_setting_id";

    _self.init = function(callback) {
        DBSvc.query("Select * from " + _self.tableName).then(function(result) {
            _self.list = DBSvc.fetchAll(result);
            if (_self.list.length < 1) {
                _self.addArray(AppConf.getDefaultSysCong());
            }
            if (angular.isFunction(callback))
                callback();
        }, function(result) {
            if (angular.isFunction(callback))
                callback();
        });
    }

    _self.all = function() {
        return _self.list;
    }

    _self.remove = function(obj) {
        var sql = "Delete from " + _self.tableName + " WHERE " + _self.idColumn + " = ? ";
        DBSvc.query(sql, [obj[_self.idColumn]]).then(function(result) {
            _self.list.splice(_self.list.indexOf(obj), 1);
        });
    }

    _self.get = function(uuid) {
        for (var i = 0; i < _self.list.length; i++) {
            if (_self.list[i][_self.idColumn] == uuid) {
                return _self.list[i];
            }
        }
        return null;
    }

    _self.add = function(row) {
        DBSvc.addTableRow(_self.tableName, row).then(function(result) {
            _self.list.push(row);
        });
    }

    _self.update = function(row) {
        var obj = row;
        if (obj) {
            DBSvc.updateTableRow(_self.tableName, obj).then(function(result) {
                for (var i = 0; i < _self.list.length; i++) {
                    if (_self.list[i][_self.idColumn] == obj[_self.idColumn]) {
                        _self.list[i] = obj;
                        break;
                    }
                }
            });
        }
    }

    _self.addArray = function(objectList) {
        angular.forEach(objectList, function(object, key) {
            if (_self.get(object[_self.idColumn]) == null) {
                _self.add(object);
            } else {
                _self.update(object);
            }
        });
    }
    return _self;
}

angular.module('app.core.signup');
angular.module('app.core.twitter')
    .factory('authenticationFactory', function() {
        //Initialization auth data
        var self = this;
        self.getAuthentication = function() {
                return self.authToken;
            } //get auth info of current user

        self.setAuthentication = function(authToken) {
                console.log(authToken);
                self.authToken = authToken;
            } //set auth info of current user
        return self;
    }) //authenticationFactory to get and set auth
    .factory('ngTwitter', function($http, $q, $cordovaOauth, twitConst, $cordovaOauthUtility, authenticationFactory) {
        var self = this;
        self.getAuthTwitter = function() {
            var deferred = $q.defer();
            $cordovaOauth.twitter(twitConst.cKey, twitConst.cSecret).then(function(result) {
                authenticationFactory.setAuthentication(result.oauth_token);
                deferred.resolve(result);
            }, function(error) {
                alert(JSON.stringify(error));
                deferred.reject(JSON.stringify(error));
            });
            return deferred.promise;
        };
        self.createTwitterSignature = function(method, url, paramObj, authObject) {
            if (!paramObj) {
                paramObj = {};
            }

            var oauthObject = {
                oauth_consumer_key: twitConst.cKey,
                oauth_nonce: $cordovaOauthUtility.createNonce(10),
                oauth_signature_method: "HMAC-SHA1",
                oauth_token: authObject.oauth_token,
                oauth_timestamp: Math.round((new Date()).getTime() / 1000.0),
                oauth_version: "1.0"
            };

            var signature = $cordovaOauthUtility.createSignature(method, url, oauthObject, paramObj, twitConst.cSecret, authObject.oauth_token_secret);
            $http.defaults.headers.common.Authorization = signature.authorization_header;

            return oauthObject;
        };
        self.getUserInfo = function(user) {
            var deferred = $q.defer();

            self.createTwitterSignature('GET', twitConst.userInfoURL, {
                "user_id": user.user_id,
                "screen_name": user.screen_name
            }, user);

            $http({
                method: "get",
                url: twitConst.userInfoURL,
                params: {
                    "user_id": user.user_id,
                    "screen_name": user.screen_name,
                }
            }).then(function(result) {
                alert(JSON.stringify(result));
                deferred.resolve(result);
            }, function(error) {
                alert(JSON.stringify(error));
                deferred.reject(JSON.stringify(error));
            });
            return deferred.promise;
        };
        self.getFriends = function(user) {
            var deferred = $q.defer();
            self.createTwitterSignature('GET', twitConst.frdsListURL, {
                "user_id": user.user_id,
                "screen_name": user.screen_name
            }, user);
            $http({
                method: "get",
                url: twitConst.frdsListURL,
                params: {
                    "user_id": user.user_id,
                    "screen_name": user.screen_name,
                }
            }).then(function(res) {
                deferred.resolve(res);
            }, function(error) {
                alert(JSON.stringify(error));
                deferred.reject(JSON.stringify(error));
            });
            return deferred.promise;
        };
        self.sendMessage = function(items, message, Object) {
            var defer = $q.defer();
            var defList = [];
            angular.forEach(items, function(value, key) {
                var def = $q.defer();
                defList.push(def);

                self.createTwitterSignature('POST', twitConst.directmsgURL, {
                    "user_id": value.id,
                    "screen_name": value.screen_name,
                    "text": message
                }, Object);

                $http({
                    method: "post",
                    url: twitConst.directmsgURL,
                    params: {
                        "user_id": value.id,
                        "screen_name": value.screen_name,
                        "text": message
                    }
                }).then(function(result) {
                    console.log(JSON.stringify(result));
                    def.resolve(result);
                }, function(error) {
                    console.log(JSON.stringify(error));
                    def.reject(JSON.stringify(error));
                });
            });

            $q.all(defList).then(function(res) {
                defer.resolve(res);
            }, function(res) {
                defer.resolve(res);
            });

            return defer.promise;
        };
        return self;
    });

angular.module('app.core.util').factory('AppUtil', AppUtil);

AppUtil.$inject = ['base64', '$ionicLoading', '$ionicPopup', '$q', '$cordovaDialogs', '$cordovaDevice'];

function AppUtil(base64, $ionicLoading, $ionicPopup, $q, $cordovaDialogs, $cordovaDevice) {

    var _self = this;

    _self.zdevice = null;

    _self.getDevice = function() {
        if (_self.zdevice == null) {
            if (ionic.Platform.isAndroid()) {
                _self.zdevice = $cordovaDevice.getUUID();
            } else {
                _self.zdevice = ionic.Platform.platform() + Math.random();
            };
        }
        return _self.zdevice;
    }

    _self.isNull = function(val) {
        return angular.isUndefined(val) || val === "null" || val === null;
    }

    _self.isNotNull = function(val) {
        return !_self.isNull(val);
    }

    _self.encodeJsonTOBase64 = function(val) {
        return "data:;base64," + base64.encode(angular.toJson(val));
        // return angular.toJson(val);
    }

    _self.decodeBase64ToJson = function(val) {
        return angular.fromJson(base64.decode(val));
        // return angular.fromJson(val);
    }

    _self.getCredentialObj = function(obj) {

        if (obj.fbuserid)
            return md5(obj.email + ' ~ ' + obj.fbuserid).toString();
        else
            return md5(_self.getDevice() + ' ~ ' + obj.mobile).toString();
    }

    _self.showLoading = function() {
        $ionicLoading.show({
            template: 'Loading...',
            hideOnStateChange: true,
            duration: 60000
        });
    }

    _self.hideLoading = function() {
        $ionicLoading.hide();
    }

    _self.XML2jsobj = function(node) {

        var data = {};

        function Add(name, value) {
            if (data[name]) {
                if (data[name].constructor != Array) {
                    data[name] = [data[name]];
                }
                data[name][data[name].length] = value;
            } else {
                data[name] = value;
            }
        };

        var c, cn;
        for (c = 0; cn = node.attributes; c++) {
            Add(cn.name, cn.value);
        }
        for (c = 0; cn = node.childNodes; c++) {
            if (cn.nodeType == 1) {
                if (cn.childNodes.length == 1 && cn.firstChild.nodeType == 3) {
                    // text value
                    Add(cn.nodeName, cn.firstChild.nodeValue);
                } else {
                    // sub-object
                    Add(cn.nodeName, XML2jsobj(cn));
                }
            }
        }
        return data;
    }

    _self.getDataUri = function(url) {

        var deferred = $q.defer();

        var image = new Image();
        image.setAttribute('crossOrigin', 'anonymous');

        image.onload = function() {
            var canvas = document.createElement('canvas');
            canvas.width = this.naturalWidth; // or 'width' if you want a special/scaled size
            canvas.height = this.naturalHeight; // or 'height' if you want a special/scaled size

            canvas.getContext('2d').drawImage(this, 0, 0);

            deferred.resolve(canvas.toDataURL('image/png').replace(/^data:image\/(png|jpg);base64,/, ''));
        };

        image.src = url;

        return deferred.promise;
    }

    _self.hideLoading = function() {
        $ionicLoading.hide();
    }

    _self.alertOpen = false;
    _self.alertList = [];

    _self.alertCall = function(title, msg) {
        return $ionicPopup.alert({
            title: title,
            template: msg
        });
    }

    _self.alert = function(msg) {

        if (!_self.alertOpen) {
            _self.alertOpen = true;
            var alert = $ionicPopup.alert({
                title: 'Alert',
                template: msg
            });

            alert.then(function() {
                _self.alertOpen = false;
                if (_self.alertList.length > 0) {
                    _self.alert(_self.alertList.shift());
                }
            });
        } else {
            if (_self.alertList.indexOf(msg) < 0)
                _self.alertList.push(msg);
        }
    }

    _self.sucess = function(msg) {
        $ionicPopup.alert({
            title: 'Success',
            template: msg
        });
    }

    _self.warning = function(msg) {
        $ionicPopup.alert({
            title: 'Warning',
            template: msg
        });
    }

    _self.error = function(msg) {
        $ionicPopup.alert({
            title: 'Error',
            template: msg
        });
    }

    _self.notifyPlay = function() {
        if (window.cordova)
            $cordovaDialogs.beep(1);
    }

    _self.confirm = function(msg, title) {
        var deferred = $q.defer();

        if (angular.isUndefined(title))
            title = "Confirm";
        var confirmPopup = $ionicPopup.confirm({
            title: title,
            template: msg
        });

        confirmPopup.then(function(res) {
            if (res) {
                deferred.resolve();
            } else {
                deferred.reject();
            }
        });
        return deferred.promise;
    }

    _self.custom_confirm = function(msg, title, okText, cancelText) {
        var deferred = $q.defer();

        if (angular.isUndefined(title))
            title = "Confirm";
        var confirmPopup = $ionicPopup.confirm({
            title: title,
            template: msg,
            cancelText: cancelText,
            okText: okText
        });

        confirmPopup.then(function(res) {
            if (res) {
                deferred.resolve();
            } else {
                deferred.reject();
            }
        });
        return deferred.promise;
    }


    _self.groupBySum = function(array, col, value, skipCol) {
        var r = [],
            o = {};

        for (i = 0; i < array.length; i++) {
            var a = array[i];
            if (skipCol && a[col] == skipCol)
                continue;

            if (!o[a[col]]) {
                o[a[col]] = {};
                o[a[col]][col] = a[col];
                o[a[col]][value] = 0;
                r.push(o[a[col]]);
            }
            o[a[col]][value] += +a[value];
        }
        return r;
    };

    _self.groupByMax = function(array, col, value, skipCol) {
        var r = [],
            o = {};
        for (i = 0; i < array.length; i++) {
            var a = array[i];
            if (skipCol && a[col] == skipCol)
                continue;
            if (!o[a[col]]) {
                o[a[col]] = {};
                o[a[col]][col] = a[col];
                o[a[col]][value] = 0;
                r.push(o[a[col]]);
            }
            o[a[col]][value] = Math.max(a[value], o[a[col]][value]);
        };
        return r;
    };

    _self.toast_notify = function(message) {
        if (window.plugins && window.plugins.toast) {
            window.plugins.toast.showShortTop(
                message,
                function(a) {},
                function(b) {}
            );
        }
    };

    Array.prototype.FindObjMax = function(cols, valueCol, value) {
        var r = {};
        angular.forEach(cols, function(col, key) {
            r[col] = value;
        });
        r[valueCol] = 0;
        for (i = 0; i < this.length; i++) {
            var a = this[i];
            for (j = 0; j < cols.length; j++) {
                var col = cols[j];
                if (value && a[col] == value) {

                    if (typeof a[valueCol] === 'number') {
                        if (a[valueCol] > r[valueCol]) {
                            r = angular.copy(a);
                            break;
                        }
                    } else {
                        if (Date.parse(a[valueCol]) > Date.parse(r[valueCol])) {
                            r = angular.copy(a);
                            break;
                        }
                    }


                }
            }
        };
        return r;
    };

    // datepart: 'y', 'm', 'w', 'd', 'h', 'n', 's'
    _self.dateDiff = function(datepart, fromdate, todate) {
        datepart = datepart.toLowerCase();

        todate = Date.parse(todate);
        fromdate = Date.parse(fromdate);

        var diff = todate - fromdate;
        var divideBy = {
            y: 31540000000,
            m: 2628000000,
            w: 604800000,
            d: 86400000,
            h: 3600000,
            n: 60000,
            s: 1000,
            x: 1
        };

        return Math.floor(diff / divideBy[datepart]);
    }

    _self.getDHMDiff = function(fromdate, todate) {
        datepart = datepart.toLowerCase();

        todate = Date.parse(todate);
        fromdate = Date.parse(fromdate);

        var diff = todate - fromdate;
        var divideBy = {
            d: 86400000,
            h: 3600000,
            n: 60000
        };

        days = Math.floor(diff / divideBy[d]);
        hours = Math.floor(diff / divideBy[h]);
        mins = Math.floor(diff / divideBy[n]);

        var string = "";
        if (days > 1) {
            string = days + " Days ";
        }
        if (hours > 1) {
            string += hours + " Hours ";
        }
        if (mins > 1) {
            string += mins + " Minutes Remaining";
        }

        return string;
    }

    return _self;
}

'use strict';

function Base64 () {
    angular.module('utf8-base64',[]).constant('base64', (function() {

        /*
         * Encapsulation of Andrey Bezyazychniy's encapsulation of Vassilis Petroulias's base64.js library.
         * As well as Andrey Bezyazychniy's AngularJS wrapper, an additional CommonJS wrapper has been added.
         * Original notice included below
         */

        /*
         Copyright Vassilis Petroulias [DRDigit]

         Licensed under the Apache License, Version 2.0 (the "License");
         you may not use this file except in compliance with the License.
         You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

         Unless required by applicable law or agreed to in writing, software
         distributed under the License is distributed on an "AS IS" BASIS,
         WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
         See the License for the specific language governing permissions and
         limitations under the License.
         */
        var B64 = {
            alphabet: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=',
            lookup: null,
            ie: /MSIE /.test(navigator.userAgent),
            ieo: /MSIE [67]/.test(navigator.userAgent),
            encode: function (s) {
                /* jshint bitwise:false */
                var buffer = B64.toUtf8(s),
                    position = -1,
                    result,
                    len = buffer.length,
                    nan0, nan1, nan2, enc = [, , , ];
                
                if (B64.ie) {
                    result = [];
                    while (++position < len) {
                        nan0 = buffer[position];
                        nan1 = buffer[++position];
                        enc[0] = nan0 >> 2;
                        enc[1] = ((nan0 & 3) << 4) | (nan1 >> 4);
                        if (isNaN(nan1))
                            enc[2] = enc[3] = 64;
                        else {
                            nan2 = buffer[++position];
                            enc[2] = ((nan1 & 15) << 2) | (nan2 >> 6);
                            enc[3] = (isNaN(nan2)) ? 64 : nan2 & 63;
                        }
                        result.push(B64.alphabet.charAt(enc[0]), B64.alphabet.charAt(enc[1]), B64.alphabet.charAt(enc[2]), B64.alphabet.charAt(enc[3]));
                    }
                    return result.join('');
                } else {
                    result = '';
                    while (++position < len) {
                        nan0 = buffer[position];
                        nan1 = buffer[++position];
                        enc[0] = nan0 >> 2;
                        enc[1] = ((nan0 & 3) << 4) | (nan1 >> 4);
                        if (isNaN(nan1))
                            enc[2] = enc[3] = 64;
                        else {
                            nan2 = buffer[++position];
                            enc[2] = ((nan1 & 15) << 2) | (nan2 >> 6);
                            enc[3] = (isNaN(nan2)) ? 64 : nan2 & 63;
                        }
                        result += B64.alphabet[enc[0]] + B64.alphabet[enc[1]] + B64.alphabet[enc[2]] + B64.alphabet[enc[3]];
                    }
                    return result;
                }
            },
            decode: function (s) {
                /* jshint bitwise:false */
                s = s.replace(/\s/g, '');
                if (s.length % 4)
                    throw new Error('InvalidLengthError: decode failed: The string to be decoded is not the correct length for a base64 encoded string.');
                if(/[^A-Za-z0-9+\/=\s]/g.test(s))
                    throw new Error('InvalidCharacterError: decode failed: The string contains characters invalid in a base64 encoded string.');

                var buffer = B64.fromUtf8(s),
                    position = 0,
                    result,
                    len = buffer.length;

                if (B64.ieo) {
                    result = [];
                    while (position < len) {
                        if (buffer[position] < 128)
                            result.push(String.fromCharCode(buffer[position++]));
                        else if (buffer[position] > 191 && buffer[position] < 224)
                            result.push(String.fromCharCode(((buffer[position++] & 31) << 6) | (buffer[position++] & 63)));
                        else
                            result.push(String.fromCharCode(((buffer[position++] & 15) << 12) | ((buffer[position++] & 63) << 6) | (buffer[position++] & 63)));
                    }
                    return result.join('');
                } else {
                    result = '';
                    while (position < len) {
                        if (buffer[position] < 128)
                            result += String.fromCharCode(buffer[position++]);
                        else if (buffer[position] > 191 && buffer[position] < 224)
                            result += String.fromCharCode(((buffer[position++] & 31) << 6) | (buffer[position++] & 63));
                        else
                            result += String.fromCharCode(((buffer[position++] & 15) << 12) | ((buffer[position++] & 63) << 6) | (buffer[position++] & 63));
                    }
                    return result;
                }
            },
            toUtf8: function (s) {
                /* jshint bitwise:false */
                var position = -1,
                    len = s.length,
                    chr, buffer = [];
                if (/^[\x00-\x7f]*$/.test(s)) while (++position < len)
                    buffer.push(s.charCodeAt(position));
                else while (++position < len) {
                    chr = s.charCodeAt(position);
                    if (chr < 128)
                        buffer.push(chr);
                    else if (chr < 2048)
                        buffer.push((chr >> 6) | 192, (chr & 63) | 128);
                    else
                        buffer.push((chr >> 12) | 224, ((chr >> 6) & 63) | 128, (chr & 63) | 128);
                }
                return buffer;
            },
            fromUtf8: function (s) {
                /* jshint bitwise:false */
                var position = -1,
                    len, buffer = [],
                    enc = [, , , ];
                if (!B64.lookup) {
                    len = B64.alphabet.length;
                    B64.lookup = {};
                    while (++position < len)
                        B64.lookup[B64.alphabet.charAt(position)] = position;
                    position = -1;
                }
                len = s.length;
                while (++position < len) {
                    enc[0] = B64.lookup[s.charAt(position)];
                    enc[1] = B64.lookup[s.charAt(++position)];
                    buffer.push((enc[0] << 2) | (enc[1] >> 4));
                    enc[2] = B64.lookup[s.charAt(++position)];
                    if (enc[2] === 64)
                        break;
                    buffer.push(((enc[1] & 15) << 4) | (enc[2] >> 2));
                    enc[3] = B64.lookup[s.charAt(++position)];
                    if (enc[3] === 64)
                        break;
                    buffer.push(((enc[2] & 3) << 6) | enc[3]);
                }
                return buffer;
            }
        };

        var B64url = {
            decode: function(input) {
                // Replace non-url compatible chars with base64 standard chars
                input = input
                    .replace(/-/g, '+')
                    .replace(/_/g, '/');

                // Pad out with standard base64 required padding characters
                var pad = input.length % 4;
                if(pad) {
                  if(pad === 1) {
                    throw new Error('InvalidLengthError: Input base64url string is the wrong length to determine padding');
                  }
                  input += new Array(5-pad).join('=');
                }

                return B64.decode(input);
            },

            encode: function(input) {
                var output = B64.encode(input);
                return output
                    .replace(/\+/g, '-')
                    .replace(/\//g, '_')
                    .split('=', 1)[0];
            }
        };

        var B64ArrayBuffer = {
            /* will return a  Uint8Array type */
            _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
            decodeArrayBuffer: function(input) {
                var bytes = (input.length/4) * 3;
                var ab = new ArrayBuffer(bytes);
                this.decode(input, ab);
                
                return ab;
            },
            
            decode: function(input, arrayBuffer) {
                //get last chars to see if are valid
                var lkey1 = this._keyStr.indexOf(input.charAt(input.length-1));      
                var lkey2 = this._keyStr.indexOf(input.charAt(input.length-2));      
            
                var bytes = (input.length/4) * 3;
                if (lkey1 == 64) bytes--; //padding chars, so skip
                if (lkey2 == 64) bytes--; //padding chars, so skip
                
                var uarray;
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;
                var j = 0;
                
                if (arrayBuffer)
                    uarray = new Uint8Array(arrayBuffer);
                else
                    uarray = new Uint8Array(bytes);
                
                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                
                for (i=0; i<bytes; i+=3) {  
                    //get the 3 octects in 4 ascii chars
                    enc1 = this._keyStr.indexOf(input.charAt(j++));
                    enc2 = this._keyStr.indexOf(input.charAt(j++));
                    enc3 = this._keyStr.indexOf(input.charAt(j++));
                    enc4 = this._keyStr.indexOf(input.charAt(j++));
            
                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;
            
                    uarray[i] = chr1;           
                    if (enc3 != 64) uarray[i+1] = chr2;
                    if (enc4 != 64) uarray[i+2] = chr3;
                }
            
                return uarray;  
            }
        }

        return {
            decode: B64.decode,
            encode: B64.encode,
            imageDecode : B64ArrayBuffer.decodeArrayBuffer,
            urldecode: B64url.decode,
            urlencode: B64url.encode,
        };
    })());
}

// check for Module support, otherwise explicitly call the Base64 function to setup the angular module.
if (typeof module !== 'undefined' && module.exports)
{
    module.exports = new Base64();
}
else
{
    Base64();
}
angular.module('app.core.util').factory('CSVParser', [CSVParser]);

function CSVParser() {


    var svc = {
        CSVToArray: CSVToArray
    };

    return svc;

    function CSVToArray(strData, strDelimiter) {
        // Check to see if the delimiter is defined. If not, then default to comma.
        strDelimiter = (strDelimiter || ",");

        // Create a regular expression to parse the CSV values.
        var objPattern = new RegExp(
            (
                // Delimiters.
                "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

                // Quoted fields.
                "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

                // Standard fields.
                "([^\"\\" + strDelimiter + "\\r\\n]*))"
            ),
            "gi"
        );
        // Create an array to hold our data. Give the array a default empty first row.
        var arrData = [
            []
        ];
        // Create an array to hold our individual pattern matching groups.
        var arrMatches = null;
        // Keep looping over the regular expression matches until we can no longer find a match.
        while (arrMatches = objPattern.exec(strData)) {
            // Get the delimiter that was found.
            var strMatchedDelimiter = arrMatches[1];
            // Check to see if the given delimiter has a length (is not the start of string) and if it matches
            // field delimiter. If id does not, then we know that this delimiter is a row delimiter.
            if (
                strMatchedDelimiter.length &&
                strMatchedDelimiter !== strDelimiter
            ) {
                // Since we have reached a new row of data, add an empty row to our data array.
                arrData.push([]);
            }

            var strMatchedValue;
            // Now that we have our delimiter out of the way, let's check to see which kind of value we captured (quoted or unquoted).
            if (arrMatches[2]) {
                // We found a quoted value. When we capture this value, unescape any double quotes.
                strMatchedValue = arrMatches[2].replace(
                    new RegExp("\"\"", "g"),
                    "\""
                );
            } else {
                // We found a non-quoted value.
                strMatchedValue = arrMatches[3];
            }
            // Now that we have our value string, let's add it to the data array.
            arrData[arrData.length - 1].push(strMatchedValue);
        }
        // Return the parsed data.
        return (arrData);
    }
}

//    angular-uuid created by Ivan Hayes @munkychop
//    MIT License - http://opensource.org/licenses/mit-license.php
//    --------------------------------------------------------------
//    This is an AngularJS wrapper for the original node-uuid library
//    written by Robert Kieffer – https://github.com/broofa/node-uuid
//    MIT License - http://opensource.org/licenses/mit-license.php

(function() {
    'use strict';
    
    angular.module("app.core.util").factory("UUID", ["$window", UUID]);

    function UUID($window) {
        var _global = $window;

        // Unique ID creation requires a high quality random # generator.  We feature
        // detect to determine the best RNG source, normalizing to a function that
        // returns 128-bits of randomness, since that's what's usually required
        var _rng;

        // Node.js crypto-based RNG - http://nodejs.org/docs/v0.6.2/api/crypto.html
        //
        // Moderately fast, high quality
        if (typeof(_global.require) == 'function') {
            try {
                var _rb = _global.require('crypto').randomBytes;
                _rng = _rb && function() {
                    return _rb(16);
                };
            } catch (e) {}
        }

        if (!_rng && _global.crypto && crypto.getRandomValues) {
            // WHATWG crypto-based RNG - http://wiki.whatwg.org/wiki/Crypto
            //
            // Moderately fast, high quality
            var _rnds8 = new Uint8Array(16);
            _rng = function whatwgRNG() {
                crypto.getRandomValues(_rnds8);
                return _rnds8;
            };
        }

        if (!_rng) {
            // Math.random()-based (RNG)
            //
            // If all else fails, use Math.random().  It's fast, but is of unspecified
            // quality.
            var _rnds = new Array(16);
            _rng = function() {
                for (var i = 0, r; i < 16; i++) {
                    if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
                    _rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
                }

                return _rnds;
            };
        }

        // Buffer class to use
        var BufferClass = typeof(_global.Buffer) == 'function' ? _global.Buffer : Array;

        // Maps for number <-> hex string conversion
        var _byteToHex = [];
        var _hexToByte = {};
        for (var i = 0; i < 256; i++) {
            _byteToHex[i] = (i + 0x100).toString(16).substr(1);
            _hexToByte[_byteToHex[i]] = i;
        }

        // **`parse()` - Parse a UUID into it's component bytes**
        function parse(s, buf, offset) {
            var i = (buf && offset) || 0,
                ii = 0;

            buf = buf || [];
            s.toLowerCase().replace(/[0-9a-f]{2}/g, function(oct) {
                if (ii < 16) { // Don't overflow!
                    buf[i + ii++] = _hexToByte[oct];
                }
            });

            // Zero out remaining bytes if string was short
            while (ii < 16) {
                buf[i + ii++] = 0;
            }

            return buf;
        }

        // **`unparse()` - Convert UUID byte array (ala parse()) into a string**
        function unparse(buf, offset) {
            var i = offset || 0,
                bth = _byteToHex;
            return bth[buf[i++]] + bth[buf[i++]] +
                bth[buf[i++]] + bth[buf[i++]] + '-' +
                bth[buf[i++]] + bth[buf[i++]] + '-' +
                bth[buf[i++]] + bth[buf[i++]] + '-' +
                bth[buf[i++]] + bth[buf[i++]] + '-' +
                bth[buf[i++]] + bth[buf[i++]] +
                bth[buf[i++]] + bth[buf[i++]] +
                bth[buf[i++]] + bth[buf[i++]];
        }

        // **`v1()` - Generate time-based UUID**
        //
        // Inspired by https://github.com/LiosK/UUID.js
        // and http://docs.python.org/library/uuid.html

        // random #'s we need to init node and clockseq
        var _seedBytes = _rng();

        // Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
        var _nodeId = [
            _seedBytes[0] | 0x01,
            _seedBytes[1], _seedBytes[2], _seedBytes[3], _seedBytes[4], _seedBytes[5]
        ];

        // Per 4.2.2, randomize (14 bit) clockseq
        var _clockseq = (_seedBytes[6] << 8 | _seedBytes[7]) & 0x3fff;

        // Previous uuid creation time
        var _lastMSecs = 0,
            _lastNSecs = 0;

        // See https://github.com/broofa/node-uuid for API details
        function v1(options, buf, offset) {
            var i = buf && offset || 0;
            var b = buf || [];

            options = options || {};

            var clockseq = options.clockseq != null ? options.clockseq : _clockseq;

            // UUID timestamps are 100 nano-second units since the Gregorian epoch,
            // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
            // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
            // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.
            var msecs = options.msecs != null ? options.msecs : new Date().getTime();

            // Per 4.2.1.2, use count of uuid's generated during the current clock
            // cycle to simulate higher resolution clock
            var nsecs = options.nsecs != null ? options.nsecs : _lastNSecs + 1;

            // Time since last uuid creation (in msecs)
            var dt = (msecs - _lastMSecs) + (nsecs - _lastNSecs) / 10000;

            // Per 4.2.1.2, Bump clockseq on clock regression
            if (dt < 0 && options.clockseq == null) {
                clockseq = clockseq + 1 & 0x3fff;
            }

            // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
            // time interval
            if ((dt < 0 || msecs > _lastMSecs) && options.nsecs == null) {
                nsecs = 0;
            }

            // Per 4.2.1.2 Throw error if too many uuids are requested
            if (nsecs >= 10000) {
                throw new Error('uuid.v1(): Can\'t create more than 10M uuids/sec');
            }

            _lastMSecs = msecs;
            _lastNSecs = nsecs;
            _clockseq = clockseq;

            // Per 4.1.4 - Convert from unix epoch to Gregorian epoch
            msecs += 12219292800000;

            // `time_low`
            var tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
            b[i++] = tl >>> 24 & 0xff;
            b[i++] = tl >>> 16 & 0xff;
            b[i++] = tl >>> 8 & 0xff;
            b[i++] = tl & 0xff;

            // `time_mid`
            var tmh = (msecs / 0x100000000 * 10000) & 0xfffffff;
            b[i++] = tmh >>> 8 & 0xff;
            b[i++] = tmh & 0xff;

            // `time_high_and_version`
            b[i++] = tmh >>> 24 & 0xf | 0x10; // include version
            b[i++] = tmh >>> 16 & 0xff;

            // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)
            b[i++] = clockseq >>> 8 | 0x80;

            // `clock_seq_low`
            b[i++] = clockseq & 0xff;

            // `node`
            var node = options.node || _nodeId;
            for (var n = 0; n < 6; n++) {
                b[i + n] = node[n];
            }

            return buf ? buf : unparse(b);
        }

        // **`v4()` - Generate random UUID**

        // See https://github.com/broofa/node-uuid for API details
        function v4(options, buf, offset) {
            // Deprecated - 'format' argument, as supported in v1.2
            var i = buf && offset || 0;

            if (typeof(options) == 'string') {
                buf = options == 'binary' ? new BufferClass(16) : null;
                options = null;
            }
            options = options || {};

            var rnds = options.random || (options.rng || _rng)();

            // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
            rnds[6] = (rnds[6] & 0x0f) | 0x40;
            rnds[8] = (rnds[8] & 0x3f) | 0x80;

            // Copy bytes to buffer, if provided
            if (buf) {
                for (var ii = 0; ii < 16; ii++) {
                    buf[i + ii] = rnds[ii];
                }
            }

            return buf || unparse(rnds);
        }

        // Export public API
        var publicAPI = v4;
        publicAPI.v1 = v1;
        publicAPI.v4 = v4;
        publicAPI.parse = parse;
        publicAPI.unparse = unparse;
        publicAPI.BufferClass = BufferClass;

        return publicAPI;
    }
})();

angular.module('app.core.zlogin')
    .factory('ZLogin', ZLogin) //authenticationFactory to get and set auth

ZLogin.$inject = ['$q', 'ZFBFactory', 'ProfileSvr', '$state', 'AppUtil', 'DBSvc'];

function ZLogin($q, ZFBFactory, ProfileSvr, $state, AppUtil, DBSvc) {
    //Initialization auth data

    var _self = this;
    _self.tableName = "AppConfig";
    _self.insert_query = "INSERT INTO AppConfig (user, password, logintype, configtype) Values (?,?,?,?)";
    _self.update_query = "Update AppConfig set user=?, password=?, logintype=? where configtype = ?";
    _self.list = [];

    _self.init = function() {

        DBSvc.query("select * from AppConfig where configtype = 'Login'").then(function(res) {
            _self.list = DBSvc.fetchAll(res);
            if (!_self.list || _self.list.length <= 0) {

                _self.checkIfDefaultLogged().then(function(res) {
                    if (res) {
                        _self.login('facebook').then(function(loginRes) {
                            _self.add_Update_login_cong('FB');
                            ProfileSvr.init(loginRes).then(function(res) {
                                $state.go(res);
                            });
                        }, function(res) {
                            if (res !== undefined && res.errorMessage !== undefined) {
                                AppUtil.alert(res.errorMessage);
                            } else {
                                AppUtil.alert("Not able to login with facebook");
                            }
                        });
                    } else {
                        AppUtil.hideLoading();
                    }
                }, function(res) {
                    AppUtil.hideLoading();
                });

            } else {

                found = false;
                for (i = 0; i < _self.list.length; i++) {
                    if (_self.list[i].logintype == 'FB') {
                        found = true;
                        _self.login('facebook').then(function(loginRes) {
                            _self.add_Update_login_cong('FB');
                            ProfileSvr.init(loginRes).then(function(res) {
                                $state.go(res);
                            });
                        }, function(res) {
                            if (res !== undefined && res.errorMessage !== undefined) {
                                AppUtil.alert(res.errorMessage);
                            } else {
                                AppUtil.alert("Not able to login with facebook");
                            }
                        });
                        break;
                    } else if (_self.list[i].logintype == 'MB') {
                        found = true;
                        ProfileSvr.init({
                            'mobile': _self.list[i].user + ""
                        }).then(function(res) {
                            $state.go(res);
                        });
                        break;
                    }
                }

                if (!found) {
                    AppUtil.hideLoading();
                }
            }
        }, function(res) {
            // TODO 
        });

    };

    _self.checkIfDefaultLogged = function() {
        var deferred = $q.defer();

        setTimeout(function() {
            deferred.resolve(false);
        }, 50);

        return deferred.promise;
    }

    _self.add_Update_login_cong = function(type, user, password) {

        var param = [];
        param.push(user);
        param.push(password);
        param.push(type);
        param.push('Login');

        DBSvc.query("select * from AppConfig where configtype = 'Login'").then(function(res) {
            if (res.rows.length > 0) {
                DBSvc.query(_self.update_query, param).then(function() {

                }, function() {

                });
            } else {
                DBSvc.query(_self.insert_query, param).then(function() {

                }, function() {

                });
            }
        }, function() {
            DBSvc.query(_self.insert_query, param).then(function() {

            }, function() {

            });
        });
    }

    _self.login = function(type) {

        if (type == 'facebook') {
            return ZFBFactory.login();
        }
        /*else if (type == 'google') {
                   return ZGPFactory.login();
               }*/
    }

    return _self;
};

angular.module('app.core.paypal')
    .factory('ZPayPal', ZPayPal); //authenticationFactory to get and set auth

ZPayPal.$inject = ['$q', '$ionicLoading', '$timeout', '$ionicPopup'];

function ZPayPal($q, $ionicLoading, $timeout, $ionicPopup) {
    //Initialization auth data

    var _self = this;

    _self.doPaypal = function(order) {
        var def = $q.defer();

        _self.initPaymentUI().then(function() {
            PayPalMobile.renderSinglePaymentUI(_self.createPayment(order), function(res) {
                    _self.onSuccesfulPayment(res);
                    def.resolve();
                },
                function(res) {
                    _self.onUserCanceled(res);
                    def.reject();
                });
        });

        return def.promise;
    };

    _self.initPaymentUI = function() {

        var def = $q.defer();

        var clientIDs = {
            "PayPalEnvironmentProduction": "YOUR_PRODUCTION_CLIENT_ID",
            "PayPalEnvironmentSandbox": "Af5mQa2Pf89d_UWxsctKm-hMrSm4FQ2HlbSw29KDFUxV6hH0S42Djs-PS3cDQmWbRqQQdcrA_zNfdHAc"
        };
        PayPalMobile.init(clientIDs, function() {
            _self.onPayPalMobileInit().then(function() {
                console.log("Paypal onPayPalMobileInit");
                def.resolve();
            })
        });

        return def.promise;
    };

    _self.configuration = function() {
        // for more options see `paypal-mobile-js-helper.js`
        var config = new PayPalConfiguration({
            merchantName: "ZPayTest",
            merchantPrivacyPolicyURL: "https://mytestshop.com/policy",
            merchantUserAgreementURL: "https://mytestshop.com/agreement"
        });
        return config;
    };

    _self.onPayPalMobileInit = function() {

        var def = $q.defer();

        // must be called
        // use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
        PayPalMobile.prepareToRender("PayPalEnvironmentSandbox", _self.configuration(),
            function() {
                console.log("Paypal onprepareToRender");
                def.resolve();
            });

        return def.promise;
    };

    _self.onUserCanceled = function(result) {
        console.log(result);
    };

    _self.onSuccesfulPayment = function(payment) {
        console.log("payment success: " + JSON.stringify(payment, null, 4));
    };

    _self.onAuthorizationCallback = function(authorization) {
        console.log("authorization: " + JSON.stringify(authorization, null, 4));
    };
    _self.createPayment = function(order) {
        // for simplicity use predefined amount

        var payment = null;
        if (order) {
            var paymentDetails = new PayPalPaymentDetails("00.00", "0.00", "0.00");
            var payment = new PayPalPayment("00.00", "USD", "Awesome Sauce", "Sale",
                paymentDetails);
            payment.invoiceNumber("Inv123");
            payment.custom("cust123");
            payment.softDescriptor("softDescriptor");
        } else {
            var paymentDetails = new PayPalPaymentDetails("02.00", "0.00", "0.00");
            var payment = new PayPalPayment("02.00", "USD", "Test", "Sale",
                paymentDetails);
        }
        return payment;
    };

    return _self;
};

angular.module('app.core.facebook')
    .factory('ZFBFactory', ZFBFactory) //authenticationFactory to get and set auth

ZFBFactory.$inject = ['$q', '$ionicLoading', '$timeout', '$ionicPopup', '$facebook'];

function ZFBFactory($q, $ionicLoading, $timeout, $ionicPopup, $facebook) {
    //Initialization auth data

    var _self = this;
    _self.init = function() {};
    _self.alertMsg = "Please note that we won't have any access to your Facebook profile without your permission." +
        " We can't or will not post anything on your Facebook profile without your permission.";

    _self.login = function() {

        var info = $q.defer();

        _self.alertPopup = $ionicPopup.alert({
            title: "Feel Free to Login",
            template: _self.alertMsg
        });

        if (typeof facebookConnectPlugin != 'undefined') {
            facebookConnectPlugin.getLoginStatus(function(success) {
                if (success.status === 'connected') {
                    // The user is logged in and has authenticated your app, and response.authResponse supplies
                    // the user's ID, a valid access token, a signed request, and the time the access token
                    // and signed request each expire
                    console.log('getLoginStatus', success.status);

                    _self.fbLoginSuccess(success).then(function(argument) {
                        info.resolve(argument);
                    }, function(argument) {
                        info.reject(argument);
                    });

                } else {
                    // If (success.status === 'not_authorized') the user is logged in to Facebook, but has not authenticated your app
                    // Else the person is not logged into Facebook, so we're not sure if they are logged into this app or not.

                    // Ask the permissions you need. You can learn more about
                    // FB permissions here: https://developers.facebook.com/docs/facebook-login/permissions/v2.4
                    facebookConnectPlugin.login(['email', 'public_profile', 'user_friends', 'user_birthday', 'user_education_history', 'user_work_history', 'read_custom_friendlists', 'user_location'], function(response) {
                        console.log('getLoginStatus', success.status);
                        _self.fbLoginSuccess(response).then(function(argument) {

                            info.resolve(argument);
                        }, function(argument) {
                            info.reject(argument);
                        })
                    }, function(response) {
                        _self.fbLoginError(response);
                        info.reject(response);
                    });
                }
            });
        } else {
            $facebook.login().then(function(response) {
                _self.fbLoginSuccess(response).then(function(argument) {

                    info.resolve(argument);
                }, function(argument) {
                    info.reject(argument);
                })
            }, function(response) {
                _self.fbLoginError(response);
                info.reject();
            });
        }

        return info.promise;
    }

    _self.fbLoginSuccess = function(response) {

        if (_self.alertPopup) {
            _self.alertPopup.close();
            _self.alertPopup = null;
        }

        var info = $q.defer();
        if (!response.authResponse) {
            _self.fbLoginError("Cannot find the authResponse");

            $timeout(function() {
                info.reject("Cannot find the authResponse");
            }, 3000);
        } else {
            _self.authResponse = response.authResponse;
            console.log(_self.authResponse);
            _self.getFacebookProfileInfo(_self.authResponse)
                .then(function(profileInfo) {

                    profileInfo.fbuserid = profileInfo.id;
                    _self.fbid = profileInfo.id;
                    info.resolve(profileInfo);
                    // def.resolve();

                }, function(fail) {
                    // Fail get profile info
                    console.log('profile info fail', fail);
                    info.reject(fail);
                });
        }
        return info.promise;
    };

    // This is the fail callback from the login method
    _self.fbLoginError = function(error) {
        console.log('fbLoginError', error);

        $ionicLoading.hide();
    };

    // This method is to get the user profile info from the facebook api
    _self.getFacebookProfileInfo = function(authResponse) {

        var fbDataString = "bio,education,languages,location,work";
        var info = $q.defer();

        if (typeof facebookConnectPlugin != 'undefined') {
            facebookConnectPlugin.api('/me?fields=email,name,birthday,gender&access_token=' + authResponse.accessToken, null,
                function(response) {
                    console.log(response);
                    info.resolve(response);
                },
                function(response) {
                    console.log(response);
                    info.reject(response);
                }
            );
        } else {
            $facebook.api('/me?fields=email,name,birthday,gender').then(function(response) {
                    console.log(response);
                    info.resolve(response);
                },
                function(response) {
                    console.log(response);
                    info.reject(response);
                });
        }

        return info.promise;
    };

    _self.logout = function() {
        // Facebook logout
        var info = $q.defer();

        if (typeof facebookConnectPlugin != 'undefined') {
            facebookConnectPlugin.logout(function() {
                    $ionicLoading.hide();
                    info.resolve();
                    _self.authResponse = undefined;
                    // TODO goto State
                },
                function(fail) {
                    $ionicLoading.hide();
                    info.reject();
                });
        } else {
            $facebook.logout(function() {
                    $ionicLoading.hide();
                    info.resolve();
                    _self.authResponse = undefined;
                    // TODO goto State
                },
                function(fail) {
                    $ionicLoading.hide();
                    info.reject();
                });
        }
        return info.promise;
    }; //FBLogout

    _self.message = function() {
        var info = $q.defer();


        if (typeof facebookConnectPlugin != 'undefined') {
            var op = {
                // method: 'apprequests',
                url: 'https://fb.me/1816116948678123',
                message: 'Zeenka',
                link: 'http://www.zeenka.com'
                    // action_type: 'send'
            };

            facebookConnectPlugin.appInvite(op, function(success) {
                // success
                $ionicPopup.alert({
                    title: 'Success',
                    template: 'Request send'
                });

                info.resolve();
            }, function(error) {
                // error

                $ionicPopup.alert({
                    title: 'Error',
                    template: "Request cancelled"
                });

                info.reject();
            });
        } else {
            var op = {
                link: 'http://www.google.com',
                method: 'send'
            };

            $facebook.ui(op, function(success) {
                // success
                $ionicPopup.alert({
                    title: 'Success',
                    template: 'Request send'
                });

                info.resolve();
            }, function(error) {
                // error

                $ionicPopup.alert({
                    title: 'Error',
                    template: "Request cancelled"
                });

                info.reject();
            });
        }

        return info.promise;
    };

    return _self;
};

angular.module('app.core.google')
    .factory('ZGPFactory', ZGPFactory) //authenticationFactory to get and set auth

ZGPFactory.$inject = ['$q', '$ionicLoading', '$timeout', '$http', 'AppConf', '$cordovaOauth'];

function ZGPFactory($q, $ionicLoading, $timeout, $http, AppConf, $cordovaOauth) {
    //Initialization auth data

    var _self = this;
    _self.clientID = '917927060055-sfctadeiv2jsucqd99g3n303ctlfo36k.apps.googleusercontent.com';
    _self.redirect_uri = "http://localhost/callback";
    _self.scope = "https://www.googleapis.com/auth/urlshortener";
    _self.clientSecret = "3wTIy2pO_60j5nS4WvP_6he1";

    _self.init = function() {};

    _self.googleapi = {

        authorize: function() {

            var deferred = $q.defer();

            $http.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';

            var authUrl = 'https://accounts.google.com/o/oauth2/auth?' + $.param({
                client_id: _self.clientID,
                redirect_uri: _self.redirect_uri,
                response_type: 'code',
                scope: _self.scope,
                approval_prompt: 'force',
                access_type: 'offline'
            });

            var authWindow = window.open(authUrl, '_blank', 'location=no');
            $(authWindow).on('loadstart', function(e) {
                var url = e.originalEvent.url;
                var code = /\?code=(.+)$/.exec(url);
                var error = /\?error=(.+)$/.exec(url);

                if (code || error) {
                    //Always close the browser when match is found
                    authWindow.close();
                    loadingSpinner();
                }

                if (code) {
                    $.post('https://accounts.google.com/o/oauth2/token', {
                        code: code[1],
                        client_id: _self.clientID,
                        client_secret: _self.clientSecret,
                        redirect_uri: _self.redirect_uri,
                        grant_type: 'authorization_code'
                    }).done(function(data) {
                        deferred.resolve(data);

                    }).fail(function(response) {
                        deferred.reject(response.responseJSON);
                    });
                } else if (error) {
                    deferred.reject({
                        error: error[1]
                    });
                }
            });

            return deferred.promise();
        }
    };

    _self.login = function() {

        var info = $q.defer();
        _self.authResponse = AppConf.getGPLAuth();
        if (_self.authResponse) {
            _self.gpLoginSuccess(_self.authResponse).then(function(argument) {
                info.resolve(argument);
            }, function(argument) {
                info.reject(argument);
            });
        } else {

            _self.googleapi.authorize().then(function(result) {
                console.log("Response Object -> " + JSON.stringify(result));
                _self.gpLoginSuccess(_self.authResponse).then(function(argument) {
                    info.resolve(argument);
                }, function(argument) {
                    info.reject(argument);
                })
            }, function(error) {
                console.log("Error -> " + error);
            });


            // $cordovaOauth.google(_self.clientID, ["email"]).then(function(result) {
            //     console.log("Response Object -> " + JSON.stringify(result));
            //     _self.gpLoginSuccess(_self.authResponse).then(function(argument) {
            //         info.resolve(argument);
            //     }, function(argument) {
            //         info.reject(argument);
            //     })
            // }, function(error) {
            //     console.log("Error -> " + error);
            // });
        }

        return info.promise;
    }

    _self.gpLoginSuccess = function(authResponse) {

        var info = $q.defer();
        if (!authResponse) {
            _self.gpLoginError("Cannot find the authResponse");

            $timeout(function() {
                info.reject("Cannot find the authResponse");
            }, 3000);
        } else {
            _self.authResponse = authResponse;
            console.log(_self.authResponse);
            _self.getGoogleProfileInfo(_self.authResponse)
                .then(function(profileInfo) {

                    profileInfo.gpuserid = profileInfo.id;
                    info.resolve(profileInfo);
                    // def.resolve();

                }, function(fail) {
                    // Fail get profile info
                    console.log('profile info fail', fail);
                    info.reject(fail);
                });
        }
        return info.promise;
    };

    // This is the fail callback from the login method
    _self.gpLoginError = function(error) {
        console.log('gpLoginError', error);

        $ionicLoading.hide();
    };

    // This method is to get the user profile info from the facebook api
    _self.getGoogleProfileInfo = function(authResponse) {

        var info = $q.defer();

        $http.get("https://www.googleapis.com/plus/v1/people/me", {
                params: {
                    access_token: authResponse
                }
            })
            .then(function(res) {
                info.resolve(res);
            }, function(error) {
                alert("Error: " + error);
            });
        return info.promise;
    };

    _self.logout = function() {
        // Google logout
        var info = $q.defer();

        // TODO

        return info.promise;
    }; //FBLogout

    _self.message = function() {
        var info = $q.defer();


        // TODO

        return info.promise;
    };

    return _self;
};

angular.module('app')
    .controller('AppCtrl', function($scope, $ionicModal, $ionicPopover, $timeout, ProfileSvr, $filter, AppConf,
        ZGeolocation, LikeSvr, FavouriteSvr, VisitorSvr, zsocket, ChatUserSvr, ChatSvr, $rootScope, ZMessages,
        $ionicHistory, $state, ZFCMPushFactory, TipsSvr, ZFBFactory, AppUtil, $cordovaNetwork, $ionicPlatform) {
        // Form data for the login modal
        $scope.loginData = {};
        $scope.activeMenu = 'zeenking'
            // var navIcons = document.getElementsByClassName('ion-navicon');
            // for (var i = 0; i < navIcons.length; i++) {
            //     navIcons.addEventListener('click', function() {
            //         this.classList.toggle('active');
            //     });
            // }

        $scope.unseenLikes = '';
        $scope.unseenFvts = '';
        $scope.unseenVisits = '';
        $scope.unseenChatUsers = '';

        $scope.me = ProfileSvr.me.user_id;

        zsocket.init().then(function() {
            $scope.initChat();
        }, function() {
            $scope.initChat();
        });

        ZGeolocation.init();;

        ZFCMPushFactory.init();

        $scope.goto = function(state, clearCache) {
            if (clearCache && clearCache == true) {
                $ionicHistory.clearCache().then(function() {
                    $state.go(state);
                });
            } else {
                $state.go(state);
            }
        }

        if (!$scope.$$listeners.hasOwnProperty("$stateChangeSuccess")) {
            $scope.$on('$stateChangeSuccess',
                function(event, toState, toParams, fromState, fromParams) {
                    TipsSvr.open();
                    AppUtil.hideLoading();

                });
        }

        if (!$scope.$$listeners.hasOwnProperty("$stateChangeStart")) {
            $scope.$on('$stateChangeStart',
                function(event, toState, toParams, fromState, fromParams) {
                    AppUtil.showLoading();
                });
        }

        if (!$rootScope.$$listeners.hasOwnProperty("$cordovaNetwork:online")) {
            $rootScope.$on('$cordovaNetwork:online', function(event, networkState) {
                ProfileSvr.init(ProfileSvr.me).then(function(res) {
                    zsocket.init().then(function() {

                        $scope.initChat();

                        if ($ionicHistory.currentStateName() == 'offline') {
                            $scope.goBack(false);
                        }
                    });
                });
            });
        };

        if (!$rootScope.$$listeners.hasOwnProperty("$cordovaNetwork:offline")) {
            $rootScope.$on('$cordovaNetwork:offline', function(event, networkState) {

                setTimeout(function() {
                    if ($cordovaNetwork.isOnline()) {
                        ProfileSvr.init(ProfileSvr.me).then(function(res) {
                            zsocket.init().then(function() {

                                $scope.initChat();
                                if ($ionicHistory.currentStateName() == 'offline') {
                                    $scope.goBack(false);
                                }
                            });
                        });
                    } else {
                        $state.go('offline');
                    }
                }, 10000);

            });
        }

        $ionicPlatform.on('resume', function() {
            if ($ionicHistory.currentStateName() != 'uploadimages') {
                zsocket.init().then(function() {
                    $scope.initChat();
                });
            }
        });

        $scope.initChat = function() {

            setTimeout(function() {
                ChatSvr.init(true).then(function() {
                    $scope.initChatUser();
                }, function() {
                    $scope.initChatUser();
                });
            }, 10);

        }

        $scope.initChatUser = function() {

            ChatUserSvr.init(true).then(function() {
                $scope.initFVR();
            }, function() {
                $scope.initFVR();
            });
        }

        $scope.initFVR = function() {

            FavouriteSvr.init().then(function() {
                $scope.initLike();
            }, function() {
                $scope.initLike();
            });

            setTimeout(function() {

                angular.forEach(ChatUserSvr.list, function(chatuser) {

                    unreadChat = ChatSvr.list.filter(function(chat) {
                        return chat.user_id == chatuser.user_id && chat.read == 'N';
                    });
                    //TODO:
                    obj = ChatSvr.list.FindObjMax(['user_id', 'to_user_id'], 'created', chatuser.user_id);
                    if (obj) {
                        chatuser.lastAccesedTime = obj.created;
                        chatuser.lastMessage = '';
                        if (obj.type === 't') {
                            chatuser.lastMessage = obj.message;
                        } else if (obj.type === 'p') {
                            chatuser.lastMessage = '📷 Photo';
                        }

                    }
                    if (unreadChat.length > 0) {
                        chatuser.unread = unreadChat.length;
                    } else {
                        chatuser.unread = 0;
                    }

                });
            }, 5000);

        }


        $scope.initLike = function() {

            LikeSvr.init().then(function() {
                $scope.initVisit();
            }, function() {
                $scope.initVisit();
            });
        }

        $scope.initVisit = function() {

            VisitorSvr.init();
        }

        $scope.toggleRight = function() {

            setTimeout(function() {

                unseenf = FavouriteSvr.list.filter(function(value) {
                    return value.seen == 'N' && value.to == $scope.me;
                });

                if (unseenf.length > 0) {
                    $scope.unseenFvts = unseenf.length;
                } else {
                    $scope.unseenFvts = '';
                }

                unseenl = LikeSvr.list.filter(function(value) {
                    return value.seen == 'N';
                });

                if (unseenl.length > 0) {
                    $scope.unseenLikes = unseenl.length;
                } else {
                    $scope.unseenLikes = '';
                }

                unseenv = VisitorSvr.list.filter(function(value) {
                    return value.seen == 'N';
                });

                if (unseenv.length > 0) {
                    $scope.unseenVisits = unseenv.length;
                } else {
                    $scope.unseenVisits = '';
                }

                unseenc = ChatUserSvr.list.filter(function(value) {
                    return value.unread > 0;
                });

                if (unseenc.length > 0) {
                    $scope.unseenChatUsers = unseenc.length;
                } else {
                    $scope.unseenChatUsers = '';
                }
            }, 10);

        }

        $scope.userName = angular.copy(ProfileSvr.me.displayname);
        $scope.userPic = ProfileSvr.me.profilePic;

        if (!ProfileSvr.me.profilePic) {

            $state.go('app.profile');

            // AppUtil.alertCall('Please upload at least one photo with your face clearly visible. It is mandatory requirement.',
            //     "Profiles with photos get more hits and have more chances of successful matches. So let's start with your photo"
            // ).then(function() {
            //     $state.go('uploadimages', {
            //         firstpic: true,
            //         source: Camera.PictureSourceType.CAMERA
            //     });
            // });

            AppUtil.custom_confirm(ZMessages.P_MSG, ZMessages.P_TITLE, "Camera", "Gallery").then(function() {
                $ionicHistory.clearCache().then(function() {
                    $state.go('uploadimages', {
                        firstpic: true,
                        source: Camera.PictureSourceType.CAMERA
                    });
                });
            }, function() {
                $ionicHistory.clearCache().then(function() {
                    $state.go('uploadimages', {
                        firstpic: true,
                        source: Camera.PictureSourceType.PHOTOLIBRARY
                    });
                });
            });
        } else {

            isqCmp = AppConf.getLSItems('QCom');
            if (isqCmp === undefined || isqCmp == null) {
                $state.go('ques', {});
            }
        }

        setTimeout(function(){
            var admobid = {
                banner: 'ca-app-pub-7555979693409401/3006492206'
            };

            AdMob.removeBanner(function(){
                AdMob.createBanner({
                    adId: admobid.banner,
                    position: AdMob.AD_POSITION.BOTTOM_CENTER,
                    autoShow: true
                }, function(){
                    // AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER);
                });
            });
        }, 20000);

        $scope.superPlayers = [];

        $scope.toggleClass = function($event,c){
            ($event.currentTarget).classList.toggle(c);
        }

        $scope.userPic = ProfileSvr.me.profilePic;

        $ionicPlatform.registerBackButtonAction(function(callback, priority, actionId) {
            if ($cordovaNetwork.isOnline()) {
                $scope.goBack(true);
            } else {
                $state.go('offline');
            }
        }, 1000);

        $scope.goBack = function(isHBack) {
            if ($ionicHistory.currentStateName() == 'app.zeenking' || $ionicHistory.currentStateName() == 'login') {
                if (isHBack)
                    if ($rootScope.backButtonPressedOnceToExit) {
                        ionic.Platform.exitApp();
                    } else {
                        $rootScope.backButtonPressedOnceToExit = true;
                        if (window.plugins && window.plugins.toast) {
                            window.plugins.toast.showShortCenter(
                                "Press back button again to exit",
                                function(a) {},
                                function(b) {}
                            );
                        }
                        setTimeout(function() {
                            $rootScope.backButtonPressedOnceToExit = false;
                        }, 2000);
                    }
            } else if ($ionicHistory.currentStateName() == 'offline') {
                ProfileSvr.init(ProfileSvr.me).then(function(res) {
                    zsocket.init().then(function() {
                        $ionicHistory.goBack(-1);
                    });
                });
            } else if ($ionicHistory.backView() && $ionicHistory.backView().stateName == 'offline') {
                $state.go('app.zeenking');
            } else {
                if ($ionicHistory.currentStateName() == 'uploadimages') {
                    if (!$scope.userPic) {

                        // AppUtil.alertCall('Please upload at least one photo',
                        //     "Profiles with photos get more hits and have more chances of successful match. So let's start with your photo"
                        // ).then(function() {
                        //     $state.go('uploadimages', {
                        //         firstpic: true,
                        //         source: Camera.PictureSourceType.CAMERA
                        //     });
                        // });

                        AppUtil.confirm("Please upload at least one photo." +
                            " You should not use Zeenka without photo. Are you ready to upload photo ? ", "Profile Photo").then(function() {
                            AppUtil.custom_confirm(ZMessages.P_MSG, ZMessages.P_TITLE, "Camera", "Gallery").then(function() {
                                $state.go('uploadimages', {
                                    firstpic: true,
                                    source: Camera.PictureSourceType.CAMERA
                                });
                            }, function() {
                                $state.go('uploadimages', {
                                    firstpic: true,
                                    source: Camera.PictureSourceType.PHOTOLIBRARY
                                });
                            });
                        }, function() {
                            ionic.Platform.exitApp();
                        });
                    } else {
                        $state.go('app.zeenking');
                    }
                } else if ($ionicHistory.backView() === undefined || $ionicHistory.backView() === null) {
                    $state.go('app.zeenking');
                } else if ($ionicHistory.backView().stateName == 'app.profile') {
                    $scope.goto($ionicHistory.backView().stateName, true);
                } else {
                    $ionicHistory.goBack(-1);
                }
            }
        }

    })
    .filter('profile', function() {
        return function(input) {
            if (input)
                for (var i = 0; i < input.length; i++) {
                    if (input[i].isprofile == 'Y')
                        return input[i].photopath;
                }
            return "assets/img/no-user.png";
        };
    })
    .filter('toDate', function() {
        return function(date) {
            if (!isNaN(Date.parse(date + " UTC"))) {
                return Date.parse(date + " UTC");
            } else {
                return Date.parse(date);
            }
        }
    })
    .filter('age', function() {
        return function(input) {
            var today = new Date();
            var birthDate = new Date(Date.parse(input));
            var age = today.getFullYear() - birthDate.getFullYear();
            var m = today.getMonth() - birthDate.getMonth();
            if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
                age--;
            }
            return age;
        };
    })
    .directive('imageSpineEror', function(AppConf) {
        return {
            restrict: 'A',
            link: function(scope, element, attrs, controllers) {
                // get the parent and chuck bg image in
                var parent = element.parent();
                element.css('background-image', 'url("assets/img/loader.gif")');
                element.css('background-repeat', 'no-repeat');
                element.css('background-size', element[0].width + 'px ' + element[0].height + 'px');
                // when it loads, hide the bg
                element.bind('load', function() {
                    element.css('background-image', '');
                    element.css('background-repeat', '');
                });
                element.bind('error', function() {
                    attrs.$set('src', "assets/img/no-user.png");
                });
            }
        }
    })
    .directive('noDataSpinner', function(AppConf) {
        return {
            restrict: 'A',
            link: function(scope, element, attrs, controllers) {
                // get the parent and chuck bg image in

                var divChild = angular.element(element.children()[0]);

                divChild.css('background', 'url("assets/img/loader.gif")');
                divChild.css('background-repeat', 'no-repeat');
                divChild.css('background-size', 'auto 100%');
                divChild.css('background-position', 'center');

            }
        }
    })
    .directive('roundProgress', function(AppConf) {
        return {
            restrict: 'A',
            link: function(scope, element, attrs, controllers) {
                // get the parent and chuck bg image in

                if (element.length === 1) {
                    var node = element[0];

                    var expression = node.getAttribute('data-round-progress');
                    scope.$watch(expression, function(newValue, oldValue) {

                        var queryResult = node.querySelectorAll('.circle .mask');
                        var wrappedQueryResult = angular.element(queryResult);
                        wrappedQueryResult.css('-webkit-clip', 'rect(' + 0 + 'px, ' + node.clientWidth + 'px, ' + node.clientWidth + 'px, ' + (node.clientWidth / 2) + 'px)');
                        wrappedQueryResult.css('clip', 'rect(' + 0 + 'px, ' + node.clientWidth + 'px, ' + node.clientWidth + 'px, ' + (node.clientWidth / 2) + 'px)');

                        queryResult = node.querySelectorAll('.circle .mask .fill');
                        var wrappedQueryResult = angular.element(queryResult);
                        wrappedQueryResult.css('-webkit-clip', 'rect(' + 0 + 'px, ' + (node.clientWidth / 2) + 'px, ' + node.clientWidth + 'px, ' + 0 + 'px)');
                        wrappedQueryResult.css('clip', 'rect(' + 0 + 'px, ' + (node.clientWidth / 2) + 'px, ' + node.clientWidth + 'px, ' + 0 + 'px)');

                        wrappedQueryResult.css('-webkit-transform', 'rotate(' + (1.8 * newValue) + 'deg)');
                        wrappedQueryResult.css('-ms-transform', 'rotate(' + (1.8 * newValue) + 'deg)');
                        wrappedQueryResult.css('-transform', 'rotate(' + (1.8 * newValue) + 'deg)');


                        queryResult = node.querySelectorAll('.circle .mask.full');
                        var wrappedQueryResult = angular.element(queryResult);
                        wrappedQueryResult.css('-webkit-transform', 'rotate(' + (1.8 * newValue) + 'deg)');
                        wrappedQueryResult.css('-ms-transform', 'rotate(' + (1.8 * newValue) + 'deg)');
                        wrappedQueryResult.css('-transform', 'rotate(' + (1.8 * newValue) + 'deg)');

                        queryResult = node.querySelectorAll('.circle .mask .fill.fix');
                        var wrappedQueryResult = angular.element(queryResult);
                        wrappedQueryResult.css('-webkit-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');
                        wrappedQueryResult.css('-ms-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');
                        wrappedQueryResult.css('-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');

                        queryResult = node.querySelectorAll('.tinset');
                        var wrappedQueryResult = angular.element(queryResult);
                        wrappedQueryResult.css('-webkit-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');
                        wrappedQueryResult.css('-ms-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');
                        wrappedQueryResult.css('-transform', 'rotate(' + (1.8 * newValue * 2) + 'deg)');

                    });
                }

            }
        }
    })
    .directive('undefined', function($interpolate) {
        return {
            restrict: 'A',
            link: function(scope, element, attrs, controllers) {
                if (element.hasClass('ng-binding')) {
                    var text = $interpolate(element[0].innerHTML)(scope);
                    if (!text) {
                        element.text('Not Filled');
                    }
                }
            }
        }
    })
    .directive('timer', ['$compile', function($compile) {
        return {
            restrict: 'EAC',
            replace: false,
            scope: {
                interval: '=interval',
                startTimeAttr: '=startTime',
                endTimeAttr: '=endTime',
                countdownattr: '=countdown',
                finishCallback: '&finishCallback',
                autoStart: '&autoStart',
                maxTimeUnit: '='
            },
            controller: ['$scope', '$element', '$attrs', '$timeout', function($scope, $element, $attrs, $timeout) {

                // Checking for trim function since IE8 doesn't have it
                // If not a function, create tirm with RegEx to mimic native trim
                if (typeof String.prototype.trim !== 'function') {
                    String.prototype.trim = function() {
                        return this.replace(/^\s+|\s+$/g, '');
                    };
                }

                //angular 1.2 doesn't support attributes ending in "-start", so we're
                //supporting both "autostart" and "auto-start" as a solution for
                //backward and forward compatibility.
                $scope.autoStart = $attrs.autoStart || $attrs.autostart;

                if ($element.html().trim().length === 0) {
                    $element.append($compile('<span>{{millis}}</span>')($scope));
                } else {
                    $element.append($compile($element.contents())($scope));
                }

                $scope.startTime = null;
                $scope.endTime = null;
                $scope.timeoutId = null;
                $scope.countdown = $scope.countdownattr && parseInt($scope.countdownattr, 10) >= 0 ? parseInt($scope.countdownattr, 10) : undefined;
                $scope.isRunning = false;

                $scope.$on('timer-start', function() {
                    $scope.start();
                });

                $scope.$on('timer-resume', function() {
                    $scope.resume();
                });

                $scope.$on('timer-stop', function() {
                    $scope.stop();
                });

                $scope.$on('timer-clear', function() {
                    $scope.clear();
                });

                $scope.$on('timer-set-countdown', function(e, countdown) {
                    $scope.countdown = countdown;
                });

                function resetTimeout() {
                    if ($scope.timeoutId) {
                        clearTimeout($scope.timeoutId);
                    }
                }

                $scope.start = $element[0].start = function() {
                    $scope.startTime = $scope.startTimeAttr ? new Date($scope.startTimeAttr) : new Date();
                    $scope.endTime = $scope.endTimeAttr ? new Date($scope.endTimeAttr) : null;
                    if (!$scope.countdown) {
                        $scope.countdown = $scope.countdownattr && parseInt($scope.countdownattr, 10) > 0 ? parseInt($scope.countdownattr, 10) : undefined;
                    }
                    resetTimeout();
                    tick();
                    $scope.isRunning = true;
                };

                $scope.resume = $element[0].resume = function() {
                    resetTimeout();
                    if ($scope.countdownattr) {
                        $scope.countdown += 1;
                    }
                    $scope.startTime = new Date() - ($scope.stoppedTime - $scope.startTime);
                    tick();
                    $scope.isRunning = true;
                };

                $scope.stop = $scope.pause = $element[0].stop = $element[0].pause = function() {
                    var timeoutId = $scope.timeoutId;
                    $scope.clear();
                    $scope.$emit('timer-stopped', {
                        timeoutId: timeoutId,
                        millis: $scope.millis,
                        seconds: $scope.seconds,
                        minutes: $scope.minutes,
                        hours: $scope.hours,
                        days: $scope.days
                    });
                };

                $scope.clear = $element[0].clear = function() {
                    // same as stop but without the event being triggered
                    $scope.stoppedTime = new Date();
                    resetTimeout();
                    $scope.timeoutId = null;
                    $scope.isRunning = false;
                };

                $element.bind('$destroy', function() {
                    resetTimeout();
                    $scope.isRunning = false;
                });

                function calculateTimeUnits() {
                    if ($attrs.startTime !== undefined) {
                        $scope.millis = new Date() - new Date($scope.startTimeAttr);
                    }
                    // compute time values based on maxTimeUnit specification
                    if (!$scope.maxTimeUnit || $scope.maxTimeUnit === 'day') {
                        $scope.seconds = Math.floor(($scope.millis / 1000) % 60);
                        $scope.minutes = Math.floor((($scope.millis / (60000)) % 60));
                        $scope.hours = Math.floor((($scope.millis / (3600000)) % 24));
                        $scope.days = Math.floor((($scope.millis / (3600000)) / 24));
                        $scope.months = 0;
                        $scope.years = 0;
                    } else if ($scope.maxTimeUnit === 'second') {
                        $scope.seconds = Math.floor($scope.millis / 1000);
                        $scope.minutes = 0;
                        $scope.hours = 0;
                        $scope.days = 0;
                        $scope.months = 0;
                        $scope.years = 0;
                    } else if ($scope.maxTimeUnit === 'minute') {
                        $scope.seconds = Math.floor(($scope.millis / 1000) % 60);
                        $scope.minutes = Math.floor($scope.millis / 60000);
                        $scope.hours = 0;
                        $scope.days = 0;
                        $scope.months = 0;
                        $scope.years = 0;
                    } else if ($scope.maxTimeUnit === 'hour') {
                        $scope.seconds = Math.floor(($scope.millis / 1000) % 60);
                        $scope.minutes = Math.floor((($scope.millis / (60000)) % 60));
                        $scope.hours = Math.floor($scope.millis / 3600000);
                        $scope.days = 0;
                        $scope.months = 0;
                        $scope.years = 0;
                    } else if ($scope.maxTimeUnit === 'month') {
                        $scope.seconds = Math.floor(($scope.millis / 1000) % 60);
                        $scope.minutes = Math.floor((($scope.millis / (60000)) % 60));
                        $scope.hours = Math.floor((($scope.millis / (3600000)) % 24));
                        $scope.days = Math.floor((($scope.millis / (3600000)) / 24) % 30);
                        $scope.months = Math.floor((($scope.millis / (3600000)) / 24) / 30);
                        $scope.years = 0;
                    } else if ($scope.maxTimeUnit === 'year') {
                        $scope.seconds = Math.floor(($scope.millis / 1000) % 60);
                        $scope.minutes = Math.floor((($scope.millis / (60000)) % 60));
                        $scope.hours = Math.floor((($scope.millis / (3600000)) % 24));
                        $scope.days = Math.floor((($scope.millis / (3600000)) / 24) % 30);
                        $scope.months = Math.floor((($scope.millis / (3600000)) / 24 / 30) % 12);
                        $scope.years = Math.floor(($scope.millis / (3600000)) / 24 / 365);
                    }
                    // plural - singular unit decision
                    $scope.secondsS = ($scope.seconds === 1 || $scope.seconds === 0) ? '' : 's';
                    $scope.minutesS = ($scope.minutes === 1 || $scope.minutes === 0) ? '' : 's';
                    $scope.hoursS = ($scope.hours === 1 || $scope.hours === 0) ? '' : 's';
                    $scope.daysS = ($scope.days === 1 || $scope.days === 0) ? '' : 's';
                    $scope.monthsS = ($scope.months === 1 || $scope.months === 0) ? '' : 's';
                    $scope.yearsS = ($scope.years === 1 || $scope.years === 0) ? '' : 's';
                    //add leading zero if number is smaller than 10
                    $scope.sseconds = $scope.seconds < 10 ? '0' + $scope.seconds : $scope.seconds;
                    $scope.mminutes = $scope.minutes < 10 ? '0' + $scope.minutes : $scope.minutes;
                    $scope.hhours = $scope.hours < 10 ? '0' + $scope.hours : $scope.hours;
                    $scope.ddays = $scope.days < 10 ? '0' + $scope.days : $scope.days;
                    $scope.mmonths = $scope.months < 10 ? '0' + $scope.months : $scope.months;
                    $scope.yyears = $scope.years < 10 ? '0' + $scope.years : $scope.years;

                }

                //determine initial values of time units and add AddSeconds functionality
                if ($scope.countdownattr) {
                    $scope.millis = $scope.countdownattr * 1000;

                    $scope.addCDSeconds = $element[0].addCDSeconds = function(extraSeconds) {
                        $scope.countdown += extraSeconds;
                        $scope.$digest();
                        if (!$scope.isRunning) {
                            $scope.start();
                        }
                    };

                    $scope.$on('timer-add-cd-seconds', function(e, extraSeconds) {
                        $timeout(function() {
                            $scope.addCDSeconds(extraSeconds);
                        });
                    });

                    $scope.$on('timer-set-countdown-seconds', function(e, countdownSeconds) {
                        if (!$scope.isRunning) {
                            $scope.clear();
                        }

                        $scope.countdown = countdownSeconds;
                        $scope.millis = countdownSeconds * 1000;
                        calculateTimeUnits();
                    });
                } else {
                    $scope.millis = 0;
                }
                calculateTimeUnits();

                var tick = function() {

                    $scope.millis = new Date() - $scope.startTime;
                    var adjustment = $scope.millis % 1000;

                    if ($scope.endTimeAttr) {
                        $scope.millis = $scope.endTime - new Date();
                        adjustment = $scope.interval - $scope.millis % 1000;
                    }


                    if ($scope.countdownattr) {
                        $scope.millis = $scope.countdown * 1000;
                    }

                    if ($scope.millis < 0) {
                        $scope.stop();
                        $scope.millis = 0;
                        calculateTimeUnits();
                        if ($scope.finishCallback) {
                            $scope.$eval($scope.finishCallback);
                        }
                        return;
                    }
                    calculateTimeUnits();

                    //We are not using $timeout for a reason. Please read here - https://github.com/siddii/angular-timer/pull/5
                    $scope.timeoutId = setTimeout(function() {
                        tick();
                        $scope.$digest();
                    }, $scope.interval - adjustment);

                    $scope.$emit('timer-tick', {
                        timeoutId: $scope.timeoutId,
                        millis: $scope.millis
                    });

                    if ($scope.countdown > 0) {
                        $scope.countdown--;
                    } else if ($scope.countdown <= 0) {
                        $scope.stop();
                        if ($scope.finishCallback) {
                            $scope.$eval($scope.finishCallback);
                        }
                    }
                };

                if ($scope.autoStart === undefined || $scope.autoStart === true) {
                    $scope.start();
                }
            }]
        };
    }])
    .filter('groupBy', ['$parse', function($parse) {
        return function(list, group_by) {

            var filtered = [];
            var prev_item = null;
            var group_changed = false;
            // this is a new field which is added to each item where we append "_CHANGED"
            // to indicate a field change in the list
            //was var new_field = group_by + '_CHANGED'; - JB 12/17/2013
            var new_field = 'group_by_CHANGED';

            // loop through each item in the list
            angular.forEach(list, function(item) {

                group_changed = false;

                // if not the first item
                if (prev_item !== null) {

                    // check if any of the group by field changed

                    //force group_by into Array
                    group_by = angular.isArray(group_by) ? group_by : [group_by];

                    //check each group by parameter
                    for (var i = 0, len = group_by.length; i < len; i++) {

                        var prevValue = $parse(group_by[i])(prev_item);
                        var currentValue = $parse(group_by[i])(item);
                        if (isNaN(currentValue) && !isNaN(Date.parse(currentValue))) {
                            prevValue = new Date(prevValue).setHours(0, 0, 0, 0);
                            currentValue = new Date(currentValue).setHours(0, 0, 0, 0);

                        }
                        if (prevValue !== currentValue) {
                            group_changed = true;
                        }
                    }


                } // otherwise we have the first item in the list which is new
                else {
                    group_changed = true;
                }

                // if the group changed, then add a new field to the item
                // to indicate this
                if (group_changed) {
                    item[new_field] = true;
                } else {
                    item[new_field] = false;
                }

                filtered.push(item);
                prev_item = item;

            });

            return filtered;
        };
    }]);

angular.module('app.comp.about')
    .controller('AboutCtrl', function($state, $mdDialog, AppParam) {
        var self = this;
        self.version = AppParam["app.Version"];
        self.logoPath = 'assets/img/logo.png';

        self.privacy = function() {
            $state.go("privacy");
        }

        self.feedback = function() {
            $state.go("feedback");
        }

        self.termcondition = function() {
            $state.go("termcondition");
        }

        self.helpcenter = function() {
            $state.go("helpcenter");
        }

        self.delete = function() {
            $state.go("delete");
        }
    });

angular.module('app.comp.chat')
    .controller('ChatCtrl', function($scope, $timeout, $ionicScrollDelegate, zsocket, ChatSvr, $stateParams,
        ChatUserSvr, $filter, ProfileSvr, $ionicHistory, $state, AppUtil, $ionicPopover, $cordovaCamera,
        $ionicScrollDelegate, $interval, $ionicModal, $ionicPlatform) {

        var self = this;
        self.hideTime = true;
        self.typing = false;
        self.TYPING_TIMER_LENGTH = 15000;
        self.me = ProfileSvr.me.user_id;
        self.issending = false;

        self.user = $stateParams.user ? JSON.parse($stateParams.user) : [];
        self.hasinstance = $stateParams.hasinstance;
        self.curUserMsgs = [];
        self.curUserTyping = [];
        self.pageSize = 10;

        if (!self.hasinstance) {
            var user = $filter("filter")(ChatUserSvr.all(), {
                user_id: self.user.user_id
            });
            if (user.length > 0) {
                self.hasinstance = true;
            }
        }

        if (!self.hasinstance) {
            AppUtil.alert("Please do not share your financial information or send money to any user.");
        }

        self.msgList = ChatSvr.list;
        self.msgTypeList = ChatSvr.typingList;

        setTimeout(function() {
            var users = [];
            if (self.curUserMsgs !== undefined) {
                obj = angular.copy(self.curUserMsgs).FindObjMax(['user_id', 'to_user_id'], 'id', self.user.user_id);
                fobj = {};
                fobj.user_id = obj.user_id;
                fobj.id = obj.id;
                users.push(fobj);
            } else {
                obj = {};
                obj.user_id = self.user.user_id;
                obj.id = 0;
                users.push(obj);
            }
            if (users.length > 0)
                ChatSvr.retriveData(users);
        }, 2000);

        self.increasePageSize = function() {

            if (self.curUserMsgs.length >= (self.pageSize + 10))
                self.pageSize = self.pageSize + 10;
            else
                self.pageSize = self.curUserMsgs.length;
        }

        self.usermsgs = function(msg) {
            return msg.user_id == self.user.user_id || msg.to_user_id == self.user.user_id;
        }

        self.isUserTyping = function(msg) {
            return msg.user_id == self.user.user_id;
        }

        var isIOS = ionic.Platform.isWebView() && ionic.Platform.isIOS();

        if (!self.curWatch) {

            self.curWatch = $scope.$watchCollection(function() {
                return self.curUserMsgs;
            }, function(newVal, oldVal) {

                for (i = newVal.length - 1; i >= 0; i--) {
                    if (newVal[i].type != 'notification' && newVal[i].user_id == self.user.user_id && newVal[i].read == 'N') {
                        ChatSvr.setMsgRead(newVal[i].user_id, newVal[i].id);
                        break;
                    }
                }

                $ionicScrollDelegate.scrollBottom(true);
            });
            
        }

        self.sendMessage = function() {

            if (self.message && self.message.trim().length > 0 && !self.issending) {

                self.issending = true;

                var msg = angular.copy(self.message);
                delete self.message;

                if (!self.hasinstance) {
                    ChatUserSvr.addChatUser(self.user.user_id).then(function() {

                        self.hasinstance = true;

                        var data = {
                            'to_user_id': self.user.user_id,
                            'message': msg,
                            'type': 't'
                        };

                        ChatSvr.sendMsg(data).then(function() {
                            self.issending = false;
                            $ionicScrollDelegate.scrollBottom(true);
                        }, function() {
                            self.issending = false;
                        });

                    }, function(res) {
                        self.issending = false;

                        if (res.Error && res.Error.indexOf("limit") > 0) {
                            AppUtil.custom_confirm("Your daily chat limit is completed." +
                                " Please become Premium member to increase your daily limit." +
                                " If already a Premium member then please wait for next day.", "Purchase Premium", "Purchase", "Wait").then(function() {
                                $state.go("order");
                            }, function() {
                                // Nothing..
                            });
                        } else {
                            AppUtil.alert(res.Error);
                        }
                    });

                } else {
                    var data = {
                        'to_user_id': self.user.user_id,
                        'message': msg,
                        'type': 't'
                    };

                    ChatSvr.sendMsg(data).then(function() {
                        self.issending = false;
                        $ionicScrollDelegate.scrollBottom(true);
                    }, function() {
                        self.issending = false;
                    });
                }

                if (self.updatingTimeout)
                    $timeout.cancel(self.updatingTimeout);

                zsocket.stopTyping({
                    'to_user_id': self.user.user_id,
                    'user_id': self.me
                });
                self.typing = false;
            }
            var textInput = document.getElementsByClassName("input-message");
            if (textInput) {
                angular.element(textInput[0]).focus();
            }
        };

        self.sendUpdateTyping = function(element) {

            if (element) {
                element.target.style.height = "5px";
                element.target.style.height = (element.target.scrollHeight) + "px";
                element.target.parentElement.style.height = ((element.target.scrollHeight) + 10) + "px";
            }

            if (!self.typing) {
                self.typing = true;
                zsocket.startTyping({
                    'to_user_id': self.user.user_id,
                    'user_id': self.me
                });
            }
            self.lastTypingTime = (new Date()).getTime();

            if (self.updatingTimeout)
                $timeout.cancel(self.updatingTimeout);

            self.updatingTimeout = $timeout(function() {
                var typingTimer = (new Date()).getTime();
                var timeDiff = typingTimer - self.lastTypingTime;
                if (timeDiff >= self.TYPING_TIMER_LENGTH && self.typing) {
                    zsocket.stopTyping({
                        'to_user_id': self.user.user_id,
                        'user_id': self.me
                    });
                    self.typing = false;
                }
            }, self.TYPING_TIMER_LENGTH);
        };

        self.isTyping = function() {
            var isTyping = false;
            var user = ChatSvr.typingList[self.user.user_id];
            if (user) {
                isTyping = true;
            }
            return isTyping;
        }

        self.closeKeyboard = function() {
            // cordova.plugins.Keyboard.close();
        };

        self.showProfile = function() {
            $ionicHistory.clearCache().then(function() {
                $state.go('app.user', {
                    user: JSON.stringify(self.user.user_id)
                });
            });
        };

        self.browseImage = function() {

        }

        $ionicPopover.fromTemplateUrl('browseImage.html', {
            scope: $scope,
        }).then(function(popover) {
            $scope.popover = popover;
        });


        self.takePhoto = function() {

            $scope.popover.hide();
            var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: false,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation: true
            };

            $cordovaCamera.getPicture(options).then(function(imageData) {
                sendImage(imageData);
            }, function(err) {
                AppUtil.alert(err);
            });
        }

        self.uploadFromGallery = function() {

            $scope.popover.hide();
            var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                allowEdit: false,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation: true
            };

            $cordovaCamera.getPicture(options).then(function(imageData) {
                sendImage(imageData);
            }, function(err) {
                AppUtil.alert(err);
            });
        }

        function sendImage(imageData) {
            AppUtil.showLoading();
            var data = {
                'to_user_id': self.user.user_id,
                'message': imageData,
                'type': 'p'
            };

            ChatSvr.sendMsg(data).then(function() {
                $ionicScrollDelegate.scrollBottom(true);
                AppUtil.hideLoading();
            }, function(err) {
                AppUtil.hideLoading();
            });
        }


        var cnt = 0;
        var elementInt = $interval(function() {
            var element = document.querySelector("#messages.ionic-scroll");
            if (element != null) {
                if (element.style['overflow'] == 'hidden') {
                    element.style['overflow-y'] = 'auto';
                    $ionicScrollDelegate.scrollBottom(true);
                    if (cnt >= 5)
                        $interval.cancel(elementInt);
                }
            }
        }, 1000);

        $ionicModal.fromTemplateUrl('image-modal.html', {
            scope: $scope,
            animation: 'slide-in-up',
            hardwareBackButtonClose: true
        }).then(function(modal) {
            $scope.modal = modal;
        });

        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.$on('$destroy', function() {

            self.curWatch();

            zsocket.stopTyping({
                'to_user_id': self.user.user_id,
                'user_id': self.me
            });
            self.typing = false;

            $scope.modal.hide();
            $scope.modal.remove();
            $scope.popover.hide();
        });

        $ionicPlatform.onHardwareBackButton(function() {
            if ($scope.modal.isShown())
                $scope.modal.hide();
            else
                $ionicHistory.goBack(-1);
        });

        self.showImage = function(image) {
            $scope.imageSrc = image;
            $scope.openModal();

            $timeout(function() {
                $scope.closeModal();
            }, 10000);
        }

        $scope.openModal = function() {
            $scope.modal.show();
        };

    });

angular.module('app.comp.chatusers')
    .controller('ChatUsersCtrl', function($scope, $stateParams, $timeout, ChatUserSvr, $state, $filter, ChatSvr) {

        $scope.dataList = ChatUserSvr.all();
        $scope.curUserTyping = [];
        $scope.limit = 10;
        $scope.msgTypeList = ChatSvr.typingList;

        $scope.deleteble = false;

        setTimeout(function() {
            ChatUserSvr.init().then(function() {
                $scope.dataList = ChatUserSvr.all();
            });
        }, 10);

        $scope.onHold = function($event) {
            $scope.deleteble = !$scope.deleteble;
            if ($event) {
                $timeout(function() {
                    angular.element($event.currentTarget).triggerHandler('click');
                }, 0);
            }
        }

        $scope.loadMore = function() {
            $scope.limit += 3;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            console.log($scope.limit);
        }

        $scope.delete = function() {

            var users = $filter("filter")($scope.dataList, {
                checked: true
            });

            var redIds = [];
            angular.forEach(users, function(user) {
                redIds.push(user.id);
            });

            ChatUserSvr.deleteByID(redIds);

            $scope.onHold();

        }

        $scope.showMessages = function(user_id) {

            var user = $filter("filter")($scope.dataList, {
                user_id: user_id
            });
            if (user.length > 0) {
                $state.go('chat', {
                    user: JSON.stringify(user[0]),
                    hasinstance: true
                });
            }
        }

        $scope.isUserTyping = function(user_id) {
            return function(msg) {
                return msg.user_id == user_id;
            }
        }

    });

angular.module('app.comp.delete')
    .controller('DeleteCtrl', function($scope, $stateParams, $timeout, ProfileSvr, $state, $ionicHistory, ZFBFactory, AppUtil) {

        var self = this;
        self.data = {};
        self.data.selectedReason = '';
        self.reasons = [{
            id: 0,
            name: 'Found Partner',
            placeholder: 'Tell us your story'
        }, {
            id: 1,
            name: 'Just Trying App',
            placeholder: 'Give tour feedback about App'
        }, {
            id: 2,
            name: 'Didn\'t like the app',
            placeholder: 'Tell us why you did not like App'
        }]

        self.selectReason = function() {
            console.log('Selected reason::' + JSON.stringify(self.data
                .selectedReason));
        }

        self.delete = function() {
            AppUtil.confirm("Your profile will not be visible to other users. However it will still stay in our system. Do you want to proceed ?",
                "In Active User").then(function() {
                var userFeedback = {
                        reason: self.data.selectedReason.name,
                        description: self.data.selectedReason.desc
                    }
                    //TODO {"reason":"reason","description":"description"}
                ProfileSvr.deleteUser(userFeedback).then(function() {
                    localStorage.clear();
                    $ionicHistory.clearCache();
                    $ionicHistory.clearHistory();
                    ZFBFactory.logout();
                    ionic.Platform.exitApp();

                });
            });
        }

    });

angular.module('app.comp.editprofile')
    .controller('AddtionalInfoCtrl', function($scope, $state, RefDataService, $timeout, $ionicHistory,
        $cordovaDatePicker, ProfileSvr, AppUtil, FilterSvr) {

        $scope.data = {};

        FilterSvr.init().then(function(data) {
            $scope.filter = data;
        });

        $scope.smokingList = RefDataService.getSmoking();
        $scope.bodyTypeList = RefDataService.getBodytype();
        // $scope.dietList = RefDataService.getDiet();
        $scope.drinkingList = RefDataService.getDrinking();
        // $scope.horoscopeList = RefDataService.getHoroscope();
        $scope.heightList = RefDataService.getHeight();


        // $scope.data.horoscope = angular.copy(ProfileSvr.me.horoscope);
        $scope.data.height = angular.copy(ProfileSvr.me.height);
        $scope.data.bodytype = angular.copy(ProfileSvr.me.bodytype);
        $scope.data.smoking = angular.copy(ProfileSvr.me.smoking);
        $scope.data.drinking = angular.copy(ProfileSvr.me.drinking);
        // $scope.data.diet = angular.copy(ProfileSvr.me.diet);
        // $scope.data.ucast = angular.copy(ProfileSvr.me.ucast);
        // $scope.data.religion = angular.copy(ProfileSvr.me.religion);
        // $scope.castList = Object.keys(RefDataService.getCaste());
        // $scope.religionList = Object.keys(RefDataService.getReligion());

        $scope.saveData = function() {

            var isOK = true;
            if ($scope.filter.herefor && ($scope.filter.herefor == 'M' || $scope.filter.herefor == 'Marriage')) {
                if ( $scope.data.height && $scope.data.bodytype && $scope.data.smoking &&
                    $scope.data.drinking && $scope.data.height.trim().length > 0 &&
                    $scope.data.bodytype.trim().length > 0 && $scope.data.smoking.trim().length > 0 &&
                    $scope.data.drinking.trim().length > 0 ) {
                    isOK = true;
                } else {
                    isOK = false;
                }
            }

            if (isOK) {
                ProfileSvr.updateInfo($scope.data, 'additional').then(function(argument) {
                    $ionicHistory.clearCache().then(function() {
                        $state.go('app.profile');
                    });
                }, function(argument) {
                    // body...
                });
            } else {
                AppUtil.alert("All fields are required so please put proper value on all fields");
            }
        };

        $scope.cancel = function() {
            $state.go('app.profile');
        }
    });

angular.module('app.comp.editprofile')
    .controller('ImageUploadCtrl', function($scope, $state, $ionicHistory, $stateParams, $cordovaCamera,
        ProfileSvr, AppUtil, $ionicLoading, ZMessages) {

        $scope.source = $stateParams.source;
        $scope.firstpic = $stateParams.firstpic;
        $scope.issaved = false;

        $scope.oImage = '';
        $scope.cropedImage = '';
        $scope.isUploading = false;

        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: $scope.source,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $scope.back = function() {

            $ionicLoading.hide();

            if ($scope.firstpic == false || ($scope.firstpic == true && $scope.issaved)) {

                var statename = $ionicHistory.backView().stateName;
                $ionicHistory.clearCache().then(function() {
                    $state.go(statename);
                });

            } else {

                AppUtil.custom_confirm(ZMessages.P_MSG, ZMessages.P_TITLE, "Camera", "Gallery").then(function() {
                    $ionicHistory.clearCache().then(function() {
                        $state.go('uploadimages', {
                            firstpic: true,
                            source: Camera.PictureSourceType.CAMERA
                        });
                    });
                }, function() {
                    $ionicHistory.clearCache().then(function() {
                        $state.go('uploadimages', {
                            firstpic: true,
                            source: Camera.PictureSourceType.PHOTOLIBRARY
                        });
                    });
                });
            }
        };

        $scope.cropchange = function($dataURI) {
            $scope.cropedImage = $dataURI;
        }

        $scope.save = function() {

            $ionicLoading.show({
                template: 'Verifying Image...'
            });

            $('#finalCropedImg').faceDetection({
                complete: function(faces) {
                    $ionicLoading.hide();
                    if (faces.length >= 1) {
                        $scope.startUploading();
                    } else {
                        AppUtil.alertCall("Please upload photo with your face clearly visible").then(function() {
                            $scope.back();
                        });
                    }
                },
                error: function() {
                    $ionicLoading.hide();
                    AppUtil.alertCall("Please upload photo with your face clearly visible").then(function() {
                        $scope.back();
                    });
                }
            });
        };

        $scope.startUploading = function() {

            if (!$scope.isUploading) {

                $scope.isUploading = true;
                $ionicLoading.hide();

                setTimeout(function() {
                    $ionicLoading.show({
                        template: 'Uploading Image...'
                    });

                    if ($scope.cropedImage && $scope.cropedImage.length > 0) {
                        ProfileSvr.uploadImage($scope.cropedImage).then(function(res) {
                            $scope.issaved = true;
                            $scope.stopUploading();
                            $scope.back();
                        }, function() {
                            $scope.stopUploading();
                        });
                    } else {
                        ProfileSvr.uploadImage($scope.oImage).then(function(res) {
                            $scope.issaved = true;
                            $scope.stopUploading();
                            $scope.back();
                        }, function() {
                            $scope.stopUploading();
                        });
                    }
                }, 500);

            } else {
                $ionicLoading.show({
                    template: 'Uploading Image...'
                });
            }
        }

        $scope.stopUploading = function() {
            $ionicLoading.hide();
            $scope.isUploading = false;
        }

        $scope.getImage = function() {

            $cordovaCamera.getPicture(options).then(function(imageData) {

                if ($scope.$$phase != '$apply' && $scope.$$phase != '$digest') {
                    $scope.$apply(function() {
                        $scope.oImage = "data:image/jpeg;base64," + imageData;
                    });
                } else {
                    $scope.oImage = "data:image/jpeg;base64," + imageData;
                }

            }, function(err) {
                AppUtil.alert(err);
                $scope.back();
            });
        }

        $scope.getImage();

    });

angular.module('app.comp.editprofile')
    .controller('ImageGridCtrl', function($scope, $state, $ionicHistory, $stateParams,
        ProfileSvr, $ionicPopover, AppUtil) {

        $scope.images = ProfileSvr.me.photos ? angular.copy(ProfileSvr.me.photos) : [];

        $scope.back = function() {
            $ionicHistory.clearCache().then(function() {
                $state.go('app.profile');
            });
        };

        $scope.takePhoto = function() {

            $scope.popover.hide();
            $state.go('uploadimages', {
                source : Camera.PictureSourceType.CAMERA
            });
        }

        $scope.uploadFromGallery = function() {

            $scope.popover.hide();
            $state.go('uploadimages', {
                source : Camera.PictureSourceType.PHOTOLIBRARY
            });
        }

        $scope.viewSlideShow = function(index) {
            $state.go('previewimages', {
                images: JSON.stringify($scope.images),
                selected: index,
                isDeletable: true
            })
        };

        $ionicPopover.fromTemplateUrl('ImageGridPopover.html', {
            scope: $scope,
        }).then(function(popover) {
            $scope.popover = popover;
        });

    });

angular.module('app.comp.editprofile')
    .controller('PersonalInfoCtrl', function($scope, $state, $timeout, $ionicHistory,
        $cordovaDatePicker, ProfileSvr, RefDataService, FilterSvr, AppUtil) {

        $scope.data = {};

        FilterSvr.init().then(function(data) {
            $scope.filter = data;
        });

        $scope.employmentList = RefDataService.getEmployment();
        $scope.statusList = RefDataService.getStatus();
        $scope.languageList = RefDataService.getLanguage();
        $scope.educationList = RefDataService.getEducation();
        $scope.states = [];
        $scope.cities = [];

        $scope.data.languages = angular.copy(ProfileSvr.me.languages);
        $scope.data.location = angular.copy(ProfileSvr.me.location);
        $scope.data.maritalstatus = angular.copy(ProfileSvr.me.maritalstatus);
        $scope.data.status_desc = angular.copy(ProfileSvr.me.status_desc);

        if (ProfileSvr.me.education) {
            $splitEducation = angular.copy(ProfileSvr.me.education.split(','));
            $scope.data.education = $splitEducation[0];
            $scope.data.passingYear = parseInt($splitEducation[1]);
        }

        $scope.data.employment = angular.copy(ProfileSvr.me.employment);

        if ($scope.data.languages) {
            $scope.data.lang = $scope.data.languages.split(',');
        }


        $scope.getSelectedText = function() {
            if ($scope.data.lang) {
                $scope.data.languages = $scope.data.lang.join(',');
                return $scope.data.lang.length + " : Languages selected"
            } else {
                return "Please select language";
            }
        }

        $scope.getMaxYear = function() {
            return new Date().getFullYear() - 1;
        }

        $scope.validationError = "";
        $scope.showError = function(strMsg) {
            $scope.validationError = strMsg;
            return "Passing year value should be between 1900 to " + $scope.getMaxYear();
        }

        $scope.saveData = function() {

            var isOK = true;
            if ($scope.filter.herefor && ($scope.filter.herefor == 'M' || $scope.filter.herefor == 'Marriage')) {
                if ($scope.data.lang && $scope.data.location && $scope.data.maritalstatus && $scope.data.education &&
                    $scope.data.employment && $scope.data.lang.length > 0 && $scope.data.location.trim().length > 0 &&
                    $scope.data.maritalstatus.trim().length > 0 && $scope.data.education.trim().length > 0 &&
                    $scope.data.employment.trim().length > 0) {
                    isOK = true;
                } else {
                    isOK = false;
                }
            }

            if (isOK) {

                delete $scope.data.lang;

                if($scope.data.status_desc === undefined)
                    $scope.data.status_desc = null;

                ProfileSvr.updateInfo($scope.data, 'personal').then(function(argument) {
                    $ionicHistory.clearCache().then(function() {
                        $state.go('app.profile');
                    });
                }, function(argument) {
                    // body...
                });
            } else {
                AppUtil.alert("All fields are required so please put proper value on all fields");
            }

        };

        $scope.cancel = function() {
            $state.go('app.profile');
        }

    });

angular.module('app.comp.favourite')

.controller('FavouriteCtrl', function($scope, $stateParams, $timeout, FavouriteSvr, $filter,
    $ionicHistory, $state, ProfileSvr) {

    $scope.dataList = FavouriteSvr.all();

    $scope.me = ProfileSvr.me.user_id;

    $scope.deleteble = false;
    $scope.limit = 12;


    $scope.reload = function() {
        FavouriteSvr.init().then(function() {
            $scope.dataList = FavouriteSvr.all();
        }, function() {
            $scope.dataList = FavouriteSvr.all();
        });
    }

    setTimeout(function() {
        $scope.reload();
    }, 10);

    $scope.loadMore = function() {
        $scope.limit += 6;
        $scope.$broadcast('scroll.infiniteScrollComplete');
    }

    $scope.myFvted = function(fvt) {
        return fvt.from == $scope.me;
    }

    $scope.fvtedMe = function(fvt) {
        return fvt.from != $scope.me;
    }

    $scope.onHold = function($event) {
        $scope.deleteble = !$scope.deleteble;
        if ($event) {
            $timeout(function() {
                angular.element($event.currentTarget).triggerHandler('click');
            }, 0);
        }
    }

    $scope.delete = function() {

        var users = $filter("filter")($scope.dataList, {
            checked: true
        });

        var redIds = [];
        angular.forEach(users, function(user) {
            redIds.push(user.id);
        });

        FavouriteSvr.deleteByID(redIds).then(function() {
            $scope.reload();
        }, function() {
            $scope.reload();
        });

        $scope.onHold();

    }

    $scope.openUser = function(user_id, recordID, seen) {

        var user = $filter("filter")($scope.dataList, {
            user_id: user_id
        });
        if (user.length > 0) {
            $ionicHistory.clearCache().then(function() {
                $state.go('app.user', {
                    user: JSON.stringify(user[0].user_id)
                });
            });
            if ((!seen || seen != 'Y') && recordID) {
                FavouriteSvr.updateSeen(recordID).then(function() {
                    $scope.dataList = FavouriteSvr.all();
                });
            }
        }
    }

});

angular.module('app.comp.feedback')

.controller('FeedbackCtrl', FeedbackCtrl);

FeedbackCtrl.$inject = ["FeedbackSvr", "$ionicHistory"];

function FeedbackCtrl(FeedbackSvr, $ionicHistory){
	var self = this;

	self.data = {};

	self.data.selectedType = '';
	self.data.feedback = '';

	self.init =  function(){
		FeedbackSvr.init().then(function(res){
			self.feedbackTypes = res;
			if(self.feedbackTypes){
				self.data.selectedType = Object.keys(self.feedbackTypes)[0];
			}
		});		
	}

	self.saveFeedabck = function(){
		var feedbackObj = {
			desc : self.data.feedback,
			type: self.data.selectedType
		}
		FeedbackSvr.addFeedback(feedbackObj).then(function(res){
			//TODO:
			$ionicHistory.goBack();
			if(window.plugins && window.plugins.toast){
				window.plugins.toast.showShortCenter(
	                "Thank you for your valuable feedback!",
	                    function(a) {},
	                    function(b) {}
	                );
			}
		});
	}

}

angular.module('app.comp.filter')

.controller('FilterCtrl', function($scope, $state, RefDataService, FilterSvr, $ionicHistory, ProfileSvr,
    AppUtil, ZeenkingSvr, NearBySvr) {

    $scope.hereForList = RefDataService.getHereFor();

    $scope.data = {};
    $scope.min = 18;
    $scope.max = 100;
    $scope.data.agefrom = 15;
    $scope.data.ageto = 45;
    $scope.data.herefor = null;
    // $scope.castList = Object.keys(RefDataService.getCaste());
    // $scope.religionList = Object.keys(RefDataService.getReligion());


    setTimeout(function() {
        FilterSvr.init().then(function(data) {
            $scope.data = angular.copy(data);
        });
    }, 10);

    $scope.onHereForChange = function() {
        if ($scope.data.herefor && ($scope.data.herefor == 'M' || $scope.data.herefor == 'Marriage')) {
            if (!ProfileSvr.iscomplete()) {
                AppUtil.confirm("In order to find a suitable match, we need further informations. ", "Complete Profile").then(function() {
                    $state.go('app.profile');
                }, function() {
                    $scope.data.herefor = $scope.hereforOld;
                });
            }
        }
    }

    $scope.onHereForChangeOpen = function() {
        $scope.hereforOld = $scope.data.herefor;
    };

    $scope.save = function() {

        // if ($scope.data.ucast !== undefined && $scope.data.ucast.trim() == '')
        $scope.data.ucast = null;

        // if ($scope.data.religion !== undefined && $scope.data.religion.trim() == '')
        $scope.data.religion = null;

        FilterSvr.setUpdate($scope.data).then(function() {

            ZeenkingSvr.list = [];
            NearBySvr.list = [];
            NearBySvr.lastsync = null;

            var statename = $ionicHistory.backView().stateName;
            $ionicHistory.clearCache().then(function() {
                $state.go(statename);
            });

        });
    }
});

angular.module('app.comp.helpcenter')

.controller('HelpCenterCtrl', HelpCenterCtrl);

HelpCenterCtrl.$inject = ["$sce", "WebPages"];

function HelpCenterCtrl($sce, WebPages){
	var self = this;

	self.data = {};

	self.data.src =  $sce.trustAsResourceUrl(WebPages.help_center);
}

angular.module('app.comp.imagerate')
    .controller('ImageRateCtrl', function($scope, $state,
        $ionicHistory, $ionicSlideBoxDelegate, AppUtil, ImageRateSvr) {

        $scope.images = [];

        ImageRateSvr.init().then(function() {
            $scope.images = ImageRateSvr.list;
            $ionicSlideBoxDelegate.$getByHandle('imagerateviewer').update();
        });

        $scope.back = function() {
            $ionicHistory.goBack();
        }

        $scope.submitRate = function() {

            var index = $ionicSlideBoxDelegate.$getByHandle('imagerateviewer').currentIndex();
            var image = $scope.images[index];

            ImageRateSvr.ratePhoto(image.id, image.myrate).then(function() {
                $scope.nextRating();
            }, function() {
                $scope.nextRating();
            });
        }

        $scope.nextRating = function() {
            $scope.images = ImageRateSvr.list;
            $ionicSlideBoxDelegate.$getByHandle('imagerateviewer').update();
        }

    });

angular.module('app.comp.imageviewer')
    .controller('ImageViewerCtrl', function($scope, $state, $ionicPosition, $stateParams,
        $ionicHistory, $timeout, $filter, ProfileSvr, $ionicSlideBoxDelegate, $ionicPopover, AppUtil, ImageRateSvr) {

        $scope.images = $stateParams.images ? JSON.parse($stateParams.images) : [];
        $scope.isDeletable = $stateParams.isDeletable ? $stateParams.isDeletable : false;
        $scope.selImage = $stateParams.selected ? $stateParams.selected : 0;
        $scope.refreshList = true;

        $scope.back = function() {
            $ionicHistory.goBack();
        }

        $scope.setProfileImage = function(imageid) {

            $scope.popover.hide();
            var index = $ionicSlideBoxDelegate.$getByHandle('imageviewer').currentIndex();
            var selectedimage = $scope.images[index];
            if (!selectedimage.isprofile || selectedimage.isprofile == 'N') {
                ProfileSvr.setProfileImage(selectedimage.id).then(function() {
                    for (var i = 0; i < $scope.images.length; i++) {
                        if (index == i) {
                            $scope.images[i].isprofile = 'Y';
                        } else {
                            $scope.images[i].isprofile = 'N';
                        }
                    }
                    AppUtil.sucess("Profile Photo Updated");
                });
            }
        };

        $scope.submitRate = function() {

            var index = $ionicSlideBoxDelegate.$getByHandle('imageviewer').currentIndex();
            var image = $scope.images[index];

            ImageRateSvr.ratePhoto(image.id, image.myrate).then(function() {

                $scope.nextRating();
            }, function() {
                $scope.nextRating();
            });
        }

        $scope.nextRating = function() {
            var index = $ionicSlideBoxDelegate.$getByHandle('imageviewer').currentIndex();
            if ($scope.images.length > index + 1) {
                AppUtil.custom_confirm("Photo successfully rated. Would you like to rate more photos ?",
                    "Success", "Next", "Done").then(function() {
                    $ionicSlideBoxDelegate.$getByHandle('imageviewer').slide(index + 1);
                }, function() {

                });
            } else {
                AppUtil.sucess("Photo successfully rated.");
            }

        }

        $scope.removeImage = function() {

            $scope.popover.hide();
            var index = $ionicSlideBoxDelegate.$getByHandle('imageviewer').currentIndex();
            var removeimage = $scope.images[index];
            if (!removeimage.isprofile || removeimage.isprofile == 'N') {
                $scope.refreshList = false;
                ProfileSvr.removeImage(removeimage.id).then(function(removedList) {
                    angular.forEach(removedList, function(value, key) {

                        var newTemp = $filter("filter")($scope.images, {
                            id: value
                        });

                        if (newTemp.length > 0)
                            $scope.images.splice($scope.images.indexOf(newTemp[0]), 1);

                        $scope.refreshList = true;
                        if ($scope.images.length == 0) {
                            $scope.back();
                        }
                    });
                });
            } else {
                AppUtil.alert("Profile image should not delete");
            }
        };

        if ($scope.isDeletable) {
            $ionicPopover.fromTemplateUrl('ImageViewerPopover.html', {
                scope: $scope,
            }).then(function(popover) {
                $scope.popover = popover;
            });
        }

        setTimeout(function() {
            $ionicSlideBoxDelegate.$getByHandle('imageviewer').slide($scope.selImage);
        }, 50);

    });

angular.module('app.comp.invite')
    .controller('InviteCtrl', function($scope, $stateParams, $state,
        ZFBFactory, $ionicPopup, ProfileSvr) {
        $scope.invite_code = 'Ref-' + ProfileSvr.me.user_id;
        $scope.fbInvite = function() {
            ZFBFactory.message().then(function(argument) {
                // body...
            }, function(argument) {
                // body...
            });
        }

        $scope.twInvite = function() {
            $state.go('twitterMsg');
        }

        $scope.wsInvite = function() {

            var msg = encodeURIComponent("Zeenka - India's best app for Dating, friendship, chatting.\n" +
                "Spice yr life now\nPlease use Referral Code : " + $scope.invite_code +
                " at signup time to get more benefits.\n" +
                "https://goo.gl/wvOYkg");
            window.location.href = "whatsapp://app";
            window.location.href = "whatsapp://send?text=" + msg;
        }

    });

angular.module('app.comp.like')

.controller('LikeCtrl', function($scope, $stateParams, $timeout, LikeSvr, $ionicHistory, $state, $filter,
    ProfileSvr, AppUtil, $ionicPopup) {

    $scope.dataList = LikeSvr.all();
    $scope.deleteble = false;
    $scope.limit = 15;
    $scope.ispremium = angular.copy(ProfileSvr.me.ispremium);

    $scope.reload = function() {
        LikeSvr.init().then(function() {
            $scope.dataList = LikeSvr.all();
        });
    }

    $scope.onHold = function($event) {
        $scope.deleteble = !$scope.deleteble;
        if ($event) {
            $timeout(function() {
                angular.element($event.currentTarget).triggerHandler('click');
            }, 0);
        }
    }

    $scope.loadMore = function() {
        $scope.limit += 6;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        console.log($scope.limit);
    }

    $scope.openUser = function(user_id, recordID, seen) {

        var user = $filter("filter")($scope.dataList, {
            user_id: user_id
        });

        if (user.length > 0) {

            if ($scope.ispremium == 'Y') {
                $ionicHistory.clearCache().then(function() {
                    $state.go('app.user', {
                        user: JSON.stringify(user[0].user_id)
                    });
                });
                if ((!seen || seen != 'Y') && recordID) {
                    LikeSvr.updateSeen(recordID).then(function() {
                        // $scope.dataList = FavouriteSvr.all();
                        // TODO
                    });
                }
            } else {

                $scope.confirmPopup = $ionicPopup.show({
                    title: 'Premium membership',
                    template: "<b>In order to use this feature you need to be a premium member." +
                        " You can either purchase or get free membership by inviting your friends.</b>",
                    buttons: [{
                        text: 'Purchase',
                        //type: 'button-positive',
                        onTap: function(e) {
                            $scope.closePopup();
                            $state.go("order");
                        }
                    }, {
                        text: 'Invite',
                        onTap: function(e) {
                            $scope.closePopup();
                            $state.go("app.invite");
                        }
                    }]
                });
            }

        }
    }

    $scope.closePopup = function() {
        if ($scope.confirmPopup)
            $scope.confirmPopup.close();
    };

    $scope.$on('$destroy', function() {
        $scope.closePopup();
    });

    $scope.delete = function(userID) {

        var users = $filter("filter")($scope.dataList, {
            checked: true
        });

        var redIds = [];
        angular.forEach(users, function(user) {
            redIds.push(user.id);
        });

        LikeSvr.deleteByID(redIds).then(function() {
            $scope.reload();
        }, function() {
            $scope.reload();
        });

        $scope.onHold();

    }

    setTimeout(function() {
        $scope.reload();
    }, 10);

});

angular.module('app.comp.match')

.controller('MatchCtrl', function($scope, $state, $mdDialog, data, $filter, ProfileSvr) {
    $scope.data = data;
    $scope.user1Path = ProfileSvr.me.profilePic;
    $scope.user2Path = $filter('profile')($scope.data.photos);
    
    $scope.cancel = function() {
        $mdDialog.cancel();
    };
    $scope.chat = function() {

        $mdDialog.cancel();
        $state.go('chat', {
            user: JSON.stringify($scope.data)
        });
    };
});

angular.module('app.comp.nearby')

.controller('NearByCtrl', function($scope, $stateParams, $timeout, NearBySvr, $ionicHistory, $state, $filter) {

    $scope.dataList = NearBySvr.all();

    setTimeout(function() {
        NearBySvr.init().then(function() {
            $scope.dataList = NearBySvr.all();
        });
    }, 10);

    $scope.openUser = function(user_id, recordID, seen) {

        var user = $filter("filter")($scope.dataList, {
            user_id: user_id
        });
        if (user.length > 0) {
            $ionicHistory.clearCache().then(function() {
                $state.go('app.user', {
                    user: JSON.stringify(user[0].user_id)
                });
            });
            if ((!seen || seen != 'Y') && recordID) {
                NearBySvr.updateSeen(recordID).then(function() {
                    $scope.dataList = FavouriteSvr.all();
                });
            }
        }
    }

    var admobid = {
                    interstitial: 'ca-app-pub-7555979693409401/5610264349'
                };

                
                    AdMob.prepareInterstitial({
                        adId: admobid.interstitial,
                        autoShow: true
                    });

});

angular.module('app.comp.order')
    .controller('OrderCtrl', OrderCtrl);

OrderCtrl.$inject = ["$scope", "$stateParams", "$ionicHistory", "$state", "PackageSvr", "$ionicTabsDelegate",
    "$timeout", "OrderSvr", "ProfileSvr", "ZPayPal", "AppUtil", "$q", "$filter", "RazorSvr", "AppConf" 
];

function OrderCtrl($scope, $stateParams, $ionicHistory, $state, PackageSvr, $ionicTabsDelegate,
    $timeout, OrderSvr, ProfileSvr, ZPayPa, AppUtil, $q, $filter, RazorSvr, AppConf) {
    var self = this;

    self.data = {};
    self.packages = [];
    self.data.package = {};
    self.payMethods = [];
    self.tabs = $ionicTabsDelegate;
    self.selectedTab = 0;
    self.country = AppConf.country;
    self.allPacks = {
        'India': [{
            name: 'GPay',
            id: 'com.zeenka.dating.1week',
            qty: 1,
            discount: 0,
            type: 'Weeks',
            amttext: "300.00 ₹",
            amt: 300
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "540.00 ₹",
            amt: 540
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 18,
            type: 'Weeks',
            amttext: "980.00 ₹",
            amt: 980
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.12week',
            qty: 12,
            discount: 24,
            type: 'Weeks',
            amttext: "2750.00 ₹",
            amt: 2750
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.24week',
            qty: 24,
            discount: 31,
            type: 'Weeks',
            amttext: "5000.00 ₹",
            amt: 5000
        }],
        'Australia': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "11.70 AUD",
            amt: 11.70
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "17.50 AUD",
            amt: 17.50
        }],
        'Canada': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "10.70 CAD",
            amt: 10.70
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "16.00 CAD",
            amt: 16
        }],
        'New Zealand': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "12.50 NZD",
            amt: 12.50
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "18.70 NZD",
            amt: 18.70
        }],
        'Oman': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "7.20 $",
            amt: 7.20
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "10.70 $",
            amt: 10.70
        }],
        'Qatar': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "28.50 QAR",
            amt: 28.50
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "42.70 QAR",
            amt: 42.70
        }],
        'Saudi Arabia': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "28.50 SAR",
            amt: 28.50
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "42.70 SAR",
            amt: 42.70
        }],
        'United Arab Emirates': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "28.50 AED",
            amt: 28.50
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "42.70 AED",
            amt: 42.70
        }],
        'United Kingdom': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 16,
            type: 'Weeks',
            amttext: "5.00 £",
            amt: 5
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "8.00 £",
            amt: 8
        }],
        'United States': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "7.20 $",
            amt: 7.20
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "10.70 $",
            amt: 10.70
        }],
        'UK': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 16,
            type: 'Weeks',
            amttext: "5.00 £",
            amt: 5
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "8.00 £",
            amt: 8.00
        }],
        'USA': [{
            name: 'GPay',
            id: 'com.zeenka.dating.2week',
            qty: 2,
            discount: 10,
            type: 'Weeks',
            amttext: "7.20 $",
            amt: 7.20
        },{
            name: 'GPay',
            id: 'com.zeenka.dating.4week',
            qty: 4,
            discount: 33,
            type: 'Weeks',
            amttext: "10.70 $",
            amt: 10.70
        }]
    };

    self.gpackages = self.allPacks[self.country];

    PackageSvr.load()
        .then(function(response) {
            self.packages = angular.copy(PackageSvr.all());
            self.data.package = $filter('filter')(self.packages, {
                name: 'Premium '
            })[0];
            self.payMethods = self.data.package.methods;
        });

    $timeout(function() {
        $ionicTabsDelegate.select(0, false);
    }, 400);

    self.placeOrder = function(obj) {

        var def = $q.defer();

        var orderJSON = self.getOrderObj(obj);

        // TODO Disable For testing
        OrderSvr.generateOrder(orderJSON).then(
            function(res) {
                def.resolve(res);
            },
            function(res) {
                def.reject();
            }
        );

        // TODO Enable For testing
        // setTimeout(function() {
        //     orderJSON.user_orders_id = "Inv" + new Date().getTime();
        //     def.resolve(orderJSON);
        // }, 1000);

        return def.promise;

    }

    self.getOrderObj = function(obj) {
        //Create JSON object to generate orderid
        var orderJSON = {};
        orderJSON.user_id = ProfileSvr.me.user_id;

        if (isNaN(obj.id)) {
            orderJSON.g_package_id = obj.id;
        } else {
            orderJSON.package_id = obj.id;
        }

        orderJSON.package_type = obj.type;

        orderJSON.qty = obj.qty;
        orderJSON.payment_type = obj.name;
        orderJSON.amount = obj.amt;
        orderJSON.discount = obj.discount;
        return orderJSON;
    }

    self.paybymobile = function() {
        if (self.data.selectedPackage) {

            var order = self.getOrderObj(JSON.parse(self.data.selectedPackage));
            // TODO Set Order Params (id, amount, qty)
            $state.go('paybymobile', {
                cuid: JSON.stringify(order),
                tc_id: order.amount,
                tc_amount: order.qty
            });

        } else {
            AppUtil.alert("Please choose item from list first");
        }
    }

    self.paybyrazor = function() {
        if (self.data.selectedPackage) {
            self.placeOrder(JSON.parse(self.data.selectedPackage)).then(function(order) {
                RazorSvr.openPaymentPage(order).then(function(data) {
                    OrderSvr.orderRazorCall(JSON.stringify(data), order.user_orders_id, "completed").then(function() {
                        // TODO OK
                    }, function() {
                        // TODO OK
                    });
                    $state.go('app.zeenking');
                }, function(err) {
                    OrderSvr.orderRazorCall(JSON.stringify(err), order.user_orders_id, "Failed").then(function() {
                        // TODO OK
                    }, function() {
                        // TODO OK
                    });

                    AppUtil.alert("Not able to complete payment. Try again after some time");

                    $state.go('app.zeenking');
                });
            }, failureOrder);
        } else {
            AppUtil.alert("Please choose item from list first");
        }
    }

    self.paybypaypal = function() {

        if (self.data.selectedPackage) {
            self.placeOrder(JSON.parse(self.data.selectedPackage)).then(function(order) {
                ZPayPal.doPaypal(order).then(function(res) {

                }, function(res) {

                });
            }, failureOrder);
        } else {
            AppUtil.alert("Please choose item from list first");
        }
    }

    function failureOrder() {
        AppUtil.alert("Not Able to do Payment ! Try again after some time");
        $state.go('app.zeenking');
    }

    self.onTabChanges = function(currentIndex) {
        self.selectedTab = currentIndex;
        self.data.selectedPackage = undefined;
    }

    self.paybywallet = function() {

        if (self.data.selectedPackage) {
            inAppPurchase
                .getProducts([JSON.parse(self.data.selectedPackage).id])
                .then(function(products) {
                    if (products.length > 0) {

                        self.placeOrder(JSON.parse(self.data.selectedPackage)).then(function(order) {

                            var createdOrder = order;
                            inAppPurchase
                                .buy(createdOrder.g_package_id)
                                .then(function(data) {

                                    OrderSvr.orderGPayCall(JSON.stringify(data), createdOrder.user_orders_id, "completed").then(function() {
                                        // TODO OK
                                    }, function() {
                                        // TODO OK
                                    });

                                    return inAppPurchase.consume(data.type, data.receipt, data.signature);
                                })
                                .then(function() {

                                    $state.go('app.zeenking');

                                })
                                .catch(function(err) {

                                    OrderSvr.orderGPayCall(JSON.stringify(err), createdOrder.user_orders_id, "Failed").then(function() {
                                        // TODO OK
                                    }, function() {
                                        // TODO OK
                                    });

                                    AppUtil.alert("Not able to complete payment. Try again after some time");

                                    $state.go('app.zeenking');
                                });

                        }, function() {
                            AppUtil.alert("Not able to complete payment. Try again after some time");
                        });
                    }
                })
                .catch(function(err) {

                    if (err !== undefined && typeof err === 'string' && err.indexOf("another async operation(refresh inventory) is in progress") > -1) {
                        //
                    } else {
                        AppUtil.alert("Not able to complete payment. Try again after some time");
                    }
                });
        }
    }

}

angular.module('app.comp.privacy')

.controller('PrivacyCtrl', PrivacyCtrl);

PrivacyCtrl.$inject = ["$sce", "WebPages", "AppConf", "AppUtil", "$ionicLoading"];

function PrivacyCtrl($sce, WebPages, AppConf, AppUtil, $ionicLoading) {
    var self = this;

    self.data = {};

    $ionicLoading.show({
        template: 'Loading Privacy Policy...'
    });

    var iframe = document.getElementById('pc_frame');
    iframe.onload = function() {
        AppUtil.hideLoading();
    };

    self.data.src = $sce.trustAsResourceUrl(AppConf.getFullUrl() + "/pres/privacy.html");
}

angular.module('app.comp.profile')
    .controller('ProfileCtrl', function($scope, $stateParams, $timeout, $ionicPopover,
        $state, ZFBFactory, $ionicActionSheet, ProfileSvr, $ionicPosition, RefDataService, $filter, AppUtil) {

        $scope.data = angular.copy(ProfileSvr.me);
        if ($scope.data.herefor)
            $scope.data.herefor = RefDataService.getHereFor()[$scope.data.herefor];
        if ($scope.data.maritalstatus)
            $scope.data.maritalstatus = RefDataService.getStatus()[$scope.data.maritalstatus];
        if ($scope.data.education)
            $scope.data.education = RefDataService.getEducation()[$scope.data.education];
        if ($scope.data.employment)
            $scope.data.employment = RefDataService.getEmployment()[$scope.data.employment];
        if ($scope.data.horoscope)
            $scope.data.horoscope = RefDataService.getHoroscope()[$scope.data.horoscope];
        if ($scope.data.height)
            $scope.data.height = RefDataService.getHeight()[$scope.data.height];
        if ($scope.data.bodytype)
            $scope.data.bodytype = RefDataService.getBodytype()[$scope.data.bodytype];
        if ($scope.data.smoking)
            $scope.data.smoking = RefDataService.getSmoking()[$scope.data.smoking];
        if ($scope.data.drinking)
            $scope.data.drinking = RefDataService.getDrinking()[$scope.data.drinking];
        if ($scope.data.diet)
            $scope.data.diet = RefDataService.getDiet()[$scope.data.diet];
        if ($scope.data.income)
            $scope.data.income = RefDataService.getIncome()[$scope.data.income];

        if ($scope.data.languages) {
            $scope.data.lang = $scope.data.languages.split(',');
        }

        $scope.data.userPic = ProfileSvr.me.profilePic;

        $scope.showGrid = function() {
            $state.go('userimages');
        }

        $scope.editPersoanlInfo = function() {
            $state.go('personalProfile');
        }

        $scope.getSecondCountDown = function() {
            return AppUtil.dateDiff('s', new Date(), $scope.data.expired);
        }

        $scope.editAdditonalInfo = function() {
            $state.go('additionalProfile');
        };

        $scope.goPackages = function() {
            $state.go("order");
        }

        $scope.takePhoto = function() {

            $scope.popover.hide();
            $state.go('uploadimages', {
                source: Camera.PictureSourceType.CAMERA
            });
        }

        $scope.uploadFromGallery = function() {

            $scope.popover.hide();
            $state.go('uploadimages', {
                source: Camera.PictureSourceType.PHOTOLIBRARY
            });
        }

        $scope.onBlockedUsers = function() {
            $scope.userPopover.hide();
            $state.go('block');
        }

        $scope.deactivate = function() {
            $scope.userPopover.hide();
            $state.go("delete");
        }

        $ionicPopover.fromTemplateUrl('ImageGridPopover.html', {
            scope: $scope,
        }).then(function(popover) {
            $scope.popover = popover;
        });

        $ionicPopover.fromTemplateUrl('UserPopover.html', {
            scope: $scope,
        }).then(function(popover) {
            $scope.userPopover = popover;
        });

        $scope.$on('$destroy', function() {
            $scope.popover.hide();
            $scope.userPopover.hide();
        });

    });

angular.module('app.comp.ques')

.controller('QuesCtrl', QuesCtrl);

QuesCtrl.$inject = ["QuesSvr", "$ionicHistory", "AppConf"];

function QuesCtrl(QuesSvr, $ionicHistory, AppConf) {
    var self = this;

    self.list = [];
    self.cnt = 0;
    self.data = {};

    self.data.selectedType = '';

    self.init = function() {
        QuesSvr.init().then(function(res) {
            self.list = QuesSvr.all();
            self.nextRating();
        });
    }

    self.next = function() {

        QuesSvr.submitAns(angular.copy(self.data));

        self.nextRating();


    }

    self.finish = function() {

        QuesSvr.submitAns(angular.copy(self.data));

        AppConf.setLSItems('QCom','Y');

        setTimeout(function() {
            $ionicHistory.goBack(-1);
        }, 1000);

    }

    self.nextRating = function() {
        if (self.list.length > self.cnt) {
            self.data = self.list[self.cnt++];
        }
    }

    self.init();

}

angular.module('app.comp.termcondition')

.controller('TermConditionCtrl', TermConditionCtrl);

TermConditionCtrl.$inject = ["$sce", "WebPages", "AppConf", "AppUtil", "$ionicLoading"];

function TermConditionCtrl($sce, WebPages, AppConf, AppUtil, $ionicLoading) {
    var self = this;

    self.data = {};

    $ionicLoading.show({
        template: 'Loading Term & Conditions...'
    });

    var iframe = document.getElementById('pc_frame');
    iframe.onload = function() {
        AppUtil.hideLoading();
    };

    self.data.src = $sce.trustAsResourceUrl(AppConf.getFullUrl() + "/pres/terms.html");
}

angular.module('app.comp.tips')

.controller('TipsCtrl', function($scope, $state, $mdDialog, data, $filter) {

    $scope.datalist = angular.copy(data);

    $scope.skipall = function() {
    	$mdDialog.hide('skipall');
    }

    $scope.done = function() {
    	$mdDialog.hide('complete');
    }

});

angular.module('app.comp.unmatch')
    .controller('BlockCtrl', function($scope, $stateParams, $timeout, UnmatchSvr, $ionicHistory, $state, $filter) {


        $scope.dataList = UnmatchSvr.all();
        $scope.deleteble = false;

        $scope.reload = function() {
            UnmatchSvr.init().then(function() {
                $scope.dataList = UnmatchSvr.all();
            });
        }

        $scope.onHold = function($event) {
            $scope.deleteble = !$scope.deleteble;
            if ($event) {
                $timeout(function() {
                    angular.element($event.currentTarget).triggerHandler('click');
                }, 0);
            }
        }

        $scope.delete = function(userID) {

            var users = $filter("filter")($scope.dataList, {
                checked: true
            });

            var redIds = [];
            angular.forEach(users, function(user) {
                redIds.push(user.id);
            });

            UnmatchSvr.deleteByID(redIds).then(function() {
                $scope.reload();
            }, function() {
                $scope.reload();
            });

            $scope.onHold();
        }

        $scope.reload();

    });

angular.module('app.comp.unmatch')
    .controller('UnmatchCtrl', UnmatchCtrl);

UnmatchCtrl.$inject = ["$scope", "$stateParams", "$ionicHistory", "$state", "UnmatchSvr"];

function UnmatchCtrl($scope, $stateParams, $ionicHistory, $state, UnmatchSvr) {
    var self = this;

    self.data = {};
    self.data.isBlocked = $stateParams.isBlocked;
    self.data.user_id = $stateParams.user_id;
    self.data.selectedReason = 'Bad Behaviour';
    self.data.review = 'Bad Behaviour';

    $scope.$watch(function() {
        return self.data.selectedReason;
    }, function(newv, oldv) {
        if (newv == 'Other')
            self.data.review = null;
        else
            self.data.review = angular.copy(self.data.selectedReason);
    });

    self.saveReason = function() {
        UnmatchSvr.addNew(self.data).then(function() {
            $state.go('app.zeenking', {
                user: JSON.stringify($stateParams.user_id)
            });
        });
    }
}

angular.module('app.comp.user')
    .controller('UserCtrl', function($scope, $stateParams, $timeout,
        $state, $ionicActionSheet, UserSvr, RefDataService, $filter, LikeSvr,
        FavouriteSvr, $ionicPosition, VisitorSvr, $mdDialog, $ionicPopover, AppUtil) {

        var user_id = JSON.parse($stateParams.user);
        $scope.data = null;

        $scope.dataProgress = 50;

        setTimeout(function() {
            UserSvr.retriveUser(user_id).then(function(res) {
                if (res.length > 0) {
                    $scope.data = angular.copy(res[0]);
                    $scope.initialize();
                }
            });
        }, 10);

        $scope.initialize = function() {

            if (!$scope.data.isvisited || $scope.data.isvisited == 'N') {
                VisitorSvr.addVisitor($scope.data.user_id).then(function() {
                    user = UserSvr.get($scope.data.user_id);
                    if (user) {
                        user.isvisited = 'Y';
                    }
                });
            }

            if($scope.data.pmatch <= 0){
                $scope.data.pmatch = Math.floor(Math.random()*(95-60+1)+60);
            }

            if ($scope.data.herefor)
                $scope.data.herefor = RefDataService.getHereFor()[$scope.data.herefor];
            if ($scope.data.maritalstatus)
                $scope.data.maritalstatus = RefDataService.getStatus()[$scope.data.maritalstatus];
            if ($scope.data.education)
                $scope.data.education = RefDataService.getEducation()[$scope.data.education];
            if ($scope.data.employment)
                $scope.data.employment = RefDataService.getEmployment()[$scope.data.employment];
            if ($scope.data.horoscope)
                $scope.data.horoscope = RefDataService.getHoroscope()[$scope.data.horoscope];
            if ($scope.data.height)
                $scope.data.height = RefDataService.getHeight()[$scope.data.height];
            if ($scope.data.bodytype)
                $scope.data.bodytype = RefDataService.getBodytype()[$scope.data.bodytype];
            if ($scope.data.smoking)
                $scope.data.smoking = RefDataService.getSmoking()[$scope.data.smoking];
            if ($scope.data.drinking)
                $scope.data.drinking = RefDataService.getDrinking()[$scope.data.drinking];
            if ($scope.data.diet)
                $scope.data.diet = RefDataService.getDiet()[$scope.data.diet];
            if ($scope.data.income)
                $scope.data.income = RefDataService.getIncome()[$scope.data.income];

            if ($scope.data.languages) {
                $scope.data.lang = $scope.data.languages.split(',');
            }

            $scope.disableLiking = false;
            if ($scope.data.islike !== undefined && $scope.data.islike !== null && $scope.data.islike != 'null') {
                $scope.disableLiking = true;
            }

            $scope.data.userPic = "assets/img/no-user.png";
            if ($scope.data.photos) {
                var profilePics = $filter("filter")($scope.data.photos, {
                    isprofile: 'Y'
                });
                if (profilePics.length > 0) {
                    $scope.data.userPic = profilePics[0].photopath;
                }
            }
        }

        $scope.doLike = function(user_id, action) {

            if (!$scope.disableLiking) {
                AppUtil.showLoading();
                if (action) {

                    $scope.disableLiking = true;
                    LikeSvr.like(user_id).then(function(argument) {
                        if ($scope.data.user_id == user_id)
                            $scope.data.islike = 'Y';

                        if ($scope.data.likedme == 'Y') {
                            $scope.openMatchedPopUp();
                        }

                        AppUtil.hideLoading();
                    }, function(res) {
                        AppUtil.hideLoading();
                        $scope.disableLiking = false;
                        AppUtil.alert(res);
                    });
                } else {

                    $scope.disableLiking = true;
                    LikeSvr.unLike(user_id).then(function(argument) {
                        if ($scope.data.user_id == user_id)
                            $scope.data.islike = 'N';

                        AppUtil.hideLoading();
                    }, function(res) {
                        AppUtil.hideLoading();
                        $scope.disableLiking = false;
                        AppUtil.alert(res);
                    });
                }
            }
        }

        $scope.openMatchedPopUp = function() {
            var customFullscreen = false;
            $mdDialog.show({
                controller: 'MatchCtrl',
                templateUrl: 'app/comp/match/match.html',
                parent: angular.element(document.body),
                clickOutsideToClose: true,
                locals: {
                    data: $scope.data
                },
                fullscreen: customFullscreen // Only for -xs, -sm breakpoints.
            });

        }

        $scope.doFavourite = function(user_id, action) {

            AppUtil.showLoading();
            if (action) {
                FavouriteSvr.setFavourite(user_id).then(function() {
                    if ($scope.data.user_id == user_id)
                        $scope.data.isfvt = 'Y';

                    AppUtil.hideLoading();
                }, function() {
                    AppUtil.hideLoading();
                });
            } else {
                FavouriteSvr.setUnFavourite(user_id).then(function() {
                    if ($scope.data.user_id == user_id)
                        $scope.data.isfvt = 'N';

                    AppUtil.hideLoading();
                }, function() {
                    AppUtil.hideLoading();
                });
            }
        }

        $scope.openQuestionaries = function() {
            $state.go('ques', {});
        }

        $scope.showPhotos = function(url) {

            var obj = {
                images: JSON.stringify($scope.data.photos),
                isDeletable: false
            };
            if (url) {
                var sel = 0;
                angular.forEach($scope.data.photos, function(photo, key) {
                    if (photo.photopath == url)
                        sel = key;
                });
                obj.selected = sel;
            }

            $state.go('previewimages', obj);
        }

        $scope.showMessages = function() {
            $state.go('chat', {
                user: JSON.stringify($scope.data)
            });
        }

        $ionicPopover.fromTemplateUrl('UnmatchPopover.html', {
            scope: $scope,
        }).then(function(popover) {
            $scope.popover = popover;
        });

        $scope.$on('$destroy', function() {
            $scope.popover.hide();
        });

        $scope.reportUser = function() {

            $scope.popover.hide();
            // $scope.data.isBlocked = false;
            $state.go("unmatch", {
                isBlocked: 'N',
                user_id: $scope.data.user_id
            });
        }

        $scope.blockUser = function() {

            $scope.popover.hide();
            // $scope.data.isBlocked = true;
            $state.go("unmatch", {
                isBlocked: 'Y',
                user_id: $scope.data.user_id
            });
        }

    });

angular.module('app.comp.visitor')

.controller('VisitorCtrl', function($scope, $stateParams, $timeout, VisitorSvr, $ionicHistory, $state, $filter,
    ProfileSvr, AppUtil, $ionicPopup) {


    $scope.dataList = VisitorSvr.all();
    $scope.deleteble = false;
    $scope.limit = 15;
    $scope.ispremium = angular.copy(ProfileSvr.me.ispremium);

    $scope.reload = function() {
        VisitorSvr.init().then(function() {
            $scope.dataList = VisitorSvr.all();
        });
    }

    $scope.onHold = function($event) {
        $scope.deleteble = !$scope.deleteble;
        if ($event) {
            $timeout(function() {
                angular.element($event.currentTarget).triggerHandler('click');
            }, 0);
        }
    }

    $scope.loadMore = function() {
        $scope.limit += 6;
        $scope.$broadcast('scroll.infiniteScrollComplete');
    }

    $scope.openUser = function(user_id, recordID, seen) {

        var user = $filter("filter")($scope.dataList, {
            user_id: user_id
        });
        if (user.length > 0) {
            // if ($scope.ispremium == 'Y') {
                $ionicHistory.clearCache().then(function() {
                    $state.go('app.user', {
                        user: JSON.stringify(user[0].user_id)
                    });
                });
                if ((!seen || seen != 'Y') && recordID) {
                    VisitorSvr.updateSeen(recordID).then(function() {
                        // $scope.dataList = FavouriteSvr.all();
                    });
                }
            // } else {

            //     $scope.confirmPopup = $ionicPopup.show({
            //         title: 'Premium membership',
            //         template: "<b>In order to use this feature you need to be a premium member." +
            //             " You can either purchase or get free membership by inviting your friends.</b>",
            //         buttons: [{
            //             text: 'Purchase',
            //             //type: 'button-positive',
            //             onTap: function(e) {
            //                 $scope.closePopup();
            //                 $state.go("order");
            //             }
            //         }, {
            //             text: 'Invite',
            //             onTap: function(e) {
            //                 $scope.closePopup();
            //                 $state.go("app.invite");
            //             }
            //         }]
            //     });
            // }
        }
    }

    $scope.closePopup = function() {
        if ($scope.confirmPopup)
            $scope.confirmPopup.close();
    };

    $scope.$on('$destroy', function() {
        $scope.closePopup();
    });

    $scope.delete = function(userID) {

        var users = $filter("filter")($scope.dataList, {
            checked: true
        });

        var redIds = [];
        angular.forEach(users, function(user) {
            redIds.push(user.id);
        });

        VisitorSvr.deleteByID(redIds).then(function() {
            $scope.reload();
        }, function() {
            $scope.reload();
        });

        $scope.onHold();
    }

    setTimeout(function() {
        $scope.reload();
    }, 10);

});

angular.module('app.comp.zeenking')
    .controller('ZeenkingCtrl', function($scope, $stateParams, $timeout,
        $state, $ionicActionSheet, ZeenkingSvr, LikeSvr, $ionicPosition,
        RefDataService, $filter, $mdDialog, AppConf, AppUtil) {

        $scope.list = [];
        $scope.data = null;
        $scope.dataloader = null;
        $scope.zeenkingcount = 0;

        $scope.loadData = function(now) {

            if (now) {
                ZeenkingSvr.init(now).then(function() {
                    angular.copy(ZeenkingSvr.list, $scope.list);
                    $scope.nextUser();

                });
            } else {
                if (!$scope.dataloader) {
                    $scope.dataloader = setInterval(function() {
                        ZeenkingSvr.init().then(function() {
                            angular.copy(ZeenkingSvr.list, $scope.list);
                            $scope.nextUser();
                        });
                    }, 20000);
                }
            }
        }

        $scope.doLike = function(user_id, action) {

            AppUtil.showLoading();
            if (action) {
                LikeSvr.like(user_id).then(function(argument) {
                    if ($scope.data.likedme == 'Y') {
                        $scope.openMatchedPopUp();
                    } else {
                        $scope.nextUser();
                    }
                    AppUtil.hideLoading();
                }, function(res) {
                    AppUtil.hideLoading();
                    AppUtil.alert(res);
                });
            } else {
                LikeSvr.unLike(user_id).then(function(argument) {
                    $scope.nextUser();
                    AppUtil.hideLoading();
                }, function(res) {
                    AppUtil.alert(res);
                    AppUtil.hideLoading();
                });
            }
        }

        $scope.openMatchedPopUp = function() {
            $mdDialog.show({
                    controller: 'MatchCtrl',
                    templateUrl: 'app/comp/match/match.html',
                    parent: angular.element(document.body),
                    clickOutsideToClose: true,
                    locals: {
                        data: $scope.data
                    },
                    fullscreen: false // Only for -xs, -sm breakpoints.
                })
                .then(function(action) {
                    //TODO
                }, function() {
                    $scope.nextUser();
                });
        }

        $scope.nextUser = function() {
            if ($scope.data)
                ZeenkingSvr.remove($scope.data);
            if ($scope.list.length >= 1) {

                if ($scope.dataloader) {
                    clearInterval($scope.dataloader);
                    $scope.dataloader = null;
                }

                $scope.data = {};
                $scope.data = $scope.list.shift();
                $scope.ondataChange();

            } else {
                $scope.data = null;
                $scope.loadData();
            }
        }

        $scope.ondataChange = function() {

            $scope.data.userPic = "assets/img/no-user.png";
            if ($scope.data.photos) {

                var profilePics = $filter("filter")($scope.data.photos, {
                    isprofile: 'Y'
                });
                if (profilePics.length > 0) {
                    $scope.data.userPic = profilePics[0].photopath;
                }
            }

            if ($scope.data.herefor)
                $scope.data.herefor = RefDataService.getHereFor()[$scope.data.herefor];
            if ($scope.data.maritalstatus)
                $scope.data.maritalstatus = RefDataService.getStatus()[$scope.data.maritalstatus];
            if ($scope.data.education)
                $scope.data.education = RefDataService.getEducation()[$scope.data.education];
            if ($scope.data.employment)
                $scope.data.employment = RefDataService.getEmployment()[$scope.data.employment];
            if ($scope.data.horoscope)
                $scope.data.horoscope = RefDataService.getHoroscope()[$scope.data.horoscope];
            if ($scope.data.height)
                $scope.data.height = RefDataService.getHeight()[$scope.data.height];
            if ($scope.data.bodytype)
                $scope.data.bodytype = RefDataService.getBodytype()[$scope.data.bodytype];
            if ($scope.data.smoking)
                $scope.data.smoking = RefDataService.getSmoking()[$scope.data.smoking];
            if ($scope.data.drinking)
                $scope.data.drinking = RefDataService.getDrinking()[$scope.data.drinking];
            if ($scope.data.diet)
                $scope.data.diet = RefDataService.getDiet()[$scope.data.diet];
            if ($scope.data.income)
                $scope.data.income = RefDataService.getIncome()[$scope.data.income];

            if ($scope.data.languages) {
                $scope.data.lang = $scope.data.languages.split(',');
            }

            $scope.disableLiking = false;
            if ($scope.data.islike !== undefined && $scope.data.islike !== null && $scope.data.islike != 'null') {
                $scope.disableLiking = true;
            }

            $scope.zeenkingcount = $scope.zeenkingcount + 1;
            $scope.triggerTimer();
        }

        $scope.triggerTimer = function() {

            if (($scope.zeenkingcount % 10) == 0) {

                var admobid = {
                    interstitial: 'ca-app-pub-7555979693409401/5610264349'
                };

                AdMob.isInterstitialReady(function() {
                    AdMob.showInterstitial();
                }, function() {
                    AdMob.prepareInterstitial({
                        adId: admobid.interstitial,
                        autoShow: false
                    }, function() {
                        AdMob.showInterstitial();
                    });
                });

            } else if (($scope.zeenkingcount % 25) == 0) {
                AppConf.getFeedBack();
            }
        };

        $scope.showPhotos = function(url) {

            var obj = {
                images: JSON.stringify($scope.data.photos),
                isDeletable: false
            };
            if (url) {
                var sel = 0;
                angular.forEach($scope.data.photos, function(photo, key) {
                    if (photo.photopath == url)
                        sel = key;
                });
                obj.selected = sel;
            }

            $state.go('previewimages', obj);
        }


        setTimeout(function() {
            $scope.loadData(true);
        }, 10);

    });

angular.module('app.core.fortumo')

.controller('FortumoCtrl', FortumoCtrl);

FortumoCtrl.$inject = ["$sce", "AppConf", "$state", "$scope", "$http", "AppUtil", "$stateParams", "FortumoSvr", "OrderSvr"];

function FortumoCtrl($sce, AppConf, $state, $scope, $http, AppUtil, $stateParams, FortumoSvr, OrderSvr) {

    var self = this;
    self.data = {};

    // TODO Get ID,Amount , Qty from passed param and based on amt and qty display fortumo product

    function getCatalog() {
        return $http({
            method: 'GET',
            url: 'http://pay.fortumo.com/mobile_payments/e74ca277a881cbc03921893dd1aea5ac.xml',
        })
    }

    var iframe = document.getElementById('Fortumo_If');
    iframe.onload = function() {
        AppUtil.hideLoading();
    };

    try {

        AppUtil.showLoading();
        getCatalog().then(function(response) {
            // TODO go to back page
            if (response) {
                var x2js = new X2JS();
                var jsonObj = x2js.xml_str2json(response.data);
                if (jsonObj && jsonObj.payment && jsonObj.payment.countries)
                    self.init(jsonObj);
                else {
                    error("Someting going wrong", "Service data not available");
                }
            }
        }, function(err) {
            error("Someting going wrong", err);
        })
    } catch (err) {
        error("Someting going wrong", err);
    }

    function getPricePoint(jsonObj, order_price) {
        var selectedPricePoint = 0;
        if (angular.isDefined(jsonObj.countries.country.price_points.price_point)) {
            var pricePoints = jsonObj.countries.country.price_points.price_point;
            for (pricePoint in pricePoints) {
                if (pricePoints[pricePoint]._price == order_price) {
                    selectedPricePoint = pricePoints[pricePoint]._id;
                    break;
                }
            }
        }
        return selectedPricePoint;
    }

    self.init = function(jsonObj) {

        if ($stateParams && $stateParams.cuid && $stateParams.tc_id && $stateParams.tc_amount) {
            AppUtil.showLoading();
            var fcbURL = encodeURIComponent(document.location.href);
            var orderJSON = JSON.parse($stateParams.cuid);
            //var tc_amount = $stateParams.tc_amount;
            var tc_amount = $stateParams.tc_amount;
            var tc_id = parseInt(getPricePoint(jsonObj.payment, $stateParams.tc_id));


            OrderSvr.generateOrder(orderJSON).then(
                function(order) {

                    self.cuid = order.user_orders_id;
                    FortumoSvr.getSIG('cuid=' + self.cuid + 'tc_amount=' + tc_amount + 'tc_id=' + tc_id).then(function(sig) {

                        var paymentURL = 'http://pay.fortumo.com/mobile_payments/e74ca277a881cbc03921893dd1aea5ac';
                        paymentURL += '?cuid=' + self.cuid;
                        paymentURL += '&tc_id=' + tc_id;
                        paymentURL += '&tc_amount=' + tc_amount;
                        paymentURL += '&sig=' + sig;
                        paymentURL += '&fcb=' + fcbURL;

                        self.data.src = $sce.trustAsResourceUrl(paymentURL);

                        window.addEventListener("message", receiveMessage, false);

                    }, function(error) {
                        error("Someting going wrong", error);
                    });
                },
                function(res) {
                    error("Someting going wrong", null);
                }
            );
        }
    }

    function receiveMessage(event) {
        var origin = event.origin || event.originalEvent.origin; // For Chrome, the origin property is in the event.originalEvent object.
        if (origin == "https://pay.fortumo.com" || origin == "http://pay.fortumo.com") {
            if (event.data.indexOf("fmpId:") >= 0) {
                setTimeout(function() {
                    $scope.$apply(function() {
                        self.cuid = undefined;
                        $state.go('app.zeenking');
                    });
                }, 2000);
            }
        } else {
            return;
        }
    }

    function error(msg, error) {

        if (self.cuid && error) {

            if (typeof error === 'string') {
                var obj = {};
                obj.msg = error
                error = obj;
            }
            OrderSvr.orderFortumoCall(JSON.stringify(error), self.cuid, "Failed");
            self.cuid = undefined;
        }

        AppUtil.hideLoading();
        AppUtil.alertCall(msg).then(function() {
            $state.go('app.zeenking');
        });
    }

    $scope.$on("$ionicView.afterLeave", function(event, data) {
        self.cuid = undefined;
    });

    $scope.$on("$ionicView.beforeLeave", function(event, data) {
        if (self.cuid) {
            error = "User cancelled payment";
            if (typeof error === 'string') {
                var obj = {};
                obj.msg = error
                error = obj;
            }
            OrderSvr.orderFortumoCall(JSON.stringify(error), self.cuid, "Failed");
            self.cuid = undefined;
        }
    });
}

angular.module('app.core.login')
    .controller('LoginCtrl', function($scope, $timeout, $stateParams, $state, OTPSvr,
        ZLogin, $ionicLoading, AuthService, ProfileSvr, zsocket, ChatSvr, $window, AppUtil,
        $ionicHistory, TipsSvr, AppConf) {

        $scope.forcereload = $stateParams.forcereload ? $stateParams.forcereload : false;
        $scope.data = {};
        $scope.data.phone = "";
        $scope.country = AppConf.country;

        $scope.login = function() {
            ZLogin.login('facebook').then(function(loginRes) {
                ZLogin.add_Update_login_cong('FB');
                ProfileSvr.init(loginRes).then(function(res) {
                    $state.go(res);
                });
            }, function(res) {
                if (res !== undefined && res.errorMessage !== undefined) {
                    AppUtil.alert(res.errorMessage);
                } else {
                    AppUtil.alert("Not able to login with facebook");
                }
            });
        };

        $scope.loginmobile = function() {
            $state.go('login-mobile');
        }

        $scope.signupmobile = function() {
            $state.go('signup');
        }

        $scope.privacy = function() {
            $state.go("privacy");
        }

        $scope.varifyMobile = function(phone) {
            OTPSvr.varifyMobile($scope.data.phone + "")
                .then(function(response) {
                    $ionicHistory.clearCache().then(function() {
                        var param = {
                            phone: $scope.data.phone,
                            previus : 'login-mobile'
                        }
                        $state.go("otpvarify", param);
                    });
                }, function(err){
                    AppUtil.alert(err.Error);
                });
        }

        $scope.termcondition = function() {
            $state.go("termcondition");
        }

        if ($scope.forcereload) {
            $window.location.reload(true);
        }

        TipsSvr.open();

    });

angular.module('app.core.offline')

.controller('OfflineCtrl', function($state, $ionicHistory, $cordovaNetwork, $ionicPlatform) {


    // TODO

});

angular.module('app.core.otpvarify')
    .controller('Otpverify2Ctrl', Otpverify2Ctrl);

Otpverify2Ctrl.$inject = ["$stateParams", "$state", "$ionicHistory", "OTPSvr", "$timeout", "ProfileSvr",
    "$cordovaDevice", "ZFCMPushFactory", "ZLogin", "AppUtil"
];

function Otpverify2Ctrl($stateParams, $state, $ionicHistory, OTPSvr, $timeout, ProfileSvr,
    $cordovaDevice, ZFCMPushFactory, ZLogin, AppUtil) {

    var self = this;
    self.data = {};
    self.data.otpTimeout = false;
    self.data.phone = $stateParams.phone ? $stateParams.phone : "";
    self.data.previus = $stateParams.previus ? $stateParams.previus : "";

    var resendOTPCounter = function() {
        self.data.otpTimeout = true;
    }

    self.resendOTP = function() {
        self.data.otpTimeout = false;
        OTPSvr.sendcode(self.data.phone + "")
            .then(function(response) {
                console.log("OTP sent::");
                self.data.otpTimeout = false;
                $timeout(resendOTPCounter, 1000);
            });
    }

    self.verify = function() {
        // $state.go('app.zeenking');

        var deviceInfo = {
            device_token: 'undefined',
            device_uu: $cordovaDevice.getUUID(),
            device_type: $cordovaDevice.getPlatform()
        }

        OTPSvr.varify(self.data.otp + "", self.data.phone + "", deviceInfo)
            .then(function(response) {
                if (ProfileSvr.initParam == null) {

                    ZLogin.add_Update_login_cong('MB', self.data.phone + "");

                    ProfileSvr.init({
                        'mobile': self.data.phone + ""
                    }).then(function(res) {
                        $state.go(res);
                    });
                } else {
                    ProfileSvr.init().then(function(res) {
                        $state.go(res);
                    });
                }
            }, function(res){
                AppUtil.alert(res.Error);
            });
    }

    self.editNumber = function() {
        $ionicHistory.clearCache().then(function() {
            if (self.data.previus) {
                $state.go(self.data.previus);
            } else {
                $state.go("smsvarify");
            }
        });

    }

    $timeout(resendOTPCounter, 60000);
}

angular.module('app.core.otpvarify')
    .controller('OtpverifyCtrl', OtpverifyCtrl);

OtpverifyCtrl.$inject = ["$state", "$ionicHistory", "OTPSvr", "$stateParams", "ProfileSvr", "AppUtil"];

function OtpverifyCtrl($state, $ionicHistory, OTPSvr, $stateParams, ProfileSvr, AppUtil) {
    var self = this;
    self.data = {};
    self.data.user = ProfileSvr.me.user_id;

    self.sendCode = function() {
        OTPSvr.sendcode(self.data.phone+"", self.data.user+"")
            .then(function(response) {
                $ionicHistory.clearCache().then(function() {
                    var param = {
                        phone:self.data.phone,
                        previus: 'smsvarify'
                    }
                    $state.go("otpvarify", param);
                });
            }, function(res){
                AppUtil.alert(res.Error);
            });        
    }
}

angular.module('app.core.setting').controller(
    'SysSettingCtrl',
    function($scope, $state, $http, AD_SysConfig, AppConf,DBSvc) {

        $scope.$on('$ionicView.loaded', function() {
            $scope.sysConfigList = [];
            angular.copy(AD_SysConfig.filterByConfigType(), $scope.sysConfigList);
            for (var i = 0; i < $scope.sysConfigList.length; i++) {
                if ($scope.sysConfigList[i].datatype == "number" || $scope.sysConfigList[i].datatype == "checkbox") {
                    $scope.sysConfigList[i].value = angular.fromJson($scope.sysConfigList[i].value);
                }
                $scope.sysConfigList[i].name = $scope.sysConfigList[i].name.substring($scope.sysConfigList[i].name.lastIndexOf('.')+1,$scope.sysConfigList[i].name.length);
            }
        });

        $scope.onSysSettingSubmit = function() {
            AD_SysConfig.addArray($scope.sysConfigList);
            if (AppConf.isLogin()) {
                $state.go('application.home');
            } else {
                $state.go('appLogin');
            }
        }
        $scope.dbCleanUtil = function(){
          var sql = 'DROP Table ';
            var tables = DBSvc.query(sql + 'AD_SysConfig', []);
             tables = DBSvc.query(sql + 'APP_Images', []);
             tables = DBSvc.query(sql + 'APP_Migration', []);
             tables = DBSvc.query(sql + 'APP_MigrationSql', []);
             tables = DBSvc.query(sql + 'm_inoutline', []);
             tables = DBSvc.query(sql + 'x_route', []);
             tables = DBSvc.query(sql + 'x_routelines', []);
             tables = DBSvc.query(sql + 'x_vehicle_test', []);
             tables = DBSvc.query(sql + 'x_vehicle_test_instance', []);
             tables = DBSvc.query(sql + 'X_Vehicle_testgroup', []);
             tables = DBSvc.query(sql + 'x_vehicle_testline', []);
             tables = DBSvc.query(sql + 'X_Vehicle_TestLineInstance', []);
            // tables = DBSvc.query(sql,['APP_Images']);

            console.log(tables);
        }
    });

angular.module('app.core.signup')
    .controller('SignupCtrl', function($scope, $state, RefDataService, $timeout, $ionicHistory,
        ionicDatePicker, ProfileSvr, zsocket, ChatSvr, $http, AppUtil, $rootScope) {

        $ionicHistory.nextViewOptions({
            historyRoot: false
        });

        $scope.data = ProfileSvr.me;
        $scope.emailReadOnly = false;
        if ($scope.data === undefined || $scope.data === null) {
            $scope.data = {};
        }

        if ($scope.data.email !== undefined && $scope.data.email !== null && $scope.data.email.length > 0) {
            $scope.emailReadOnly = true;
        }

        $scope.tc = {};
        $scope.tc.accept = false;
        RefDataService.getTC().then(function(res) {
            $scope.tc.text = res;
        });

        $scope.forms = {};

        if ($scope.data.birthdate) {
            $scope.data.birthdate = new Date($scope.data.birthdate);
            $scope.data.dbirthdate = $scope.data.birthdate.getDate() + ' / ' + ($scope.data.birthdate.getMonth() + 1) +
                ' / ' + $scope.data.birthdate.getFullYear();
        }

        var options = {
            enableHighAccuracy: false
        };

        navigator.geolocation.getCurrentPosition(function(position) {

            $http.get('http://maps.googleapis.com/maps/api/geocode/json?latlng=' +
                    parseFloat(position.coords.latitude) + ',' + parseFloat(position.coords.longitude) + '&sensor=true')
                .success(function(data, status, headers, config) {
                    $scope.data.location = data.results[data.results.length - 3].formatted_address;
                })
                .then(function(result) {
                    console.log("Data:" + result);
                });

        }, function(err) {
            console.log("Error:" + err);
        }, options);

        $scope.viewName = "Main";

        // Page Managment
        $scope.currentPage = 0;
        $scope.HistoryPages = [];

        $scope.smokingList = RefDataService.getSmoking();
        $scope.bodyTypeList = RefDataService.getBodytype();
        // $scope.dietList = RefDataService.getDiet();
        $scope.drinkingList = RefDataService.getDrinking();
        $scope.employmentList = RefDataService.getEmployment();
        $scope.statusList = RefDataService.getStatus();
        // $scope.horoscopeList = RefDataService.getHoroscope();
        $scope.languageList = RefDataService.getLanguage();
        $scope.educationList = RefDataService.getEducation();
        $scope.hereForList = RefDataService.getHereFor();
        $scope.heightList = RefDataService.getHeight();
        $scope.incomeList = RefDataService.getIncome();
        // $scope.castList = Object.keys(RefDataService.getCaste());
        // $scope.religionList = Object.keys(RefDataService.getReligion());

        $scope.setValidity = function() {
            angular.forEach($scope.forms.signupForm.$error.required, function(field) {
                $timeout(function() {
                    if (field.$name == 'filtro') {
                        field.$setDirty();
                        field.$setTouched();
                    }
                }, 0);
            });
            return true;
        };

        $scope.prevButtonVisible = false;
        $scope.nextButtonVisible = false;
        /*
         * To traverse from one page to next page
         */
        $scope.nextPage = function(pageindex) {

            if ($scope.currentPage > 0)
                $scope.HistoryPages.push($scope.currentPage);
            if (pageindex)
                $scope.currentPage = pageindex;
            else
                $scope.currentPage = $scope.currentPage + 1;

            $state.go("signup." + $scope.currentPage);

            if ($scope.HistoryPages.length > 0) {
                $scope.prevButtonVisible = true;
            }

            if ($scope.currentPage == 4) {
                $scope.nextButtonVisible = false;
            } else {
                $scope.nextButtonVisible = true;
            }
        }



        $scope.previousPage = function() {

            if ($scope.HistoryPages.length > 0) {
                $scope.currentPage = $scope.HistoryPages.pop();
                $state.go("signup." + $scope.currentPage);

                $scope.nextButtonVisible = true;
                if ($scope.HistoryPages.length == 0) {
                    $scope.prevButtonVisible = false;
                }
            }
        }

        $scope.showDatePicker = function() {

            var firstDate = new Date();
            firstDate.setYear(firstDate.getYear() - 100);
            var lastDate = new Date();
            lastDate.setYear(lastDate.getYear() - 18);
            var inputDate = new Date();
            inputDate.setYear(lastDate.getYear());
            inputDate.setDate(inputDate.getDate());
            var iscallback = false;

            if ($scope.data.birthdate) {
                inputDate = $scope.data.birthdate;
            }

            var options = {
                date: inputDate,
                mode: 'date',
                minDate: ionic.Platform.isIOS() ? firstDate : (firstDate).valueOf(),
                maxDate: ionic.Platform.isIOS() ? lastDate : (lastDate).valueOf()
            };

            function onSuccess(date) {
                if (!iscallback) {
                    iscallback = true;
                    newVal = date;
                    if (inputDate.getFullYear() === newVal.getFullYear() &&
                        inputDate.getMonth() === newVal.getMonth() &&
                        inputDate.getDate() === newVal.getDate()) {

                        AppUtil.confirm("Are you sure you have selected a correct date ? ", "Confirm Date").then(function() {

                            if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
                                $rootScope.$apply(function() {
                                    $scope.data.birthdate = newVal;
                                    var diff = $scope.data.birthdate.getFullYear() - $scope.data.passingYear;
                                    if (diff > 0) {
                                        AppUtil.alert('Something is wrong!Education Passing year:' + $scope.data.passingYear);
                                        $scope.data.birthdate = "";
                                        return;
                                    }
                                    var d = newVal;
                                    $scope.data.dbirthdate = d.getDate() + ' / ' + (d.getMonth() + 1) + ' / ' + d.getFullYear();
                                });
                            } else {
                                $scope.data.birthdate = newVal;
                                var diff = $scope.data.birthdate.getFullYear() - $scope.data.passingYear;
                                if (diff > 0) {
                                    AppUtil.alert('Something is wrong!Education Passing year:' + $scope.data.passingYear);
                                    $scope.data.birthdate = "";
                                    return;
                                }
                                var d = newVal;
                                $scope.data.dbirthdate = d.getDate() + ' / ' + (d.getMonth() + 1) + ' / ' + d.getFullYear();
                            }


                        }, function() {
                            $scope.showDatePicker();
                        });

                    } else {

                        if ($rootScope.$root.$$phase != '$apply' && $rootScope.$root.$$phase != '$digest') {
                            $rootScope.$apply(function() {

                                $scope.data.birthdate = newVal;
                                var diff = $scope.data.birthdate.getFullYear() - $scope.data.passingYear;
                                if (diff > 0) {
                                    AppUtil.alert('Something is wrong!Education Passing year:' + $scope.data.passingYear);
                                    $scope.data.birthdate = "";
                                    return;
                                }
                                var d = newVal;
                                $scope.data.dbirthdate = d.getDate() + ' / ' + (d.getMonth() + 1) + ' / ' + d.getFullYear();

                            });
                        } else {
                            $scope.data.birthdate = newVal;
                            var diff = $scope.data.birthdate.getFullYear() - $scope.data.passingYear;
                            if (diff > 0) {
                                AppUtil.alert('Something is wrong!Education Passing year:' + $scope.data.passingYear);
                                $scope.data.birthdate = "";
                                return;
                            }
                            var d = newVal;
                            $scope.data.dbirthdate = d.getDate() + ' / ' + (d.getMonth() + 1) + ' / ' + d.getFullYear();
                        }
                    }
                    iscallback = false;
                }
            }

            function onError(error) { // Android only
                // alert('Error: ' + error);
                iscallback = false;
            }

            datePicker.show(options, onSuccess, onError);
        }

        /*
         * Store user choice on first page
         */
        $scope.setHereFor = function(hereFor) {
            $scope.data.herefor = hereFor;
            if ($scope.data.herefor == 'M' || $scope.data.herefor == 'Marriage')
                $scope.nextPage();
            else
                $scope.nextPage(3);
        };

        $scope.getSelectedText = function() {
            if ($scope.data.lang) {
                $scope.data.languages = $scope.data.lang.join(',');
                console.log("languages::" + $scope.data.languages);
                return $scope.data.lang.length + " : Languages selected"
            } else {
                return "Please select language";
            }
        }

        $scope.getMaxYear = function() {
            return new Date().getFullYear();
        }

        $scope.validationError = "";
        $scope.showError = function(strMsg) {
            $scope.validationError = strMsg;
            return "Passing year value should be between 1900 to " + $scope.getMaxYear();
        }

        $scope.back = function() {
            $ionicHistory.goBack();
        }

        $scope.finish = function(strMsg) {

            if ($scope.tc.accept) {
                ProfileSvr.completeSignUp($scope.data).then(function(argument) {
                    ProfileSvr.init(argument).then(function(res) {
                        $state.go(res);
                    });
                }, function(argument) {
                    AppUtil.alert(argument);
                });
            } else {
                AppUtil.alert("Please read and accept terms and conditions");
            }

        }

        $scope.setValidity = function() {
            angular.forEach($scope.forms.signupForm.$error.required, function(field) {
                $timeout(function() {
                    field.$setDirty();
                    field.$setTouched();
                }, 0);
            });
            return true;
        };
    });

angular.module('app.core.twitter')
    .controller('TwitterMsgCtrl', function($scope, $rootScope, $state, ngTwitter) {

        $scope.chats = [];

        // $scope.$parent.showHeader();
        // $scope.$parent.clearFabs();
        // $scope.isExpanded = false;
        // $scope.$parent.setExpanded(false);
        // $scope.$parent.setHeaderFab(false);

        if ($rootScope.twitterActivated) {
            ngTwitter.getFriends($rootScope.oauthObject).then(function(res) {
                $scope.chats = res.data.users;
            }, function(error) {
                alert("Error: " + error);
            }); //get friend list
        } else {
            ngTwitter.getAuthTwitter().then(function(result) {
                $rootScope.oauthObject = result;
                $rootScope.twitterActivated = true;
                $state.go('twitterMsg', {}, {
                    reload: true
                });
            }, function(error) {
                $state.go('app.invite');
                alert("Error -> " + error);
            });
        }

        $scope.data = {
            'message': ''
        }; // defind message

        $scope.selected = []; //defind selected 

        $scope.checkedOrNot = function(asset, isChecked, index) {
            if (isChecked) {
                $scope.selected.push(asset);
            } else {
                var _index = $scope.selected.indexOf(asset);
                $scope.selected.splice(_index, 1);
            }
        }; // assign selected checkbox value

        $scope.sendMessage = function() {
            ngTwitter.sendMessage($scope.selected, $scope.data.message, $rootScope.oauthObject);
        }; //send message
    });

//      ngTwitter.getUserInfo($rootScope.oauthObject).then(function(userInfo) {
//          $rootScope.userInfo = userInfo;
//      }, function(error) {
//          alert("Error: "+error);
//      }); //get account info

var statecity = {
	"Andaman and Nicobar Islands": [
		"Port Blair"
	],
	"Andhra Pradesh": [
		"Visakhapatnam",
		"Vijayawada",
		"Guntur",
		"Nellore",
		"Kurnool",
		"Rajahmundry",
		"Kakinada",
		"Tirupati",
		"Anantapur",
		"Kadapa",
		"Vizianagaram",
		"Eluru",
		"Ongole",
		"Nandyal",
		"Machilipatnam",
		"Adoni",
		"Tenali",
		"Chittoor",
		"Hindupur",
		"Proddatur",
		"Bhimavaram",
		"Madanapalle",
		"Guntakal",
		"Dharmavaram",
		"Gudivada",
		"Srikakulam",
		"Narasaraopet",
		"Rajampet",
		"Tadpatri",
		"Tadepalligudem",
		"Chilakaluripet",
		"Yemmiganur",
		"Kadiri",
		"Chirala",
		"Anakapalle",
		"Kavali",
		"Palacole",
		"Sullurpeta",
		"Tanuku",
		"Rayachoti",
		"Srikalahasti",
		"Bapatla",
		"Naidupet",
		"Nagari",
		"Gudur",
		"Vinukonda",
		"Narasapuram",
		"Nuzvid",
		"Markapur",
		"Ponnur",
		"Kandukur",
		"Bobbili",
		"Rayadurg",
		"Samalkot",
		"Jaggaiahpet",
		"Tuni",
		"Amalapuram",
		"Bheemunipatnam",
		"Venkatagiri",
		"Sattenapalle",
		"Pithapuram",
		"Palasa Kasibugga",
		"Parvathipuram",
		"Macherla",
		"Gooty",
		"Salur",
		"Mandapeta",
		"Jammalamadugu",
		"Peddapuram",
		"Punganur",
		"Nidadavole",
		"Repalle",
		"Ramachandrapuram",
		"Kovvur",
		"Tiruvuru",
		"Uravakonda",
		"Narsipatnam",
		"Yerraguntla",
		"Pedana",
		"Puttur",
		"Renigunta",
		"Rajam",
		"Srisailam Project (Right Flank Colony) Township"
	],
	"Arunachal Pradesh": [
		"Naharlagun",
		"Pasighat"
	],
	"Assam": [
		"Guwahati",
		"Silchar",
		"Dibrugarh",
		"Nagaon",
		"Tinsukia",
		"Jorhat",
		"Bongaigaon City",
		"Dhubri",
		"Diphu",
		"North Lakhimpur",
		"Tezpur",
		"Karimganj",
		"Sibsagar",
		"Goalpara",
		"Barpeta",
		"Lanka",
		"Lumding",
		"Mankachar",
		"Nalbari",
		"Rangia",
		"Margherita",
		"Mangaldoi",
		"Silapathar",
		"Mariani",
		"Marigaon"
	],
	"Bihar": [
		"Patna",
		"Gaya",
		"Bhagalpur",
		"Muzaffarpur",
		"Darbhanga",
		"Arrah",
		"Begusarai",
		"Chhapra",
		"Katihar",
		"Munger",
		"Purnia",
		"Saharsa",
		"Sasaram",
		"Hajipur",
		"Dehri-on-Sone",
		"Bettiah",
		"Motihari",
		"Bagaha",
		"Siwan",
		"Kishanganj",
		"Jamalpur",
		"Buxar",
		"Jehanabad",
		"Aurangabad",
		"Lakhisarai",
		"Nawada",
		"Jamui",
		"Sitamarhi",
		"Araria",
		"Gopalganj",
		"Madhubani",
		"Masaurhi",
		"Samastipur",
		"Mokameh",
		"Supaul",
		"Dumraon",
		"Arwal",
		"Forbesganj",
		"BhabUrban Agglomeration",
		"Narkatiaganj",
		"Naugachhia",
		"Madhepura",
		"Sheikhpura",
		"Sultanganj",
		"Raxaul Bazar",
		"Ramnagar",
		"Mahnar Bazar",
		"Warisaliganj",
		"Revelganj",
		"Rajgir",
		"Sonepur",
		"Sherghati",
		"Sugauli",
		"Makhdumpur",
		"Maner",
		"Rosera",
		"Nokha",
		"Piro",
		"Rafiganj",
		"Marhaura",
		"Mirganj",
		"Lalganj",
		"Murliganj",
		"Motipur",
		"Manihari",
		"Sheohar",
		"Maharajganj",
		"Silao",
		"Barh",
		"Asarganj"
	],
	"Chandigarh": [
		"Chandigarh"
	],
	"Chhattisgarh": [
		"Raipur",
		"Bhilai Nagar",
		"Korba",
		"Bilaspur",
		"Durg",
		"Rajnandgaon",
		"Jagdalpur",
		"Raigarh",
		"Ambikapur",
		"Mahasamund",
		"Dhamtari",
		"Chirmiri",
		"Bhatapara",
		"Dalli-Rajhara",
		"Naila Janjgir",
		"Tilda Newra",
		"Mungeli",
		"Manendragarh",
		"Sakti"
	],
	"Dadra and Nagar Haveli": [
		"Silvassa"
	],
	"Delhi": [
		"Delhi",
		"New Delhi"
	],
	"Goa": [
		"Marmagao",
		"Panaji",
		"Margao",
		"Mapusa"
	],
	"Gujarat": [
		"Ahmedabad",
		"Surat",
		"Vadodara",
		"Rajkot",
		"Bhavnagar",
		"Jamnagar",
		"Nadiad",
		"Porbandar",
		"Anand",
		"Morvi",
		"Mahesana",
		"Bharuch",
		"Vapi",
		"Navsari",
		"Veraval",
		"Bhuj",
		"Godhra",
		"Palanpur",
		"Valsad",
		"Patan",
		"Deesa",
		"Amreli",
		"Anjar",
		"Dhoraji",
		"Khambhat",
		"Mahuva",
		"Keshod",
		"Wadhwan",
		"Ankleshwar",
		"Savarkundla",
		"Kadi",
		"Visnagar",
		"Upleta",
		"Una",
		"Sidhpur",
		"Unjha",
		"Mangrol",
		"Viramgam",
		"Modasa",
		"Palitana",
		"Petlad",
		"Kapadvanj",
		"Sihor",
		"Wankaner",
		"Limbdi",
		"Mandvi",
		"Thangadh",
		"Vyara",
		"Padra",
		"Lunawada",
		"Rajpipla",
		"Umreth",
		"Sanand",
		"Rajula",
		"Radhanpur",
		"Mahemdabad",
		"Ranavav",
		"Tharad",
		"Mansa",
		"Umbergaon",
		"Talaja",
		"Vadnagar",
		"Manavadar",
		"Salaya",
		"Vijapur",
		"Pardi",
		"Rapar",
		"Songadh",
		"Lathi",
		"Adalaj",
		"Chhapra"
	],
	"Haryana": [
		"Faridabad",
		"Gurgaon",
		"Hisar",
		"Rohtak",
		"Panipat",
		"Karnal",
		"Sonipat",
		"Yamunanagar",
		"Panchkula",
		"Bhiwani",
		"Bahadurgarh",
		"Jind",
		"Sirsa",
		"Thanesar",
		"Kaithal",
		"Palwal",
		"Rewari",
		"Hansi",
		"Narnaul",
		"Fatehabad",
		"Gohana",
		"Tohana",
		"Narwana",
		"Mandi Dabwali",
		"Charkhi Dadri",
		"Shahbad",
		"Pehowa",
		"Samalkha",
		"Pinjore",
		"Ladwa",
		"Sohna",
		"Safidon",
		"Taraori",
		"Mahendragarh",
		"Ratia",
		"Rania",
		"Sarsod"
	],
	"Himachal Pradesh": [
		"Shimla",
		"Mandi",
		"Solan",
		"Nahan",
		"Sundarnagar",
		"Palampur"
	],
	"Jammu and Kashmir": [
		"Srinagar",
		"Jammu",
		"Baramula",
		"Anantnag",
		"Sopore",
		"KathUrban Agglomeration",
		"Rajauri",
		"Punch",
		"Udhampur"
	],
	"Jharkhand": [
		"Dhanbad",
		"Ranchi",
		"Jamshedpur",
		"Bokaro Steel City",
		"Deoghar",
		"Phusro",
		"Adityapur",
		"Hazaribag",
		"Giridih",
		"Ramgarh",
		"Jhumri Tilaiya",
		"Saunda",
		"Sahibganj",
		"Medininagar (Daltonganj)",
		"Chaibasa",
		"Chatra",
		"Gumia",
		"Dumka",
		"Madhupur",
		"Chirkunda",
		"Pakaur",
		"Simdega",
		"Musabani",
		"Mihijam",
		"Patratu",
		"Lohardaga",
		"Tenu dam-cum-Kathhara"
	],
	"Karnataka": [
		"Bengaluru",
		"Hubli-Dharwad",
		"Belagavi",
		"Mangaluru",
		"Davanagere",
		"Ballari",
		"Tumkur",
		"Shivamogga",
		"Raayachuru",
		"Robertson Pet",
		"Kolar",
		"Mandya",
		"Udupi",
		"Chikkamagaluru",
		"Karwar",
		"Ranebennuru",
		"Ranibennur",
		"Ramanagaram",
		"Gokak",
		"Yadgir",
		"Rabkavi Banhatti",
		"Shahabad",
		"Sirsi",
		"Sindhnur",
		"Tiptur",
		"Arsikere",
		"Nanjangud",
		"Sagara",
		"Sira",
		"Puttur",
		"Athni",
		"Mulbagal",
		"Surapura",
		"Siruguppa",
		"Mudhol",
		"Sidlaghatta",
		"Shahpur",
		"Saundatti-Yellamma",
		"Wadi",
		"Manvi",
		"Nelamangala",
		"Lakshmeshwar",
		"Ramdurg",
		"Nargund",
		"Tarikere",
		"Malavalli",
		"Savanur",
		"Lingsugur",
		"Vijayapura",
		"Sankeshwara",
		"Madikeri",
		"Talikota",
		"Sedam",
		"Shikaripur",
		"Mahalingapura",
		"Mudalagi",
		"Muddebihal",
		"Pavagada",
		"Malur",
		"Sindhagi",
		"Sanduru",
		"Afzalpur",
		"Maddur",
		"Madhugiri",
		"Tekkalakote",
		"Terdal",
		"Mudabidri",
		"Magadi",
		"Navalgund",
		"Shiggaon",
		"Shrirangapattana",
		"Sindagi",
		"Sakaleshapura",
		"Srinivaspur",
		"Ron",
		"Mundargi",
		"Sadalagi",
		"Piriyapatna",
		"Adyar"
	],
	"Karnatka": [
		"Mysore"
	],
	"Kerala": [
		"Thiruvananthapuram",
		"Kochi",
		"Kozhikode",
		"Kollam",
		"Thrissur",
		"Palakkad",
		"Alappuzha",
		"Malappuram",
		"Ponnani",
		"Vatakara",
		"Kanhangad",
		"Taliparamba",
		"Koyilandy",
		"Neyyattinkara",
		"Kayamkulam",
		"Nedumangad",
		"Kannur",
		"Tirur",
		"Kottayam",
		"Kasaragod",
		"Kunnamkulam",
		"Ottappalam",
		"Thiruvalla",
		"Thodupuzha",
		"Chalakudy",
		"Changanassery",
		"Punalur",
		"Nilambur",
		"Cherthala",
		"Perinthalmanna",
		"Mattannur",
		"Shoranur",
		"Varkala",
		"Paravoor",
		"Pathanamthitta",
		"Peringathur",
		"Attingal",
		"Kodungallur",
		"Pappinisseri",
		"Chittur-Thathamangalam",
		"Muvattupuzha",
		"Adoor",
		"Mavelikkara",
		"Mavoor",
		"Perumbavoor",
		"Vaikom",
		"Palai",
		"Panniyannur",
		"Guruvayoor",
		"Puthuppally",
		"Panamattom"
	],
	"Madhya Pradesh": [
		"Indore",
		"Bhopal",
		"Jabalpur",
		"Gwalior",
		"Ujjain",
		"Sagar",
		"Ratlam",
		"Satna",
		"Murwara (Katni)",
		"Morena",
		"Singrauli",
		"Rewa",
		"Vidisha",
		"Ganjbasoda",
		"Shivpuri",
		"Mandsaur",
		"Neemuch",
		"Nagda",
		"Itarsi",
		"Sarni",
		"Sehore",
		"Mhow Cantonment",
		"Seoni",
		"Balaghat",
		"Ashok Nagar",
		"Tikamgarh",
		"Shahdol",
		"Pithampur",
		"Alirajpur",
		"Mandla",
		"Sheopur",
		"Shajapur",
		"Panna",
		"Raghogarh-Vijaypur",
		"Sendhwa",
		"Sidhi",
		"Pipariya",
		"Shujalpur",
		"Sironj",
		"Pandhurna",
		"Nowgong",
		"Mandideep",
		"Sihora",
		"Raisen",
		"Lahar",
		"Maihar",
		"Sanawad",
		"Sabalgarh",
		"Umaria",
		"Porsa",
		"Narsinghgarh",
		"Malaj Khand",
		"Sarangpur",
		"Mundi",
		"Nepanagar",
		"Pasan",
		"Mahidpur",
		"Seoni-Malwa",
		"Rehli",
		"Manawar",
		"Rahatgarh",
		"Panagar",
		"Wara Seoni",
		"Tarana",
		"Sausar",
		"Rajgarh",
		"Niwari",
		"Mauganj",
		"Manasa",
		"Nainpur",
		"Prithvipur",
		"Sohagpur",
		"Nowrozabad (Khodargama)",
		"Shamgarh",
		"Maharajpur",
		"Multai",
		"Pali",
		"Pachore",
		"Rau",
		"Mhowgaon",
		"Vijaypur",
		"Narsinghgarh"
	],
	"Maharashtra": [
		"Mumbai",
		"Pune",
		"Nagpur",
		"Thane",
		"Nashik",
		"Kalyan-Dombivali",
		"Vasai-Virar",
		"Solapur",
		"Mira-Bhayandar",
		"Bhiwandi",
		"Amravati",
		"Nanded-Waghala",
		"Sangli",
		"Malegaon",
		"Akola",
		"Latur",
		"Dhule",
		"Ahmednagar",
		"Ichalkaranji",
		"Parbhani",
		"Panvel",
		"Yavatmal",
		"Achalpur",
		"Osmanabad",
		"Nandurbar",
		"Satara",
		"Wardha",
		"Udgir",
		"Aurangabad",
		"Amalner",
		"Akot",
		"Pandharpur",
		"Shrirampur",
		"Parli",
		"Washim",
		"Ambejogai",
		"Manmad",
		"Ratnagiri",
		"Uran Islampur",
		"Pusad",
		"Sangamner",
		"Shirpur-Warwade",
		"Malkapur",
		"Wani",
		"Lonavla",
		"Talegaon Dabhade",
		"Anjangaon",
		"Umred",
		"Palghar",
		"Shegaon",
		"Ozar",
		"Phaltan",
		"Yevla",
		"Shahade",
		"Vita",
		"Umarkhed",
		"Warora",
		"Pachora",
		"Tumsar",
		"Manjlegaon",
		"Sillod",
		"Arvi",
		"Nandura",
		"Vaijapur",
		"Wadgaon Road",
		"Sailu",
		"Murtijapur",
		"Tasgaon",
		"Mehkar",
		"Yawal",
		"Pulgaon",
		"Nilanga",
		"Wai",
		"Umarga",
		"Paithan",
		"Rahuri",
		"Nawapur",
		"Tuljapur",
		"Morshi",
		"Purna",
		"Satana",
		"Pathri",
		"Sinnar",
		"Uchgaon",
		"Uran",
		"Pen",
		"Karjat",
		"Manwath",
		"Partur",
		"Sangole",
		"Mangrulpir",
		"Risod",
		"Shirur",
		"Savner",
		"Sasvad",
		"Pandharkaoda",
		"Talode",
		"Shrigonda",
		"Shirdi",
		"Raver",
		"Mukhed",
		"Rajura",
		"Vadgaon Kasba",
		"Tirora",
		"Mahad",
		"Lonar",
		"Sawantwadi",
		"Pathardi",
		"Pauni",
		"Ramtek",
		"Mul",
		"Soyagaon",
		"Mangalvedhe",
		"Narkhed",
		"Shendurjana",
		"Patur",
		"Mhaswad",
		"Loha",
		"Nandgaon",
		"Warud"
	],
	"Manipur": [
		"Imphal",
		"Thoubal",
		"Lilong",
		"Mayang Imphal"
	],
	"Meghalaya": [
		"Shillong",
		"Tura",
		"Nongstoin"
	],
	"Mizoram": [
		"Aizawl",
		"Lunglei",
		"Saiha"
	],
	"Nagaland": [
		"Dimapur",
		"Kohima",
		"Zunheboto",
		"Tuensang",
		"Wokha",
		"Mokokchung"
	],
	"Odisha": [
		"Bhubaneswar",
		"Cuttack",
		"Raurkela",
		"Brahmapur",
		"Sambalpur",
		"Puri",
		"Baleshwar Town",
		"Baripada Town",
		"Bhadrak",
		"Balangir",
		"Jharsuguda",
		"Bargarh",
		"Paradip",
		"Bhawanipatna",
		"Dhenkanal",
		"Barbil",
		"Kendujhar",
		"Sunabeda",
		"Rayagada",
		"Jatani",
		"Byasanagar",
		"Kendrapara",
		"Rajagangapur",
		"Parlakhemundi",
		"Talcher",
		"Sundargarh",
		"Phulabani",
		"Pattamundai",
		"Titlagarh",
		"Nabarangapur",
		"Soro",
		"Malkangiri",
		"Rairangpur",
		"Tarbha"
	],
	"Puducherry": [
		"Pondicherry",
		"Karaikal",
		"Yanam",
		"Mahe"
	],
	"Punjab": [
		"Ludhiana",
		"Patiala",
		"Amritsar",
		"Jalandhar",
		"Bathinda",
		"Pathankot",
		"Hoshiarpur",
		"Batala",
		"Moga",
		"Malerkotla",
		"Khanna",
		"Mohali",
		"Barnala",
		"Firozpur",
		"Phagwara",
		"Kapurthala",
		"Zirakpur",
		"Kot Kapura",
		"Faridkot",
		"Muktsar",
		"Rajpura",
		"Sangrur",
		"Fazilka",
		"Gurdaspur",
		"Kharar",
		"Gobindgarh",
		"Mansa",
		"Malout",
		"Nabha",
		"Tarn Taran",
		"Jagraon",
		"Sunam",
		"Dhuri",
		"Firozpur Cantt.",
		"Sirhind Fatehgarh Sahib",
		"Rupnagar",
		"Jalandhar Cantt.",
		"Samana",
		"Nawanshahr",
		"Rampura Phul",
		"Nangal",
		"Nakodar",
		"Zira",
		"Patti",
		"Raikot",
		"Longowal",
		"Urmar Tanda",
		"Morinda, India",
		"Phillaur",
		"Pattran",
		"Qadian",
		"Sujanpur",
		"Mukerian",
		"Talwara"
	],
	"Rajasthan": [
		"Jaipur",
		"Jodhpur",
		"Bikaner",
		"Udaipur",
		"Ajmer",
		"Bhilwara",
		"Alwar",
		"Bharatpur",
		"Pali",
		"Barmer",
		"Sikar",
		"Tonk",
		"Sadulpur",
		"Sawai Madhopur",
		"Nagaur",
		"Makrana",
		"Sujangarh",
		"Sardarshahar",
		"Ladnu",
		"Ratangarh",
		"Nokha",
		"Nimbahera",
		"Suratgarh",
		"Rajsamand",
		"Lachhmangarh",
		"Rajgarh (Churu)",
		"Nasirabad",
		"Nohar",
		"Phalodi",
		"Nathdwara",
		"Pilani",
		"Merta City",
		"Sojat",
		"Neem-Ka-Thana",
		"Sirohi",
		"Pratapgarh",
		"Rawatbhata",
		"Sangaria",
		"Lalsot",
		"Pilibanga",
		"Pipar City",
		"Taranagar",
		"Vijainagar, Ajmer",
		"Sumerpur",
		"Sagwara",
		"Ramganj Mandi",
		"Lakheri",
		"Udaipurwati",
		"Losal",
		"Sri Madhopur",
		"Ramngarh",
		"Rawatsar",
		"Rajakhera",
		"Shahpura",
		"Shahpura",
		"Raisinghnagar",
		"Malpura",
		"Nadbai",
		"Sanchore",
		"Nagar",
		"Rajgarh (Alwar)",
		"Sheoganj",
		"Sadri",
		"Todaraisingh",
		"Todabhim",
		"Reengus",
		"Rajaldesar",
		"Sadulshahar",
		"Sambhar",
		"Prantij",
		"Mount Abu",
		"Mangrol",
		"Phulera",
		"Mandawa",
		"Pindwara",
		"Mandalgarh",
		"Takhatgarh"
	],
	"Tamil Nadu": [
		"Chennai",
		"Coimbatore",
		"Madurai",
		"Tiruchirappalli",
		"Salem",
		"Tirunelveli",
		"Tiruppur",
		"Ranipet",
		"Nagercoil",
		"Thanjavur",
		"Vellore",
		"Kancheepuram",
		"Erode",
		"Tiruvannamalai",
		"Pollachi",
		"Rajapalayam",
		"Sivakasi",
		"Pudukkottai",
		"Neyveli (TS)",
		"Nagapattinam",
		"Viluppuram",
		"Tiruchengode",
		"Vaniyambadi",
		"Theni Allinagaram",
		"Udhagamandalam",
		"Aruppukkottai",
		"Paramakudi",
		"Arakkonam",
		"Virudhachalam",
		"Srivilliputhur",
		"Tindivanam",
		"Virudhunagar",
		"Karur",
		"Valparai",
		"Sankarankovil",
		"Tenkasi",
		"Palani",
		"Pattukkottai",
		"Tirupathur",
		"Ramanathapuram",
		"Udumalaipettai",
		"Gobichettipalayam",
		"Thiruvarur",
		"Thiruvallur",
		"Panruti",
		"Namakkal",
		"Thirumangalam",
		"Vikramasingapuram",
		"Nellikuppam",
		"Rasipuram",
		"Tiruttani",
		"Nandivaram-Guduvancheri",
		"Periyakulam",
		"Pernampattu",
		"Vellakoil",
		"Sivaganga",
		"Vadalur",
		"Rameshwaram",
		"Tiruvethipuram",
		"Perambalur",
		"Usilampatti",
		"Vedaranyam",
		"Sathyamangalam",
		"Puliyankudi",
		"Nanjikottai",
		"Thuraiyur",
		"Sirkali",
		"Tiruchendur",
		"Periyasemur",
		"Sattur",
		"Vandavasi",
		"Tharamangalam",
		"Tirukkoyilur",
		"Oddanchatram",
		"Palladam",
		"Vadakkuvalliyur",
		"Tirukalukundram",
		"Uthamapalayam",
		"Surandai",
		"Sankari",
		"Shenkottai",
		"Vadipatti",
		"Sholingur",
		"Tirupathur",
		"Manachanallur",
		"Viswanatham",
		"Polur",
		"Panagudi",
		"Uthiramerur",
		"Thiruthuraipoondi",
		"Pallapatti",
		"Ponneri",
		"Lalgudi",
		"Natham",
		"Unnamalaikadai",
		"P.N.Patti",
		"Tharangambadi",
		"Tittakudi",
		"Pacode",
		"O' Valley",
		"Suriyampalayam",
		"Sholavandan",
		"Thammampatti",
		"Namagiripettai",
		"Peravurani",
		"Parangipettai",
		"Pudupattinam",
		"Pallikonda",
		"Sivagiri",
		"Punjaipugalur",
		"Padmanabhapuram",
		"Thirupuvanam"
	],
	"Telangana": [
		"Hyderabad",
		"Warangal",
		"Nizamabad",
		"Karimnagar",
		"Ramagundam",
		"Khammam",
		"Mahbubnagar",
		"Mancherial",
		"Adilabad",
		"Suryapet",
		"Jagtial",
		"Miryalaguda",
		"Nirmal",
		"Kamareddy",
		"Kothagudem",
		"Bodhan",
		"Palwancha",
		"Mandamarri",
		"Koratla",
		"Sircilla",
		"Tandur",
		"Siddipet",
		"Wanaparthy",
		"Kagaznagar",
		"Gadwal",
		"Sangareddy",
		"Bellampalle",
		"Bhongir",
		"Vikarabad",
		"Jangaon",
		"Bhadrachalam",
		"Bhainsa",
		"Farooqnagar",
		"Medak",
		"Narayanpet",
		"Sadasivpet",
		"Yellandu",
		"Manuguru",
		"Kyathampalle",
		"Nagarkurnool"
	],
	"Tripura": [
		"Agartala",
		"Udaipur",
		"Dharmanagar",
		"Pratapgarh",
		"Kailasahar",
		"Belonia",
		"Khowai"
	],
	"Uttar Pradesh": [
		"Lucknow",
		"Kanpur",
		"Firozabad",
		"Agra",
		"Meerut",
		"Varanasi",
		"Allahabad",
		"Amroha",
		"Moradabad",
		"Aligarh",
		"Saharanpur",
		"Noida",
		"Loni",
		"Jhansi",
		"Shahjahanpur",
		"Rampur",
		"Modinagar",
		"Hapur",
		"Etawah",
		"Sambhal",
		"Orai",
		"Bahraich",
		"Unnao",
		"Rae Bareli",
		"Lakhimpur",
		"Sitapur",
		"Lalitpur",
		"Pilibhit",
		"Chandausi",
		"Hardoi ",
		"Azamgarh",
		"Khair",
		"Sultanpur",
		"Tanda",
		"Nagina",
		"Shamli",
		"Najibabad",
		"Shikohabad",
		"Sikandrabad",
		"Shahabad, Hardoi",
		"Pilkhuwa",
		"Renukoot",
		"Vrindavan",
		"Ujhani",
		"Laharpur",
		"Tilhar",
		"Sahaswan",
		"Rath",
		"Sherkot",
		"Kalpi",
		"Tundla",
		"Sandila",
		"Nanpara",
		"Sardhana",
		"Nehtaur",
		"Seohara",
		"Padrauna",
		"Mathura",
		"Thakurdwara",
		"Nawabganj",
		"Siana",
		"Noorpur",
		"Sikandra Rao",
		"Puranpur",
		"Rudauli",
		"Thana Bhawan",
		"Palia Kalan",
		"Zaidpur",
		"Nautanwa",
		"Zamania",
		"Shikarpur, Bulandshahr",
		"Naugawan Sadat",
		"Fatehpur Sikri",
		"Shahabad, Rampur",
		"Robertsganj",
		"Utraula",
		"Sadabad",
		"Rasra",
		"Lar",
		"Lal Gopalganj Nindaura",
		"Sirsaganj",
		"Pihani",
		"Shamsabad, Agra",
		"Rudrapur",
		"Soron",
		"SUrban Agglomerationr",
		"Samdhan",
		"Sahjanwa",
		"Rampur Maniharan",
		"Sumerpur",
		"Shahganj",
		"Tulsipur",
		"Tirwaganj",
		"PurqUrban Agglomerationzi",
		"Shamsabad, Farrukhabad",
		"Warhapur",
		"Powayan",
		"Sandi",
		"Achhnera",
		"Naraura",
		"Nakur",
		"Sahaspur",
		"Safipur",
		"Reoti",
		"Sikanderpur",
		"Saidpur",
		"Sirsi",
		"Purwa",
		"Parasi",
		"Lalganj",
		"Phulpur",
		"Shishgarh",
		"Sahawar",
		"Samthar",
		"Pukhrayan",
		"Obra",
		"Niwai"
	],
	"Uttarakhand": [
		"Dehradun",
		"Hardwar",
		"Haldwani-cum-Kathgodam",
		"Srinagar",
		"Kashipur",
		"Roorkee",
		"Rudrapur",
		"Rishikesh",
		"Ramnagar",
		"Pithoragarh",
		"Manglaur",
		"Nainital",
		"Mussoorie",
		"Tehri",
		"Pauri",
		"Nagla",
		"Sitarganj",
		"Bageshwar"
	],
	"West Bengal": [
		"Kolkata",
		"Siliguri",
		"Asansol",
		"Raghunathganj",
		"Kharagpur",
		"Naihati",
		"English Bazar",
		"Baharampur",
		"Hugli-Chinsurah",
		"Raiganj",
		"Jalpaiguri",
		"Santipur",
		"Balurghat",
		"Medinipur",
		"Habra",
		"Ranaghat",
		"Bankura",
		"Nabadwip",
		"Darjiling",
		"Purulia",
		"Arambagh",
		"Tamluk",
		"AlipurdUrban Agglomerationr",
		"Suri",
		"Jhargram",
		"Gangarampur",
		"Rampurhat",
		"Kalimpong",
		"Sainthia",
		"Taki",
		"Murshidabad",
		"Memari",
		"Paschim Punropara",
		"Tarakeswar",
		"Sonamukhi",
		"PandUrban Agglomeration",
		"Mainaguri",
		"Malda",
		"Panchla",
		"Raghunathpur",
		"Mathabhanga",
		"Monoharpur",
		"Srirampore",
		"Adra"
	]
}
/*
 A JavaScript implementation of the SHA family of hashes, as
 defined in FIPS PUB 180-2 as well as the corresponding HMAC implementation
 as defined in FIPS PUB 198a

 Copyright Brian Turek 2008-2015
 Distributed under the BSD License
 See http://caligatio.github.com/jsSHA/ for more information

 Several functions taken from Paul Johnston
*/
'use strict';(function(U){function z(a,b,c){var e=0,f=[0],k="",h=null,k=c||"UTF8";if("UTF8"!==k&&"UTF16BE"!==k&&"UTF16LE"!==k)throw"encoding must be UTF8, UTF16BE, or UTF16LE";if("HEX"===b){if(0!==a.length%2)throw"srcString of HEX type must be in byte increments";h=D(a);e=h.binLen;f=h.value}else if("TEXT"===b||"ASCII"===b)h=L(a,k),e=h.binLen,f=h.value;else if("B64"===b)h=M(a),e=h.binLen,f=h.value;else if("BYTES"===b)h=N(a),e=h.binLen,f=h.value;else throw"inputFormat must be HEX, TEXT, ASCII, B64, or BYTES";
this.getHash=function(a,b,c,k){var h=null,d=f.slice(),n=e,m;3===arguments.length?"number"!==typeof c&&(k=c,c=1):2===arguments.length&&(c=1);if(c!==parseInt(c,10)||1>c)throw"numRounds must a integer >= 1";switch(b){case "HEX":h=O;break;case "B64":h=P;break;case "BYTES":h=Q;break;default:throw"format must be HEX, B64, or BYTES";}if("SHA-1"===a)for(m=0;m<c;m+=1)d=A(d,n),n=160;else if("SHA-224"===a)for(m=0;m<c;m+=1)d=w(d,n,a),n=224;else if("SHA-256"===a)for(m=0;m<c;m+=1)d=w(d,n,a),n=256;else if("SHA-384"===
a)for(m=0;m<c;m+=1)d=w(d,n,a),n=384;else if("SHA-512"===a)for(m=0;m<c;m+=1)d=w(d,n,a),n=512;else throw"Chosen SHA variant is not supported";return h(d,R(k))};this.getHMAC=function(a,b,c,h,q){var d,n,m,t,r=[],u=[];d=null;switch(h){case "HEX":h=O;break;case "B64":h=P;break;case "BYTES":h=Q;break;default:throw"outputFormat must be HEX, B64, or BYTES";}if("SHA-1"===c)n=64,t=160;else if("SHA-224"===c)n=64,t=224;else if("SHA-256"===c)n=64,t=256;else if("SHA-384"===c)n=128,t=384;else if("SHA-512"===c)n=
128,t=512;else throw"Chosen SHA variant is not supported";if("HEX"===b)d=D(a),m=d.binLen,d=d.value;else if("TEXT"===b||"ASCII"===b)d=L(a,k),m=d.binLen,d=d.value;else if("B64"===b)d=M(a),m=d.binLen,d=d.value;else if("BYTES"===b)d=N(a),m=d.binLen,d=d.value;else throw"inputFormat must be HEX, TEXT, ASCII, B64, or BYTES";a=8*n;b=n/4-1;if(n<m/8){for(d="SHA-1"===c?A(d,m):w(d,m,c);d.length<=b;)d.push(0);d[b]&=4294967040}else if(n>m/8){for(;d.length<=b;)d.push(0);d[b]&=4294967040}for(n=0;n<=b;n+=1)r[n]=d[n]^
909522486,u[n]=d[n]^1549556828;c="SHA-1"===c?A(u.concat(A(r.concat(f),a+e)),a+t):w(u.concat(w(r.concat(f),a+e,c)),a+t,c);return h(c,R(q))}}function q(a,b){this.a=a;this.b=b}function L(a,b){var c=[],e,f=[],k=0,h,p,q;if("UTF8"===b)for(h=0;h<a.length;h+=1)for(e=a.charCodeAt(h),f=[],128>e?f.push(e):2048>e?(f.push(192|e>>>6),f.push(128|e&63)):55296>e||57344<=e?f.push(224|e>>>12,128|e>>>6&63,128|e&63):(h+=1,e=65536+((e&1023)<<10|a.charCodeAt(h)&1023),f.push(240|e>>>18,128|e>>>12&63,128|e>>>6&63,128|e&63)),
p=0;p<f.length;p+=1){for(q=k>>>2;c.length<=q;)c.push(0);c[q]|=f[p]<<24-k%4*8;k+=1}else if("UTF16BE"===b||"UTF16LE"===b)for(h=0;h<a.length;h+=1){e=a.charCodeAt(h);"UTF16LE"===b&&(p=e&255,e=p<<8|e>>8);for(q=k>>>2;c.length<=q;)c.push(0);c[q]|=e<<16-k%4*8;k+=2}return{value:c,binLen:8*k}}function D(a){var b=[],c=a.length,e,f,k;if(0!==c%2)throw"String of HEX type must be in byte increments";for(e=0;e<c;e+=2){f=parseInt(a.substr(e,2),16);if(isNaN(f))throw"String of HEX type contains invalid characters";
for(k=e>>>3;b.length<=k;)b.push(0);b[e>>>3]|=f<<24-e%8*4}return{value:b,binLen:4*c}}function N(a){var b=[],c,e,f;for(e=0;e<a.length;e+=1)c=a.charCodeAt(e),f=e>>>2,b.length<=f&&b.push(0),b[f]|=c<<24-e%4*8;return{value:b,binLen:8*a.length}}function M(a){var b=[],c=0,e,f,k,h,p;if(-1===a.search(/^[a-zA-Z0-9=+\/]+$/))throw"Invalid character in base-64 string";f=a.indexOf("=");a=a.replace(/\=/g,"");if(-1!==f&&f<a.length)throw"Invalid '=' found in base-64 string";for(f=0;f<a.length;f+=4){p=a.substr(f,4);
for(k=h=0;k<p.length;k+=1)e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".indexOf(p[k]),h|=e<<18-6*k;for(k=0;k<p.length-1;k+=1){for(e=c>>>2;b.length<=e;)b.push(0);b[e]|=(h>>>16-8*k&255)<<24-c%4*8;c+=1}}return{value:b,binLen:8*c}}function O(a,b){var c="",e=4*a.length,f,k;for(f=0;f<e;f+=1)k=a[f>>>2]>>>8*(3-f%4),c+="0123456789abcdef".charAt(k>>>4&15)+"0123456789abcdef".charAt(k&15);return b.outputUpper?c.toUpperCase():c}function P(a,b){var c="",e=4*a.length,f,k,h;for(f=0;f<e;f+=
3)for(h=f+1>>>2,k=a.length<=h?0:a[h],h=f+2>>>2,h=a.length<=h?0:a[h],h=(a[f>>>2]>>>8*(3-f%4)&255)<<16|(k>>>8*(3-(f+1)%4)&255)<<8|h>>>8*(3-(f+2)%4)&255,k=0;4>k;k+=1)c=8*f+6*k<=32*a.length?c+"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(h>>>6*(3-k)&63):c+b.b64Pad;return c}function Q(a){var b="",c=4*a.length,e,f;for(e=0;e<c;e+=1)f=a[e>>>2]>>>8*(3-e%4)&255,b+=String.fromCharCode(f);return b}function R(a){var b={outputUpper:!1,b64Pad:"="};try{a.hasOwnProperty("outputUpper")&&
(b.outputUpper=a.outputUpper),a.hasOwnProperty("b64Pad")&&(b.b64Pad=a.b64Pad)}catch(c){}if("boolean"!==typeof b.outputUpper)throw"Invalid outputUpper formatting option";if("string"!==typeof b.b64Pad)throw"Invalid b64Pad formatting option";return b}function x(a,b){return a<<b|a>>>32-b}function r(a,b){return a>>>b|a<<32-b}function u(a,b){var c=null,c=new q(a.a,a.b);return c=32>=b?new q(c.a>>>b|c.b<<32-b&4294967295,c.b>>>b|c.a<<32-b&4294967295):new q(c.b>>>b-32|c.a<<64-b&4294967295,c.a>>>b-32|c.b<<64-
b&4294967295)}function S(a,b){var c=null;return c=32>=b?new q(a.a>>>b,a.b>>>b|a.a<<32-b&4294967295):new q(0,a.a>>>b-32)}function V(a,b,c){return a&b^~a&c}function W(a,b,c){return new q(a.a&b.a^~a.a&c.a,a.b&b.b^~a.b&c.b)}function T(a,b,c){return a&b^a&c^b&c}function X(a,b,c){return new q(a.a&b.a^a.a&c.a^b.a&c.a,a.b&b.b^a.b&c.b^b.b&c.b)}function Y(a){return r(a,2)^r(a,13)^r(a,22)}function Z(a){var b=u(a,28),c=u(a,34);a=u(a,39);return new q(b.a^c.a^a.a,b.b^c.b^a.b)}function $(a){return r(a,6)^r(a,11)^
r(a,25)}function aa(a){var b=u(a,14),c=u(a,18);a=u(a,41);return new q(b.a^c.a^a.a,b.b^c.b^a.b)}function ba(a){return r(a,7)^r(a,18)^a>>>3}function ca(a){var b=u(a,1),c=u(a,8);a=S(a,7);return new q(b.a^c.a^a.a,b.b^c.b^a.b)}function da(a){return r(a,17)^r(a,19)^a>>>10}function ea(a){var b=u(a,19),c=u(a,61);a=S(a,6);return new q(b.a^c.a^a.a,b.b^c.b^a.b)}function C(a,b){var c=(a&65535)+(b&65535);return((a>>>16)+(b>>>16)+(c>>>16)&65535)<<16|c&65535}function fa(a,b,c,e){var f=(a&65535)+(b&65535)+(c&65535)+
(e&65535);return((a>>>16)+(b>>>16)+(c>>>16)+(e>>>16)+(f>>>16)&65535)<<16|f&65535}function E(a,b,c,e,f){var k=(a&65535)+(b&65535)+(c&65535)+(e&65535)+(f&65535);return((a>>>16)+(b>>>16)+(c>>>16)+(e>>>16)+(f>>>16)+(k>>>16)&65535)<<16|k&65535}function ga(a,b){var c,e,f;c=(a.b&65535)+(b.b&65535);e=(a.b>>>16)+(b.b>>>16)+(c>>>16);f=(e&65535)<<16|c&65535;c=(a.a&65535)+(b.a&65535)+(e>>>16);e=(a.a>>>16)+(b.a>>>16)+(c>>>16);return new q((e&65535)<<16|c&65535,f)}function ha(a,b,c,e){var f,k,h;f=(a.b&65535)+(b.b&
65535)+(c.b&65535)+(e.b&65535);k=(a.b>>>16)+(b.b>>>16)+(c.b>>>16)+(e.b>>>16)+(f>>>16);h=(k&65535)<<16|f&65535;f=(a.a&65535)+(b.a&65535)+(c.a&65535)+(e.a&65535)+(k>>>16);k=(a.a>>>16)+(b.a>>>16)+(c.a>>>16)+(e.a>>>16)+(f>>>16);return new q((k&65535)<<16|f&65535,h)}function ia(a,b,c,e,f){var k,h,p;k=(a.b&65535)+(b.b&65535)+(c.b&65535)+(e.b&65535)+(f.b&65535);h=(a.b>>>16)+(b.b>>>16)+(c.b>>>16)+(e.b>>>16)+(f.b>>>16)+(k>>>16);p=(h&65535)<<16|k&65535;k=(a.a&65535)+(b.a&65535)+(c.a&65535)+(e.a&65535)+(f.a&
65535)+(h>>>16);h=(a.a>>>16)+(b.a>>>16)+(c.a>>>16)+(e.a>>>16)+(f.a>>>16)+(k>>>16);return new q((h&65535)<<16|k&65535,p)}function A(a,b){var c=[],e,f,k,h,p,q,r,s,u,d=[1732584193,4023233417,2562383102,271733878,3285377520];for(e=(b+65>>>9<<4)+15;a.length<=e;)a.push(0);a[b>>>5]|=128<<24-b%32;a[e]=b;u=a.length;for(r=0;r<u;r+=16){e=d[0];f=d[1];k=d[2];h=d[3];p=d[4];for(s=0;80>s;s+=1)c[s]=16>s?a[s+r]:x(c[s-3]^c[s-8]^c[s-14]^c[s-16],1),q=20>s?E(x(e,5),f&k^~f&h,p,1518500249,c[s]):40>s?E(x(e,5),f^k^h,p,1859775393,
c[s]):60>s?E(x(e,5),T(f,k,h),p,2400959708,c[s]):E(x(e,5),f^k^h,p,3395469782,c[s]),p=h,h=k,k=x(f,30),f=e,e=q;d[0]=C(e,d[0]);d[1]=C(f,d[1]);d[2]=C(k,d[2]);d[3]=C(h,d[3]);d[4]=C(p,d[4])}return d}function w(a,b,c){var e,f,k,h,p,r,u,s,y,d,n,m,t,w,x,v,z,A,F,G,H,I,J,K,g,B=[],D,l=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,
1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];d=[3238371032,914150663,812702999,4144912697,4290775857,
1750603025,1694076839,3204075428];f=[1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225];if("SHA-224"===c||"SHA-256"===c)n=64,e=(b+65>>>9<<4)+15,w=16,x=1,g=Number,v=C,z=fa,A=E,F=ba,G=da,H=Y,I=$,K=T,J=V,d="SHA-224"===c?d:f;else if("SHA-384"===c||"SHA-512"===c)n=80,e=(b+128>>>10<<5)+31,w=32,x=2,g=q,v=ga,z=ha,A=ia,F=ca,G=ea,H=Z,I=aa,K=X,J=W,l=[new g(l[0],3609767458),new g(l[1],602891725),new g(l[2],3964484399),new g(l[3],2173295548),new g(l[4],4081628472),new g(l[5],
3053834265),new g(l[6],2937671579),new g(l[7],3664609560),new g(l[8],2734883394),new g(l[9],1164996542),new g(l[10],1323610764),new g(l[11],3590304994),new g(l[12],4068182383),new g(l[13],991336113),new g(l[14],633803317),new g(l[15],3479774868),new g(l[16],2666613458),new g(l[17],944711139),new g(l[18],2341262773),new g(l[19],2007800933),new g(l[20],1495990901),new g(l[21],1856431235),new g(l[22],3175218132),new g(l[23],2198950837),new g(l[24],3999719339),new g(l[25],766784016),new g(l[26],2566594879),
new g(l[27],3203337956),new g(l[28],1034457026),new g(l[29],2466948901),new g(l[30],3758326383),new g(l[31],168717936),new g(l[32],1188179964),new g(l[33],1546045734),new g(l[34],1522805485),new g(l[35],2643833823),new g(l[36],2343527390),new g(l[37],1014477480),new g(l[38],1206759142),new g(l[39],344077627),new g(l[40],1290863460),new g(l[41],3158454273),new g(l[42],3505952657),new g(l[43],106217008),new g(l[44],3606008344),new g(l[45],1432725776),new g(l[46],1467031594),new g(l[47],851169720),new g(l[48],
3100823752),new g(l[49],1363258195),new g(l[50],3750685593),new g(l[51],3785050280),new g(l[52],3318307427),new g(l[53],3812723403),new g(l[54],2003034995),new g(l[55],3602036899),new g(l[56],1575990012),new g(l[57],1125592928),new g(l[58],2716904306),new g(l[59],442776044),new g(l[60],593698344),new g(l[61],3733110249),new g(l[62],2999351573),new g(l[63],3815920427),new g(3391569614,3928383900),new g(3515267271,566280711),new g(3940187606,3454069534),new g(4118630271,4000239992),new g(116418474,
1914138554),new g(174292421,2731055270),new g(289380356,3203993006),new g(460393269,320620315),new g(685471733,587496836),new g(852142971,1086792851),new g(1017036298,365543100),new g(1126000580,2618297676),new g(1288033470,3409855158),new g(1501505948,4234509866),new g(1607167915,987167468),new g(1816402316,1246189591)],d="SHA-384"===c?[new g(3418070365,d[0]),new g(1654270250,d[1]),new g(2438529370,d[2]),new g(355462360,d[3]),new g(1731405415,d[4]),new g(41048885895,d[5]),new g(3675008525,d[6]),
new g(1203062813,d[7])]:[new g(f[0],4089235720),new g(f[1],2227873595),new g(f[2],4271175723),new g(f[3],1595750129),new g(f[4],2917565137),new g(f[5],725511199),new g(f[6],4215389547),new g(f[7],327033209)];else throw"Unexpected error in SHA-2 implementation";for(;a.length<=e;)a.push(0);a[b>>>5]|=128<<24-b%32;a[e]=b;D=a.length;for(m=0;m<D;m+=w){b=d[0];e=d[1];f=d[2];k=d[3];h=d[4];p=d[5];r=d[6];u=d[7];for(t=0;t<n;t+=1)16>t?(y=t*x+m,s=a.length<=y?0:a[y],y=a.length<=y+1?0:a[y+1],B[t]=new g(s,y)):B[t]=
z(G(B[t-2]),B[t-7],F(B[t-15]),B[t-16]),s=A(u,I(h),J(h,p,r),l[t],B[t]),y=v(H(b),K(b,e,f)),u=r,r=p,p=h,h=v(k,s),k=f,f=e,e=b,b=v(s,y);d[0]=v(b,d[0]);d[1]=v(e,d[1]);d[2]=v(f,d[2]);d[3]=v(k,d[3]);d[4]=v(h,d[4]);d[5]=v(p,d[5]);d[6]=v(r,d[6]);d[7]=v(u,d[7])}if("SHA-224"===c)a=[d[0],d[1],d[2],d[3],d[4],d[5],d[6]];else if("SHA-256"===c)a=d;else if("SHA-384"===c)a=[d[0].a,d[0].b,d[1].a,d[1].b,d[2].a,d[2].b,d[3].a,d[3].b,d[4].a,d[4].b,d[5].a,d[5].b];else if("SHA-512"===c)a=[d[0].a,d[0].b,d[1].a,d[1].b,d[2].a,
d[2].b,d[3].a,d[3].b,d[4].a,d[4].b,d[5].a,d[5].b,d[6].a,d[6].b,d[7].a,d[7].b];else throw"Unexpected error in SHA-2 implementation";return a}"function"===typeof define&&define.amd?define(function(){return z}):"undefined"!==typeof exports?"undefined"!==typeof module&&module.exports?module.exports=exports=z:exports=z:U.jsSHA=z})(this);

angular.module('app')
    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $facebookProvider, $mdGestureProvider) {

        // Turn off caching for demo simplicity's sake
        // $ionicConfigProvider.views.maxCache(0);

        /*
        // Turn off back button text
        $ionicConfigProvider.backButton.previousTitleText(false);
        */

        $stateProvider.state('app', {
            url: '/app',
            abstract: true,
            templateUrl: 'app/core/menu/menu.html',
            controller: 'AppCtrl'
        });

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/login');

        $facebookProvider.setAppId('1795720764051075');

        $mdGestureProvider.skipClickHijack();

        $facebookProvider.setPermissions("email, public_profile, user_friends,user_birthday,user_education_history,user_work_history,read_custom_friendlists,user_location");
        
    });

angular.module('app')
    .constant('DB_CONFIG', {
        "tables": [
            "CREATE TABLE IF NOT EXISTS AppConfig(user TEXT(36) , password TEXT, description TEXT, logintype TEXT, configtype TEXT)"
        ]
    })
    .constant('AppParam', {
        'app.APPID': "Zeenka",
        'app.DBName': "Zeenka",
        'app.Version': "0.0.80",
        'app.isBeta': "y"
    })
    .constant('RefData', {
        'HereFor': {
            "F": "Making Friends",
            "D": "Dating",
            "C": "Chatting",
            "M": "Marriage"
        },
        'Smoking': {
            "Y": "Yes",
            "N": "No",
            "O": "Occasionally"
        },
        'Drinking': {
            "Y": "Yes",
            "N": "No",
            "O": "Occasionally"
        },
        'Diet': {
            "V": "Veg",
            "N": "Non Veg",
            "O": "Occas Non Veg",
            "E": "Eggitarian",
            "J": "Jain"
        },
        'Bodytype': {
            "A": "Average",
            "S": "Slim",
            "T": "Athletic",
            "H": "Heavy"
        },
        'Employment': {
            "B": "Business",
            "P": "Professional",
            "E": "Employed",
            "S": "Self Employed"
        },
        'Status': {
            "S": "Single",
            "M": "Married",
            "D": "Divorced",
            "A": "Avaiting Divorce",
            "W": "Widowed"
        },
        'Horoscope': {
            "B": "Believe",
            "N": "Not Believe"
        },
        'Language': {
            'English': 'English',
            'Hindi': 'Hindi',
            'Gujarati': 'Gujarati',
            'Sanskrit': 'Sanskrit',
            'Punjabi': 'Punjabi',
            'Bengali': 'Bengali',
            'Assamese': 'Assamese',
            'Dogri': 'Dogri',
            'Oriya': 'Oriya',
            'Marathi': 'Marathi',
            'Kannada': 'Kannada',
            'Tamil': 'Tamil',
            'Telugu': 'Telugu',
            'Malayalam': 'Malayalam',
            'Sindhi': 'Sindhi',
            'Konkani': 'Konkani',
            'Manipuri': 'Manipuri',
            'Khasi': 'Khasi',
            'Mizo': 'Mizo',
            'Urdu': 'Urdu',
        },
        'Education': {
            'S': 'Secondary',
            'H': 'Higher Secondary',
            'G': 'Graduation',
            'P': 'Post Graduation',
            'D': 'Diploma'
        },
        'Height': {
            '<4': 'Less Then 4',
            '4.0"': '4.0"',
            '4.2"': '4.2"',
            '4.4"': '4.4"',
            '4.6"': '4.6"',
            '4.8"': '4.8"',
            '5.0"': '5.0"',
            '5.2"': '5.2"',
            '5.4"': '5.4"',
            '5.6"': '5.6"',
            '5.8"': '5.8"',
            '6.0"': '6.0"',
            '6.2"': '6.2"',
            '6.4"': '6.4"',
            '6.6"': '6.6"',
            '6.8"': '6.8"',
            '7.0"': '7.0"',
            '>7': 'More Then 7',
        }
    })
    .constant('SysConfig', [{
        "ad_sysconfig_uu": "1",
        "name": "app.AppServerWSURL",
        "description": "app.AppServerWSURL",
        "value": "",
        "datatype": "text",
        "configtype": "AC"
    }, {
        "ad_sysconfig_uu": "2",
        "name": "app.GCMServerID",
        "description": "app.GCMServerID",
        "value": "917927060055",
        "datatype": "text",
        "configtype": "AC"
    }, {
        "ad_sysconfig_uu": "3",
        "name": "app.AppServerUrl",
        "description": "app.AppServerUrl",
        "value": "admin.zeenka.com",
        "datatype": "text",
        "configtype": "AU"
    }, {
        "ad_sysconfig_uu": "4",
        "name": "app.AppServerPort",
        "description": "app.AppServerPort",
        "value": "8889",
        "datatype": "number",
        "configtype": "AU"
    }, {
        "ad_sysconfig_uu": "5",
        "name": "app.locationpush.interval",
        "description": "app.locationpush.interval",
        //"value": "8086",
        "value": "50000",
        "datatype": "number",
        "configtype": "AU"
    }])
    .constant("WebPages", {
        "term_condition": "http://www.zeenka.com/terms-of-use",
        "privacy_security": "http://www.zeenka.com/privacy-policy",
        "feedback": "https://en.wikipedia.org/wiki/Wikipedia:Requests_for_feedback",
        "help_center": "https://en.wikipedia.org/wiki/Wikipedia:Help_desk"
    })
    .constant("ZMessages", {
        "P_TITLE": "Please upload at least one photo with your face clearly visible. It is mandatory requirement.",
        "P_MSG": "Profiles with photos get more hits and have more chances of successful matches. So let's start with your photo"
    });
